//@ui5-bundle sap/ui/integration/library-h2-preload.js
/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.predefine('sap/ui/integration/library',["sap/ui/base/DataType","sap/ui/Global","sap/ui/core/library","sap/m/library","sap/f/library"],function(D){"use strict";sap.ui.getCore().initLibrary({name:"sap.ui.integration",version:"1.98.0",dependencies:["sap.ui.core","sap.f","sap.m"],types:["sap.ui.integration.CardActionType","sap.ui.integration.CardDataMode","sap.ui.integration.CardMenuAction"],controls:["sap.ui.integration.widgets.Card","sap.ui.integration.cards.filters.FilterBar","sap.ui.integration.cards.Header","sap.ui.integration.cards.NumericHeader","sap.ui.integration.controls.ListContentItem"],elements:["sap.ui.integration.ActionDefinition","sap.ui.integration.Host"],customElements:{"card":"sap/ui/integration/customElements/CustomElementCard"}});var t=sap.ui.integration;t.CardActionType={Navigation:"Navigation",Submit:"Submit",Custom:"Custom",DateChange:"DateChange",MonthChange:"MonthChange"};t.CardDataMode={Active:"Active",Inactive:"Inactive",Auto:"Auto"};t.CardActionArea={None:"None",Content:"Content",ContentItem:"ContentItem",ActionsStrip:"ActionsStrip",ContentItemDetail:"ContentItemDetail",Header:"Header"};t.CardArea={Header:"Header",Filters:"Filters",Content:"Content"};t.AttributesLayoutType={OneColumn:"OneColumn",TwoColumns:"TwoColumns"};t.CardMenuAction=D.createType("sap.ui.integration.CardMenuAction",{isValid:function(v){var p=["type","text","icon","tooltip","buttonType","enabled","visible","action","parameters","target","url"];return Object.keys(v).every(function(k){return p.indexOf(k)!==-1;});}},"object");return t;});
sap.ui.require.preload({
	"sap/ui/integration/manifest.json":'{"_version":"1.21.0","sap.app":{"id":"sap.ui.integration","type":"library","embeds":[],"applicationVersion":{"version":"1.98.0"},"title":"SAPUI5 library with integration-related controls.","description":"SAPUI5 library with integration-related controls.","ach":"CA-UI5-CTR","resources":"resources.json","offline":true,"openSourceComponents":[{"name":"ui5-web-components","packagedWithMySelf":true,"version":"1.0.1"},{"name":"adaptive-cards","packagedWithMySelf":true,"version":"2.9.0"},{"name":"adaptive-cards-templating","packagedWithMySelf":true,"version":"2.2.0"},{"name":"adaptive-expressions","packagedWithMySelf":true,"version":"4.15.0"},{"name":"markdown-it","packagedWithMySelf":true,"version":"12.2.0"},{"name":"@cfworker/json-schema","packagedWithMySelf":true,"version":"1.6.8"}]},"sap.ui":{"technology":"UI5","supportedThemes":["base","sap_hcb"]},"sap.ui5":{"dependencies":{"minUI5Version":"1.98","libs":{"sap.ui.core":{"minVersion":"1.98.0"},"sap.f":{"minVersion":"1.98.0"}}},"library":{"i18n":{"bundleUrl":"messagebundle.properties","supportedLocales":["","ar","bg","ca","cs","cy","da","de","el","en","en-GB","en-US-sappsd","en-US-saprigi","en-US-saptrc","es","es-MX","et","fi","fr","fr-CA","hi","hr","hu","id","it","iw","ja","kk","ko","lt","lv","ms","nl","no","pl","pt","pt-PT","ro","ru","sh","sk","sl","sv","th","tr","uk","vi","zh-CN","zh-TW"]},"content":{"controls":["sap.ui.integration.widgets.Card","sap.ui.integration.cards.filters.FilterBar","sap.ui.integration.cards.Header","sap.ui.integration.cards.NumericHeader","sap.ui.integration.controls.ListContentItem"],"elements":["sap.ui.integration.ActionDefinition","sap.ui.integration.Host"],"types":["sap.ui.integration.CardActionType","sap.ui.integration.CardDataMode","sap.ui.integration.CardMenuAction"]}}}}'
},"sap/ui/integration/library-h2-preload"
);
sap.ui.loader.config({depCacheUI5:{
"sap/ui/integration/ActionDefinition.js":["sap/m/library.js","sap/ui/core/Element.js"],
"sap/ui/integration/Designtime.js":["sap/ui/base/ManagedObject.js"],
"sap/ui/integration/Extension.js":["sap/base/Log.js","sap/ui/base/ManagedObject.js","sap/ui/integration/library.js"],
"sap/ui/integration/Host.js":["sap/ui/core/Element.js","sap/ui/integration/library.js"],
"sap/ui/integration/bindingFeatures/DateRange.js":["sap/base/Log.js","sap/ui/core/date/UniversalDateUtils.js"],
"sap/ui/integration/cards/AdaptiveContent.js":["sap/base/Log.js","sap/m/MessageStrip.js","sap/m/VBox.js","sap/ui/core/Core.js","sap/ui/core/HTML.js","sap/ui/core/library.js","sap/ui/dom/includeScript.js","sap/ui/integration/cards/BaseContent.js","sap/ui/integration/cards/adaptivecards/elements/hostConfig.js","sap/ui/integration/library.js","sap/ui/model/json/JSONModel.js"],
"sap/ui/integration/cards/AnalyticalContent.js":["sap/base/Log.js","sap/base/util/merge.js","sap/ui/core/Core.js","sap/ui/integration/cards/AnalyticalContentRenderer.js","sap/ui/integration/cards/BaseContent.js","sap/ui/integration/library.js","sap/ui/integration/util/BindingResolver.js"],
"sap/ui/integration/cards/AnalyticalContentRenderer.js":["sap/ui/integration/cards/BaseContentRenderer.js"],
"sap/ui/integration/cards/AnalyticsCloudContent.js":["sap/base/Log.js","sap/ui/core/HTML.js","sap/ui/integration/cards/AnalyticsCloudContentRenderer.js","sap/ui/integration/cards/BaseContent.js","sap/ui/integration/library.js","sap/ui/integration/util/BindingResolver.js"],
"sap/ui/integration/cards/AnalyticsCloudContentRenderer.js":["sap/ui/integration/cards/BaseContentRenderer.js"],
"sap/ui/integration/cards/BaseContent.js":["sap/base/util/merge.js","sap/ui/base/ManagedObjectObserver.js","sap/ui/core/Control.js","sap/ui/core/Core.js","sap/ui/integration/cards/BaseContentRenderer.js","sap/ui/integration/model/ObservableModel.js","sap/ui/integration/util/BindingHelper.js","sap/ui/integration/util/BindingResolver.js","sap/ui/integration/util/LoadingProvider.js"],
"sap/ui/integration/cards/BaseContentRenderer.js":["sap/ui/core/Renderer.js"],
"sap/ui/integration/cards/BaseListContent.js":["sap/base/Log.js","sap/ui/integration/cards/BaseContent.js","sap/ui/integration/library.js","sap/ui/integration/util/BindingResolver.js","sap/ui/model/Filter.js","sap/ui/model/FilterOperator.js","sap/ui/model/Sorter.js"],
"sap/ui/integration/cards/CalendarContent.js":["sap/f/CalendarAppointmentInCard.js","sap/f/CalendarInCard.js","sap/f/PlanningCalendarInCardLegend.js","sap/m/Button.js","sap/m/FlexBox.js","sap/m/library.js","sap/ui/core/ResizeHandler.js","sap/ui/core/date/UniversalDate.js","sap/ui/core/format/DateFormat.js","sap/ui/integration/cards/BaseContent.js","sap/ui/integration/cards/CalendarContentRenderer.js","sap/ui/integration/library.js","sap/ui/integration/util/BindingHelper.js","sap/ui/integration/util/BindingResolver.js","sap/ui/model/Filter.js","sap/ui/model/FilterOperator.js","sap/ui/unified/CalendarLegendItem.js","sap/ui/unified/DateTypeRange.js","sap/ui/unified/calendar/CalendarDate.js","sap/ui/unified/calendar/CalendarUtils.js"],
"sap/ui/integration/cards/CalendarContentRenderer.js":["sap/ui/core/IconPool.js","sap/ui/core/InvisibleText.js","sap/ui/integration/cards/BaseContentRenderer.js","sap/ui/unified/CalendarLegendRenderer.js","sap/ui/unified/library.js"],
"sap/ui/integration/cards/ComponentContent.js":["sap/ui/core/Component.js","sap/ui/core/ComponentContainer.js","sap/ui/integration/cards/BaseContent.js","sap/ui/integration/cards/ComponentContentRenderer.js"],
"sap/ui/integration/cards/ComponentContentRenderer.js":["sap/ui/integration/cards/BaseContentRenderer.js"],
"sap/ui/integration/cards/Footer.js":["sap/ui/core/Control.js","sap/ui/core/Core.js","sap/ui/integration/controls/ActionsStrip.js","sap/ui/integration/util/BindingHelper.js","sap/ui/integration/util/BindingResolver.js"],
"sap/ui/integration/cards/Header.js":["sap/base/util/isEmptyObject.js","sap/f/cards/Header.js","sap/f/cards/HeaderRenderer.js","sap/m/library.js","sap/ui/core/Core.js","sap/ui/integration/util/BindingHelper.js","sap/ui/integration/util/LoadingProvider.js","sap/ui/model/json/JSONModel.js"],
"sap/ui/integration/cards/ListContent.js":["sap/m/List.js","sap/m/ObjectStatus.js","sap/m/library.js","sap/ui/integration/cards/BaseListContent.js","sap/ui/integration/cards/ListContentRenderer.js","sap/ui/integration/controls/ActionsStrip.js","sap/ui/integration/controls/ListContentItem.js","sap/ui/integration/controls/Microchart.js","sap/ui/integration/controls/MicrochartLegend.js","sap/ui/integration/library.js","sap/ui/integration/util/BindingHelper.js","sap/ui/integration/util/BindingResolver.js","sap/ui/util/openWindow.js"],
"sap/ui/integration/cards/ListContentRenderer.js":["sap/ui/integration/cards/BaseContentRenderer.js","sap/ui/integration/library.js"],
"sap/ui/integration/cards/NumericHeader.js":["sap/base/util/extend.js","sap/base/util/isEmptyObject.js","sap/f/cards/NumericHeader.js","sap/f/cards/NumericHeaderRenderer.js","sap/f/cards/NumericSideIndicator.js","sap/ui/core/Core.js","sap/ui/integration/util/LoadingProvider.js","sap/ui/model/json/JSONModel.js"],
"sap/ui/integration/cards/ObjectContent.js":["sap/base/Log.js","sap/f/cards/NumericIndicators.js","sap/f/cards/NumericSideIndicator.js","sap/m/Avatar.js","sap/m/FlexItemData.js","sap/m/HBox.js","sap/m/Label.js","sap/m/Link.js","sap/m/ObjectStatus.js","sap/m/Text.js","sap/m/Title.js","sap/m/VBox.js","sap/m/library.js","sap/ui/core/ResizeHandler.js","sap/ui/dom/units/Rem.js","sap/ui/integration/cards/BaseContent.js","sap/ui/integration/cards/ObjectContentRenderer.js","sap/ui/integration/library.js","sap/ui/integration/util/BindingHelper.js","sap/ui/integration/util/Utils.js","sap/ui/layout/AlignedFlowLayout.js"],
"sap/ui/integration/cards/ObjectContentRenderer.js":["sap/ui/integration/cards/BaseContentRenderer.js"],
"sap/ui/integration/cards/TableContent.js":["sap/base/Log.js","sap/m/Avatar.js","sap/m/Column.js","sap/m/ColumnListItem.js","sap/m/Link.js","sap/m/ObjectIdentifier.js","sap/m/ObjectStatus.js","sap/m/ProgressIndicator.js","sap/m/Table.js","sap/m/Text.js","sap/m/library.js","sap/ui/core/library.js","sap/ui/integration/cards/BaseListContent.js","sap/ui/integration/cards/TableContentRenderer.js","sap/ui/integration/library.js","sap/ui/integration/util/BindingHelper.js","sap/ui/integration/util/BindingResolver.js"],
"sap/ui/integration/cards/TableContentRenderer.js":["sap/ui/integration/cards/BaseContentRenderer.js"],
"sap/ui/integration/cards/TimelineContent.js":["sap/ui/core/Core.js","sap/ui/integration/cards/BaseListContent.js","sap/ui/integration/cards/TimelineContentRenderer.js","sap/ui/integration/library.js","sap/ui/integration/util/BindingHelper.js"],
"sap/ui/integration/cards/TimelineContentRenderer.js":["sap/ui/integration/cards/BaseContentRenderer.js"],
"sap/ui/integration/cards/WebPageContent.js":["sap/ui/core/Core.js","sap/ui/integration/cards/BaseContent.js","sap/ui/integration/cards/WebPageContentRenderer.js","sap/ui/integration/util/BindingHelper.js"],
"sap/ui/integration/cards/WebPageContentRenderer.js":["sap/ui/integration/cards/BaseContentRenderer.js","sap/ui/integration/util/BindingResolver.js"],
"sap/ui/integration/cards/actions/BaseAction.js":["sap/ui/base/ManagedObject.js","sap/ui/core/Core.js","sap/ui/integration/util/BindingResolver.js"],
"sap/ui/integration/cards/actions/CardActions.js":["sap/base/Log.js","sap/base/strings/capitalize.js","sap/ui/base/ManagedObject.js","sap/ui/integration/cards/actions/CustomAction.js","sap/ui/integration/cards/actions/DateChangeAction.js","sap/ui/integration/cards/actions/MonthChangeAction.js","sap/ui/integration/cards/actions/NavigationAction.js","sap/ui/integration/cards/actions/SubmitAction.js","sap/ui/integration/library.js","sap/ui/integration/util/BindingResolver.js"],
"sap/ui/integration/cards/actions/CustomAction.js":["sap/ui/integration/cards/actions/BaseAction.js"],
"sap/ui/integration/cards/actions/DateChangeAction.js":["sap/ui/integration/cards/actions/BaseAction.js"],
"sap/ui/integration/cards/actions/MonthChangeAction.js":["sap/ui/integration/cards/actions/BaseAction.js"],
"sap/ui/integration/cards/actions/NavigationAction.js":["sap/ui/integration/cards/actions/BaseAction.js","sap/ui/util/openWindow.js"],
"sap/ui/integration/cards/actions/SubmitAction.js":["sap/base/Log.js","sap/ui/integration/cards/actions/BaseAction.js","sap/ui/integration/util/BindingHelper.js","sap/ui/integration/util/BindingResolver.js","sap/ui/integration/util/Utils.js"],
"sap/ui/integration/cards/adaptivecards/elements/UI5InputChoiceSet.js":["sap/ui/integration/thirdparty/adaptivecards.js"],
"sap/ui/integration/cards/adaptivecards/elements/UI5InputDate.js":["sap/ui/integration/thirdparty/adaptivecards.js"],
"sap/ui/integration/cards/adaptivecards/elements/UI5InputNumber.js":["sap/ui/integration/thirdparty/adaptivecards.js"],
"sap/ui/integration/cards/adaptivecards/elements/UI5InputText.js":["sap/ui/integration/thirdparty/adaptivecards.js"],
"sap/ui/integration/cards/adaptivecards/elements/UI5InputTime.js":["sap/ui/core/format/DateFormat.js","sap/ui/integration/thirdparty/adaptivecards.js"],
"sap/ui/integration/cards/adaptivecards/elements/UI5InputToggle.js":["sap/ui/integration/thirdparty/adaptivecards.js"],
"sap/ui/integration/cards/adaptivecards/elements/hostConfig.js":["sap/ui/core/theming/Parameters.js"],
"sap/ui/integration/cards/adaptivecards/overwrites/ActionRender.js":["sap/ui/integration/thirdparty/adaptivecards.js"],
"sap/ui/integration/cards/filters/BaseFilter.js":["sap/base/Log.js","sap/m/HBox.js","sap/m/Text.js","sap/ui/core/Control.js","sap/ui/core/Core.js","sap/ui/core/Icon.js","sap/ui/integration/model/ObservableModel.js","sap/ui/integration/util/LoadingProvider.js"],
"sap/ui/integration/cards/filters/DateRangeFilter.js":["sap/m/DynamicDateRange.js","sap/m/DynamicDateUtil.js","sap/ui/core/library.js","sap/ui/integration/cards/filters/BaseFilter.js"],
"sap/ui/integration/cards/filters/FilterBar.js":["sap/ui/core/Control.js"],
"sap/ui/integration/cards/filters/FilterBarFactory.js":["sap/m/HBox.js","sap/m/library.js","sap/ui/base/Object.js","sap/ui/integration/cards/filters/DateRangeFilter.js","sap/ui/integration/cards/filters/FilterBar.js","sap/ui/integration/cards/filters/SearchFilter.js","sap/ui/integration/cards/filters/SelectFilter.js","sap/ui/layout/AlignedFlowLayout.js"],
"sap/ui/integration/cards/filters/SearchFilter.js":["sap/m/SearchField.js","sap/ui/integration/cards/filters/BaseFilter.js"],
"sap/ui/integration/cards/filters/SelectFilter.js":["sap/m/Select.js","sap/ui/core/ListItem.js","sap/ui/integration/cards/filters/BaseFilter.js","sap/ui/integration/util/BindingResolver.js","sap/ui/model/json/JSONModel.js"],
"sap/ui/integration/controls/ActionsStrip.js":["sap/m/Button.js","sap/m/OverflowToolbar.js","sap/m/OverflowToolbarButton.js","sap/m/OverflowToolbarLayoutData.js","sap/m/ToolbarSpacer.js","sap/m/library.js","sap/ui/core/Control.js","sap/ui/core/Core.js","sap/ui/integration/cards/actions/CardActions.js","sap/ui/integration/library.js","sap/ui/integration/util/BindingHelper.js"],
"sap/ui/integration/controls/ActionsToolbar.js":["sap/base/strings/capitalize.js","sap/m/ActionSheet.js","sap/m/Button.js","sap/m/library.js","sap/ui/base/ManagedObjectObserver.js","sap/ui/core/Control.js","sap/ui/core/Core.js","sap/ui/core/library.js","sap/ui/integration/cards/actions/CardActions.js","sap/ui/integration/controls/ActionsToolbarRenderer.js"],
"sap/ui/integration/controls/ListContentItem.js":["sap/m/Avatar.js","sap/m/AvatarShape.js","sap/m/AvatarSize.js","sap/m/StandardListItem.js","sap/ui/integration/controls/ListContentItemRenderer.js","sap/ui/integration/library.js"],
"sap/ui/integration/controls/ListContentItemRenderer.js":["sap/m/StandardListItemRenderer.js","sap/ui/Device.js","sap/ui/core/Core.js","sap/ui/core/Renderer.js","sap/ui/integration/library.js"],
"sap/ui/integration/controls/Microchart.js":["sap/m/library.js","sap/ui/core/Control.js","sap/ui/core/Core.js"],
"sap/ui/integration/controls/MicrochartLegend.js":["sap/m/Text.js","sap/ui/core/Control.js","sap/ui/core/Core.js","sap/ui/core/theming/Parameters.js","sap/ui/integration/controls/MicrochartLegendRenderer.js","sap/ui/integration/util/BindingHelper.js"],
"sap/ui/integration/controls/MicrochartLegendRenderer.js":["sap/m/library.js","sap/ui/core/Core.js"],
"sap/ui/integration/customElements/CustomElementBase.js":["sap/base/Log.js","sap/base/strings/camelize.js","sap/base/strings/hyphenate.js","sap/ui/integration/util/Utils.js"],
"sap/ui/integration/customElements/CustomElementCard.js":["sap/m/BadgeCustomData.js","sap/ui/integration/customElements/CustomElementBase.js","sap/ui/integration/widgets/Card.js"],
"sap/ui/integration/customElements/CustomElementCardEditor.js":["sap/ui/integration/customElements/CustomElementBase.js","sap/ui/integration/designtime/editor/CardEditor.js"],
"sap/ui/integration/customElements/CustomElementEditor.js":["sap/ui/integration/customElements/CustomElementBase.js","sap/ui/integration/editor/Editor.js"],
"sap/ui/integration/designtime/baseEditor/BaseEditor.js":["sap/base/Log.js","sap/base/i18n/ResourceBundle.js","sap/base/util/ObjectPath.js","sap/base/util/deepClone.js","sap/base/util/deepEqual.js","sap/base/util/each.js","sap/base/util/includes.js","sap/base/util/isEmptyObject.js","sap/base/util/isPlainObject.js","sap/base/util/restricted/_castArray.js","sap/base/util/restricted/_flatten.js","sap/base/util/restricted/_intersection.js","sap/base/util/restricted/_isNil.js","sap/base/util/restricted/_merge.js","sap/base/util/restricted/_mergeWith.js","sap/base/util/restricted/_omit.js","sap/base/util/restricted/_union.js","sap/base/util/values.js","sap/ui/core/Control.js","sap/ui/integration/designtime/baseEditor/PropertyEditors.js","sap/ui/integration/designtime/baseEditor/propertyEditor/PropertyEditorFactory.js","sap/ui/integration/designtime/baseEditor/util/binding/ObjectBinding.js","sap/ui/integration/designtime/baseEditor/util/binding/resolveBinding.js","sap/ui/integration/designtime/baseEditor/util/cleanupDesigntimeMetadata.js","sap/ui/integration/designtime/baseEditor/util/createPromise.js","sap/ui/integration/designtime/baseEditor/util/hasTag.js","sap/ui/integration/designtime/baseEditor/util/unset.js","sap/ui/integration/designtime/baseEditor/validator/ValidatorRegistry.js","sap/ui/model/json/JSONModel.js","sap/ui/model/resource/ResourceModel.js"],
"sap/ui/integration/designtime/baseEditor/PropertyEditor.js":["sap/base/util/deepClone.js","sap/base/util/deepEqual.js","sap/base/util/restricted/_merge.js","sap/base/util/restricted/_omit.js","sap/ui/core/Control.js","sap/ui/integration/designtime/baseEditor/propertyEditor/PropertyEditorFactory.js","sap/ui/integration/designtime/baseEditor/util/createPromise.js","sap/ui/integration/designtime/baseEditor/util/escapeParameter.js","sap/ui/integration/designtime/baseEditor/util/findClosestInstance.js"],
"sap/ui/integration/designtime/baseEditor/PropertyEditors.js":["sap/base/util/deepClone.js","sap/base/util/deepEqual.js","sap/base/util/restricted/_intersection.js","sap/base/util/restricted/_omit.js","sap/ui/base/ManagedObjectObserver.js","sap/ui/core/Control.js","sap/ui/core/Fragment.js","sap/ui/integration/designtime/baseEditor/util/StylesheetManager.js","sap/ui/integration/designtime/baseEditor/util/createPromise.js","sap/ui/integration/designtime/baseEditor/util/findClosestInstance.js","sap/ui/integration/designtime/baseEditor/util/isTemplate.js","sap/ui/model/json/JSONModel.js"],
"sap/ui/integration/designtime/baseEditor/layout/Form.fragment.xml":["sap/ui/core/Fragment.js","sap/ui/integration/designtime/baseEditor/PropertyEditor.js","sap/ui/layout/form/Form.js","sap/ui/layout/form/FormContainer.js","sap/ui/layout/form/FormElement.js","sap/ui/layout/form/ResponsiveGridLayout.js"],
"sap/ui/integration/designtime/baseEditor/layout/Form.js":["sap/base/util/restricted/_omit.js","sap/ui/integration/designtime/baseEditor/util/hasTag.js"],
"sap/ui/integration/designtime/baseEditor/propertyEditor/BasePropertyEditor.js":["sap/base/util/deepClone.js","sap/base/util/deepEqual.js","sap/base/util/each.js","sap/base/util/isPlainObject.js","sap/base/util/restricted/_CancelablePromise.js","sap/base/util/restricted/_omit.js","sap/base/util/values.js","sap/m/Label.js","sap/ui/base/ManagedObjectObserver.js","sap/ui/core/Control.js","sap/ui/core/Fragment.js","sap/ui/integration/designtime/baseEditor/propertyEditor/PropertyEditorFactory.js","sap/ui/integration/designtime/baseEditor/util/BaseDefaultValidatorModules.js","sap/ui/integration/designtime/baseEditor/util/cleanupDesigntimeMetadata.js","sap/ui/integration/designtime/baseEditor/util/createPromise.js","sap/ui/integration/designtime/baseEditor/util/isTemplate.js","sap/ui/integration/designtime/baseEditor/validator/ValidatorRegistry.js","sap/ui/model/json/JSONModel.js"],
"sap/ui/integration/designtime/baseEditor/propertyEditor/PropertyEditorFactory.js":["sap/base/util/includes.js","sap/base/util/values.js"],
"sap/ui/integration/designtime/baseEditor/propertyEditor/arrayEditor/ArrayEditor.fragment.xml":["sap/m/Button.js","sap/m/Panel.js","sap/m/Title.js","sap/m/Toolbar.js","sap/m/ToolbarSpacer.js","sap/m/VBox.js","sap/ui/core/CustomData.js","sap/ui/core/Fragment.js","sap/ui/integration/designtime/baseEditor/PropertyEditors.js"],
"sap/ui/integration/designtime/baseEditor/propertyEditor/arrayEditor/ArrayEditor.js":["sap/base/strings/formatMessage.js","sap/base/util/ObjectPath.js","sap/base/util/deepClone.js","sap/base/util/deepEqual.js","sap/base/util/isEmptyObject.js","sap/base/util/restricted/_isNil.js","sap/base/util/restricted/_merge.js","sap/ui/integration/designtime/baseEditor/propertyEditor/BasePropertyEditor.js","sap/ui/integration/designtime/baseEditor/util/binding/resolveBinding.js","sap/ui/integration/designtime/baseEditor/util/unset.js","sap/ui/model/json/JSONModel.js"],
"sap/ui/integration/designtime/baseEditor/propertyEditor/arrayEditor/ArrayEditorPlain.fragment.xml":["sap/m/Bar.js","sap/m/Button.js","sap/m/Label.js","sap/m/VBox.js","sap/ui/core/CustomData.js","sap/ui/core/Fragment.js","sap/ui/integration/designtime/baseEditor/PropertyEditors.js"],
"sap/ui/integration/designtime/baseEditor/propertyEditor/booleanEditor/BooleanEditor.fragment.xml":["sap/m/ComboBox.js","sap/ui/core/Fragment.js","sap/ui/core/Item.js"],
"sap/ui/integration/designtime/baseEditor/propertyEditor/booleanEditor/BooleanEditor.js":["sap/ui/integration/designtime/baseEditor/propertyEditor/BasePropertyEditor.js","sap/ui/integration/designtime/baseEditor/util/isValidBindingString.js"],
"sap/ui/integration/designtime/baseEditor/propertyEditor/dateEditor/DateEditor.fragment.xml":["sap/m/DatePicker.js","sap/ui/core/Fragment.js"],
"sap/ui/integration/designtime/baseEditor/propertyEditor/dateEditor/DateEditor.js":["sap/ui/core/format/DateFormat.js","sap/ui/integration/designtime/baseEditor/propertyEditor/BasePropertyEditor.js"],
"sap/ui/integration/designtime/baseEditor/propertyEditor/dateTimeEditor/DateTimeEditor.fragment.xml":["sap/m/DateTimePicker.js","sap/ui/core/Fragment.js"],
"sap/ui/integration/designtime/baseEditor/propertyEditor/dateTimeEditor/DateTimeEditor.js":["sap/ui/core/format/DateFormat.js","sap/ui/integration/designtime/baseEditor/propertyEditor/BasePropertyEditor.js","sap/ui/integration/designtime/baseEditor/propertyEditor/dateEditor/DateEditor.js"],
"sap/ui/integration/designtime/baseEditor/propertyEditor/enumStringEditor/EnumStringEditor.fragment.xml":["sap/m/ComboBox.js","sap/ui/core/Fragment.js","sap/ui/core/Item.js"],
"sap/ui/integration/designtime/baseEditor/propertyEditor/enumStringEditor/EnumStringEditor.js":["sap/ui/integration/designtime/baseEditor/propertyEditor/BasePropertyEditor.js","sap/ui/integration/designtime/baseEditor/util/isValidBindingString.js"],
"sap/ui/integration/designtime/baseEditor/propertyEditor/groupEditor/GroupEditor.fragment.xml":["sap/m/Panel.js","sap/ui/core/Fragment.js"],
"sap/ui/integration/designtime/baseEditor/propertyEditor/groupEditor/GroupEditor.js":["sap/base/util/isPlainObject.js","sap/base/util/restricted/_isNil.js","sap/ui/integration/designtime/baseEditor/propertyEditor/BasePropertyEditor.js"],
"sap/ui/integration/designtime/baseEditor/propertyEditor/iconEditor/IconEditor.fragment.xml":["sap/m/Input.js","sap/ui/core/Fragment.js"],
"sap/ui/integration/designtime/baseEditor/propertyEditor/iconEditor/IconEditor.js":["sap/ui/base/BindingParser.js","sap/ui/core/Fragment.js","sap/ui/core/IconPool.js","sap/ui/core/ListItem.js","sap/ui/integration/designtime/baseEditor/propertyEditor/BasePropertyEditor.js","sap/ui/integration/designtime/baseEditor/propertyEditor/iconEditor/IsInIconPool.validator.js","sap/ui/integration/designtime/baseEditor/util/isValidBindingString.js","sap/ui/model/Filter.js","sap/ui/model/FilterOperator.js","sap/ui/model/json/JSONModel.js"],
"sap/ui/integration/designtime/baseEditor/propertyEditor/iconEditor/IconEditorDialog.fragment.xml":["sap/m/SelectDialog.js","sap/m/StandardListItem.js","sap/ui/core/Fragment.js"],
"sap/ui/integration/designtime/baseEditor/propertyEditor/iconEditor/IsInIconPool.validator.js":["sap/base/util/restricted/_isNil.js","sap/ui/core/IconPool.js","sap/ui/integration/designtime/baseEditor/validator/IsValidBinding.js"],
"sap/ui/integration/designtime/baseEditor/propertyEditor/integerEditor/IntegerEditor.js":["sap/ui/core/format/NumberFormat.js","sap/ui/integration/designtime/baseEditor/propertyEditor/BasePropertyEditor.js","sap/ui/integration/designtime/baseEditor/propertyEditor/numberEditor/NumberEditor.js"],
"sap/ui/integration/designtime/baseEditor/propertyEditor/jsonEditor/JsonEditor.fragment.xml":["sap/m/Input.js","sap/ui/core/Fragment.js"],
"sap/ui/integration/designtime/baseEditor/propertyEditor/jsonEditor/JsonEditor.js":["sap/ui/core/Fragment.js","sap/ui/integration/designtime/baseEditor/propertyEditor/BasePropertyEditor.js"],
"sap/ui/integration/designtime/baseEditor/propertyEditor/jsonEditor/JsonEditorDialog.fragment.xml":["sap/m/Bar.js","sap/m/Button.js","sap/m/Dialog.js","sap/m/MessageStrip.js","sap/m/Title.js","sap/ui/core/Fragment.js"],
"sap/ui/integration/designtime/baseEditor/propertyEditor/listEditor/ListEditor.fragment.xml":["sap/m/MultiInput.js","sap/m/Token.js","sap/ui/core/Fragment.js"],
"sap/ui/integration/designtime/baseEditor/propertyEditor/listEditor/ListEditor.js":["sap/ui/integration/designtime/baseEditor/propertyEditor/BasePropertyEditor.js","sap/ui/integration/designtime/baseEditor/validator/IsValidBinding.js"],
"sap/ui/integration/designtime/baseEditor/propertyEditor/mapEditor/MapEditor.fragment.xml":["sap/m/Button.js","sap/m/Panel.js","sap/m/Title.js","sap/m/Toolbar.js","sap/m/ToolbarSpacer.js","sap/m/VBox.js","sap/ui/core/CustomData.js","sap/ui/core/Fragment.js","sap/ui/integration/designtime/baseEditor/PropertyEditors.js"],
"sap/ui/integration/designtime/baseEditor/propertyEditor/mapEditor/MapEditor.js":["sap/base/strings/formatMessage.js","sap/base/util/deepClone.js","sap/base/util/deepEqual.js","sap/base/util/includes.js","sap/base/util/isPlainObject.js","sap/base/util/restricted/_merge.js","sap/base/util/restricted/_omit.js","sap/ui/integration/designtime/baseEditor/propertyEditor/BasePropertyEditor.js","sap/ui/integration/designtime/baseEditor/propertyEditor/PropertyEditorFactory.js","sap/ui/model/json/JSONModel.js"],
"sap/ui/integration/designtime/baseEditor/propertyEditor/multiSelectEditor/MultiSelectEditor.fragment.xml":["sap/m/MultiComboBox.js","sap/ui/core/Fragment.js","sap/ui/core/ListItem.js"],
"sap/ui/integration/designtime/baseEditor/propertyEditor/multiSelectEditor/MultiSelectEditor.js":["sap/ui/integration/designtime/baseEditor/propertyEditor/BasePropertyEditor.js","sap/ui/integration/designtime/baseEditor/util/isValidBindingString.js"],
"sap/ui/integration/designtime/baseEditor/propertyEditor/numberEditor/NumberEditor.fragment.xml":["sap/m/Input.js","sap/ui/core/Fragment.js"],
"sap/ui/integration/designtime/baseEditor/propertyEditor/numberEditor/NumberEditor.js":["sap/base/util/restricted/_isNil.js","sap/ui/core/format/NumberFormat.js","sap/ui/integration/designtime/baseEditor/propertyEditor/BasePropertyEditor.js","sap/ui/integration/designtime/baseEditor/util/isValidBindingString.js"],
"sap/ui/integration/designtime/baseEditor/propertyEditor/selectEditor/SelectEditor.fragment.xml":["sap/m/ComboBox.js","sap/ui/core/Fragment.js","sap/ui/core/ListItem.js"],
"sap/ui/integration/designtime/baseEditor/propertyEditor/selectEditor/SelectEditor.js":["sap/ui/integration/designtime/baseEditor/propertyEditor/BasePropertyEditor.js","sap/ui/integration/designtime/baseEditor/util/isValidBindingString.js"],
"sap/ui/integration/designtime/baseEditor/propertyEditor/separatorEditor/SeparatorEditor.fragment.xml":["sap/m/ToolbarSpacer.js","sap/ui/core/Fragment.js"],
"sap/ui/integration/designtime/baseEditor/propertyEditor/separatorEditor/SeparatorEditor.js":["sap/base/util/isPlainObject.js","sap/base/util/restricted/_isNil.js","sap/ui/integration/designtime/baseEditor/propertyEditor/BasePropertyEditor.js"],
"sap/ui/integration/designtime/baseEditor/propertyEditor/stringEditor/StringEditor.fragment.xml":["sap/m/Input.js","sap/ui/core/Fragment.js"],
"sap/ui/integration/designtime/baseEditor/propertyEditor/stringEditor/StringEditor.js":["sap/base/util/isPlainObject.js","sap/base/util/restricted/_isNil.js","sap/ui/integration/designtime/baseEditor/propertyEditor/BasePropertyEditor.js"],
"sap/ui/integration/designtime/baseEditor/propertyEditor/textAreaEditor/TextAreaEditor.fragment.xml":["sap/m/TextArea.js","sap/ui/core/Fragment.js"],
"sap/ui/integration/designtime/baseEditor/propertyEditor/textAreaEditor/TextAreaEditor.js":["sap/base/util/isPlainObject.js","sap/base/util/restricted/_isNil.js","sap/ui/integration/designtime/baseEditor/propertyEditor/BasePropertyEditor.js"],
"sap/ui/integration/designtime/baseEditor/util/BaseDefaultValidatorModules.js":["sap/ui/integration/designtime/baseEditor/validator/IsBoolean.js","sap/ui/integration/designtime/baseEditor/validator/IsDate.js","sap/ui/integration/designtime/baseEditor/validator/IsInteger.js","sap/ui/integration/designtime/baseEditor/validator/IsNumber.js","sap/ui/integration/designtime/baseEditor/validator/IsPatternMatch.js","sap/ui/integration/designtime/baseEditor/validator/IsSelectedKey.js","sap/ui/integration/designtime/baseEditor/validator/IsStringList.js","sap/ui/integration/designtime/baseEditor/validator/IsUniqueKey.js","sap/ui/integration/designtime/baseEditor/validator/IsUniqueList.js","sap/ui/integration/designtime/baseEditor/validator/IsValidBinding.js","sap/ui/integration/designtime/baseEditor/validator/MaxLength.js","sap/ui/integration/designtime/baseEditor/validator/NotABinding.js"],
"sap/ui/integration/designtime/baseEditor/util/StylesheetManager.js":["sap/base/util/uid.js","sap/ui/dom/includeStylesheet.js"],
"sap/ui/integration/designtime/baseEditor/util/binding/ObjectBinding.js":["sap/base/util/ObjectPath.js","sap/base/util/deepClone.js","sap/base/util/deepEqual.js","sap/base/util/includes.js","sap/base/util/isPlainObject.js","sap/ui/base/BindingParser.js","sap/ui/base/ManagedObject.js"],
"sap/ui/integration/designtime/baseEditor/util/binding/resolveBinding.js":["sap/ui/integration/designtime/baseEditor/util/binding/ObjectBinding.js"],
"sap/ui/integration/designtime/baseEditor/util/cleanupDesigntimeMetadata.js":["sap/base/util/each.js","sap/base/util/isEmptyObject.js","sap/base/util/isPlainObject.js","sap/base/util/restricted/_isNil.js"],
"sap/ui/integration/designtime/baseEditor/util/escapeParameter.js":["sap/base/util/each.js","sap/base/util/isPlainObject.js"],
"sap/ui/integration/designtime/baseEditor/util/hasTag.js":["sap/base/util/restricted/_intersection.js"],
"sap/ui/integration/designtime/baseEditor/util/isValidBindingString.js":["sap/ui/base/BindingParser.js"],
"sap/ui/integration/designtime/baseEditor/util/unset.js":["sap/base/util/ObjectPath.js","sap/base/util/isEmptyObject.js","sap/base/util/isPlainObject.js"],
"sap/ui/integration/designtime/baseEditor/validator/IsBoolean.js":["sap/base/util/restricted/_isNil.js","sap/ui/integration/designtime/baseEditor/validator/IsValidBinding.js"],
"sap/ui/integration/designtime/baseEditor/validator/IsDate.js":["sap/ui/integration/designtime/baseEditor/validator/IsValidBinding.js"],
"sap/ui/integration/designtime/baseEditor/validator/IsInteger.js":["sap/ui/integration/designtime/baseEditor/validator/IsValidBinding.js"],
"sap/ui/integration/designtime/baseEditor/validator/IsNumber.js":["sap/ui/integration/designtime/baseEditor/validator/IsValidBinding.js"],
"sap/ui/integration/designtime/baseEditor/validator/IsPatternMatch.js":["sap/ui/integration/designtime/baseEditor/validator/IsValidBinding.js"],
"sap/ui/integration/designtime/baseEditor/validator/IsSelectedKey.js":["sap/ui/integration/designtime/baseEditor/validator/IsValidBinding.js"],
"sap/ui/integration/designtime/baseEditor/validator/IsStringList.js":["sap/ui/integration/designtime/baseEditor/validator/IsValidBinding.js"],
"sap/ui/integration/designtime/baseEditor/validator/IsUniqueKey.js":["sap/base/util/includes.js"],
"sap/ui/integration/designtime/baseEditor/validator/IsUniqueList.js":["sap/base/util/restricted/_uniq.js"],
"sap/ui/integration/designtime/baseEditor/validator/IsValidBinding.js":["sap/ui/integration/designtime/baseEditor/util/isValidBindingString.js"],
"sap/ui/integration/designtime/baseEditor/validator/MaxLength.js":["sap/base/util/restricted/_isNil.js","sap/ui/integration/designtime/baseEditor/validator/IsValidBinding.js"],
"sap/ui/integration/designtime/baseEditor/validator/NotABinding.js":["sap/ui/integration/designtime/baseEditor/util/isValidBindingString.js"],
"sap/ui/integration/designtime/baseEditor/validator/ValidatorRegistry.js":["sap/base/util/includes.js","sap/base/util/restricted/_CancelablePromise.js","sap/base/util/values.js"],
"sap/ui/integration/designtime/cardEditor/BASEditor.js":["sap/base/Log.js","sap/base/util/LoaderExtensions.js","sap/base/util/ObjectPath.js","sap/base/util/deepClone.js","sap/base/util/deepEqual.js","sap/base/util/merge.js","sap/base/util/restricted/_CancelablePromise.js","sap/base/util/restricted/_isEqual.js","sap/base/util/restricted/_omit.js","sap/ui/integration/Designtime.js","sap/ui/integration/designtime/baseEditor/BaseEditor.js","sap/ui/integration/designtime/cardEditor/CardEditor.js","sap/ui/integration/util/CardMerger.js"],
"sap/ui/integration/designtime/cardEditor/CardEditor.js":["sap/base/util/ObjectPath.js","sap/base/util/deepClone.js","sap/base/util/deepEqual.js","sap/base/util/each.js","sap/base/util/isEmptyObject.js","sap/base/util/merge.js","sap/base/util/restricted/_CancelablePromise.js","sap/base/util/restricted/_castArray.js","sap/base/util/restricted/_isEqual.js","sap/base/util/restricted/_omit.js","sap/ui/integration/designtime/baseEditor/BaseEditor.js","sap/ui/integration/designtime/cardEditor/config/index.js","sap/ui/integration/util/CardMerger.js","sap/ui/thirdparty/jquery.js"],
"sap/ui/integration/designtime/cardEditor/ConfigurationTemplate.js":["sap/ui/integration/Designtime.js"],
"sap/ui/integration/designtime/cardEditor/PropertyEditor.js":["sap/ui/integration/designtime/baseEditor/PropertyEditor.js"],
"sap/ui/integration/designtime/cardEditor/PropertyEditors.js":["sap/ui/integration/designtime/baseEditor/PropertyEditors.js"],
"sap/ui/integration/designtime/cardEditor/config/HeaderConfig.js":["sap/ui/integration/designtime/cardEditor/config/generateActionConfig.js"],
"sap/ui/integration/designtime/cardEditor/config/ListCardConfig.js":["sap/ui/integration/designtime/cardEditor/config/generateActionConfig.js"],
"sap/ui/integration/designtime/cardEditor/config/ObjectCardConfig.js":["sap/ui/integration/designtime/cardEditor/config/generateActionConfig.js","sap/ui/integration/designtime/cardEditor/util/CommonPatterns.js"],
"sap/ui/integration/designtime/cardEditor/config/TableCardConfig.js":["sap/ui/integration/designtime/cardEditor/config/generateActionConfig.js"],
"sap/ui/integration/designtime/cardEditor/config/generateActionConfig.js":["sap/base/util/restricted/_merge.js"],
"sap/ui/integration/designtime/cardEditor/config/index.js":["sap/ui/integration/designtime/cardEditor/config/AppConfig.js","sap/ui/integration/designtime/cardEditor/config/HeaderConfig.js","sap/ui/integration/designtime/cardEditor/config/ListCardConfig.js","sap/ui/integration/designtime/cardEditor/config/ObjectCardConfig.js","sap/ui/integration/designtime/cardEditor/config/TableCardConfig.js","sap/ui/integration/designtime/cardEditor/config/generateDataConfig.js"],
"sap/ui/integration/designtime/cardEditor/propertyEditor/complexMapEditor/ComplexMapEditor.fragment.xml":["sap/ui/core/Fragment.js","sap/ui/integration/designtime/baseEditor/PropertyEditor.js"],
"sap/ui/integration/designtime/cardEditor/propertyEditor/complexMapEditor/ComplexMapEditor.js":["sap/base/util/deepClone.js","sap/base/util/restricted/_merge.js","sap/base/util/restricted/_omit.js","sap/ui/integration/cards/filters/DateRangeFilter.js","sap/ui/integration/designtime/baseEditor/propertyEditor/BasePropertyEditor.js"],
"sap/ui/integration/designtime/cardEditor/propertyEditor/destinationsEditor/DestinationsEditor.js":["sap/base/util/restricted/_merge.js","sap/ui/integration/designtime/baseEditor/propertyEditor/BasePropertyEditor.js","sap/ui/integration/designtime/cardEditor/propertyEditor/complexMapEditor/ComplexMapEditor.js"],
"sap/ui/integration/designtime/cardEditor/propertyEditor/filtersEditor/FiltersEditor.js":["sap/base/util/restricted/_merge.js","sap/ui/integration/cards/filters/DateRangeFilter.js","sap/ui/integration/designtime/baseEditor/propertyEditor/BasePropertyEditor.js","sap/ui/integration/designtime/cardEditor/propertyEditor/complexMapEditor/ComplexMapEditor.js"],
"sap/ui/integration/designtime/cardEditor/propertyEditor/iconEditor/IconEditor.fragment.xml":["sap/m/Button.js","sap/m/FlexBox.js","sap/m/FlexItemData.js","sap/ui/core/Fragment.js","sap/ui/integration/designtime/cardEditor/PropertyEditor.js","sap/ui/layout/VerticalLayout.js"],
"sap/ui/integration/designtime/cardEditor/propertyEditor/iconEditor/IconEditor.js":["sap/base/util/deepClone.js","sap/base/util/isEmptyObject.js","sap/base/util/isPlainObject.js","sap/base/util/restricted/_omit.js","sap/ui/core/Fragment.js","sap/ui/core/IconPool.js","sap/ui/integration/designtime/baseEditor/propertyEditor/BasePropertyEditor.js","sap/ui/integration/designtime/baseEditor/util/isValidBindingString.js","sap/ui/model/json/JSONModel.js","sap/ui/unified/ColorPickerPopover.js","sap/ui/unified/library.js"],
"sap/ui/integration/designtime/cardEditor/propertyEditor/iconEditor/IconEditorSettingsDialog.fragment.xml":["sap/m/Button.js","sap/m/Dialog.js","sap/m/Input.js","sap/m/Label.js","sap/m/Select.js","sap/m/VBox.js","sap/ui/core/Fragment.js","sap/ui/core/Item.js","sap/ui/layout/form/SimpleForm.js"],
"sap/ui/integration/designtime/cardEditor/propertyEditor/parametersEditor/ParametersConfigurationEditor.fragment.xml":["sap/ui/core/Fragment.js","sap/ui/integration/designtime/baseEditor/PropertyEditors.js"],
"sap/ui/integration/designtime/cardEditor/propertyEditor/parametersEditor/ParametersEditor.js":["sap/base/util/deepEqual.js","sap/base/util/includes.js","sap/base/util/restricted/_merge.js","sap/ui/integration/designtime/baseEditor/propertyEditor/BasePropertyEditor.js","sap/ui/integration/designtime/baseEditor/propertyEditor/mapEditor/MapEditor.js"],
"sap/ui/integration/designtime/cardEditor/validator/IsPatternMatchList.js":["sap/ui/integration/designtime/baseEditor/validator/IsPatternMatch.js"],
"sap/ui/integration/designtime/editor/CardEditor.js":["sap/base/util/merge.js","sap/ui/core/Core.js","sap/ui/integration/editor/Editor.js","sap/ui/integration/editor/Merger.js","sap/ui/integration/widgets/Card.js","sap/ui/model/json/JSONModel.js","sap/ui/model/resource/ResourceModel.js"],
"sap/ui/integration/designtime/editor/CardPreview.js":["sap/m/HBox.js","sap/m/Image.js","sap/m/ToggleButton.js","sap/ui/core/Control.js","sap/ui/core/Core.js","sap/ui/dom/includeStylesheet.js","sap/ui/integration/util/CardMerger.js","sap/ui/integration/widgets/Card.js"],
"sap/ui/integration/editor/Editor.js":["sap/base/Log.js","sap/base/i18n/ResourceBundle.js","sap/base/util/LoaderExtensions.js","sap/base/util/ObjectPath.js","sap/base/util/deepClone.js","sap/base/util/deepEqual.js","sap/base/util/includes.js","sap/base/util/merge.js","sap/m/Button.js","sap/m/FlexBox.js","sap/m/FlexItemData.js","sap/m/FormattedText.js","sap/m/HBox.js","sap/m/Label.js","sap/m/MessageStrip.js","sap/m/Panel.js","sap/m/Popover.js","sap/m/ResponsivePopover.js","sap/m/Text.js","sap/m/Title.js","sap/m/ToolbarSpacer.js","sap/m/VBox.js","sap/ui/base/Interface.js","sap/ui/core/Control.js","sap/ui/core/Core.js","sap/ui/core/Icon.js","sap/ui/core/Manifest.js","sap/ui/core/Popup.js","sap/ui/core/theming/Parameters.js","sap/ui/dom/includeStylesheet.js","sap/ui/integration/Designtime.js","sap/ui/integration/editor/EditorResourceBundles.js","sap/ui/integration/editor/Manifest.js","sap/ui/integration/editor/Merger.js","sap/ui/integration/editor/Settings.js","sap/ui/integration/util/DataProviderFactory.js","sap/ui/integration/util/Destinations.js","sap/ui/integration/util/Utils.js","sap/ui/model/json/JSONModel.js","sap/ui/model/resource/ResourceModel.js","sap/ui/thirdparty/URI.js","ui5loader.js"],
"sap/ui/integration/editor/EditorResourceBundles.js":["sap/base/i18n/ResourceBundle.js","sap/base/util/LoaderExtensions.js","sap/base/util/includes.js"],
"sap/ui/integration/editor/Extension.js":["sap/base/Log.js","sap/ui/base/ManagedObject.js","sap/ui/integration/library.js"],
"sap/ui/integration/editor/Manifest.js":["sap/ui/integration/editor/Merger.js","sap/ui/integration/util/Manifest.js"],
"sap/ui/integration/editor/Merger.js":["sap/base/util/deepClone.js","sap/base/util/merge.js","sap/ui/core/Core.js","sap/ui/model/json/JSONModel.js"],
"sap/ui/integration/editor/Settings.js":["sap/base/util/ObjectPath.js","sap/base/util/merge.js","sap/m/Button.js","sap/m/CheckBox.js","sap/m/Column.js","sap/m/ColumnListItem.js","sap/m/HBox.js","sap/m/Input.js","sap/m/Label.js","sap/m/Menu.js","sap/m/MenuItem.js","sap/m/ResponsivePopover.js","sap/m/ScrollContainer.js","sap/m/SegmentedButton.js","sap/m/SegmentedButtonItem.js","sap/m/Select.js","sap/m/Table.js","sap/m/Text.js","sap/m/Title.js","sap/m/VBox.js","sap/ui/core/Control.js","sap/ui/core/Core.js","sap/ui/core/ListItem.js","sap/ui/integration/util/BindingHelper.js","sap/ui/integration/util/ParameterMap.js","sap/ui/model/json/JSONModel.js"],
"sap/ui/integration/editor/fields/BaseField.js":["sap/base/util/ObjectPath.js","sap/base/util/deepEqual.js","sap/m/Button.js","sap/m/FormattedText.js","sap/m/MessageToast.js","sap/m/MultiInput.js","sap/m/Token.js","sap/ui/core/Control.js","sap/ui/core/Core.js","sap/ui/core/ListItem.js","sap/ui/integration/util/BindingHelper.js","sap/ui/integration/util/Utils.js"],
"sap/ui/integration/editor/fields/BooleanField.js":["sap/m/CheckBox.js","sap/ui/integration/editor/fields/BaseField.js"],
"sap/ui/integration/editor/fields/DateField.js":["sap/m/DatePicker.js","sap/ui/integration/editor/fields/BaseField.js"],
"sap/ui/integration/editor/fields/DateTimeField.js":["sap/m/DateTimePicker.js","sap/ui/integration/editor/fields/BaseField.js"],
"sap/ui/integration/editor/fields/DestinationField.js":["sap/m/Select.js","sap/ui/core/ListItem.js","sap/ui/integration/editor/fields/BaseField.js"],
"sap/ui/integration/editor/fields/IntegerField.js":["sap/m/Input.js","sap/ui/integration/editor/fields/BaseField.js"],
"sap/ui/integration/editor/fields/ListField.js":["sap/base/util/ObjectPath.js","sap/base/util/deepClone.js","sap/base/util/each.js","sap/base/util/includes.js","sap/base/util/merge.js","sap/base/util/restricted/_debounce.js","sap/base/util/restricted/_isEqual.js","sap/m/Input.js","sap/m/MultiComboBox.js","sap/m/MultiInput.js","sap/m/Text.js","sap/m/Token.js","sap/m/Tokenizer.js","sap/ui/core/Core.js","sap/ui/core/ListItem.js","sap/ui/core/SeparatorItem.js","sap/ui/integration/editor/fields/BaseField.js","sap/ui/model/Sorter.js"],
"sap/ui/integration/editor/fields/NumberField.js":["sap/m/Input.js","sap/ui/integration/editor/fields/BaseField.js"],
"sap/ui/integration/editor/fields/StringField.js":["sap/base/util/deepClone.js","sap/base/util/each.js","sap/base/util/includes.js","sap/base/util/restricted/_debounce.js","sap/m/Button.js","sap/m/ComboBox.js","sap/m/CustomListItem.js","sap/m/Input.js","sap/m/List.js","sap/m/OverflowToolbar.js","sap/m/Popover.js","sap/m/Select.js","sap/m/Text.js","sap/m/Title.js","sap/m/ToolbarSpacer.js","sap/m/VBox.js","sap/ui/core/Core.js","sap/ui/core/CustomData.js","sap/ui/core/ListItem.js","sap/ui/core/SeparatorItem.js","sap/ui/integration/editor/EditorResourceBundles.js","sap/ui/integration/editor/fields/BaseField.js","sap/ui/model/Sorter.js","sap/ui/model/json/JSONModel.js"],
"sap/ui/integration/editor/fields/viz/ColorSelect.js":["sap/base/util/merge.js","sap/m/Button.js","sap/m/ColorPalettePopover.js","sap/ui/core/Control.js","sap/ui/core/Core.js","sap/ui/core/theming/Parameters.js"],
"sap/ui/integration/editor/fields/viz/IconSelect.js":["sap/base/util/deepClone.js","sap/base/util/merge.js","sap/m/Select.js","sap/ui/core/Control.js","sap/ui/core/Core.js","sap/ui/core/IconPool.js","sap/ui/core/ListItem.js","sap/ui/model/json/JSONModel.js"],
"sap/ui/integration/editor/fields/viz/ShapeSelect.js":["sap/base/util/merge.js","sap/m/SegmentedButton.js","sap/m/SegmentedButtonItem.js","sap/ui/core/Control.js","sap/ui/core/Core.js","sap/ui/core/theming/Parameters.js"],
"sap/ui/integration/formatters/DateTimeFormatter.js":["sap/ui/core/date/UniversalDate.js","sap/ui/core/format/DateFormat.js","sap/ui/integration/util/Utils.js"],
"sap/ui/integration/formatters/IconFormatter.js":["sap/ui/base/ManagedObject.js","sap/ui/core/Core.js","sap/ui/core/IconPool.js"],
"sap/ui/integration/formatters/NumberFormatter.js":["sap/ui/core/format/NumberFormat.js","sap/ui/integration/util/Utils.js"],
"sap/ui/integration/formatters/TextFormatter.js":["sap/base/strings/formatMessage.js"],
"sap/ui/integration/library.js":["sap/f/library.js","sap/m/library.js","sap/ui/Global.js","sap/ui/base/DataType.js","sap/ui/core/library.js"],
"sap/ui/integration/model/ContextModel.js":["sap/base/Log.js","sap/ui/integration/util/Utils.js","sap/ui/model/json/JSONModel.js"],
"sap/ui/integration/model/ObservableModel.js":["sap/base/util/deepClone.js","sap/base/util/deepEqual.js","sap/ui/model/ClientPropertyBinding.js","sap/ui/model/json/JSONModel.js"],
"sap/ui/integration/sap-ui-integration-define-nojQuery.js":["ui5loader-autoconfig.js"],
"sap/ui/integration/services/Data.js":["sap/ui/integration/services/Service.js"],
"sap/ui/integration/services/Navigation.js":["sap/ui/integration/services/Service.js"],
"sap/ui/integration/util/BaseFactory.js":["sap/base/util/merge.js","sap/ui/base/Object.js","sap/ui/integration/util/BindingHelper.js"],
"sap/ui/integration/util/BindingHelper.js":["sap/base/util/extend.js","sap/base/util/isPlainObject.js","sap/ui/base/BindingParser.js","sap/ui/integration/bindingFeatures/DateRange.js","sap/ui/integration/formatters/DateTimeFormatter.js","sap/ui/integration/formatters/NumberFormatter.js","sap/ui/integration/formatters/TextFormatter.js"],
"sap/ui/integration/util/BindingResolver.js":["sap/base/Log.js","sap/base/util/extend.js","sap/base/util/isPlainObject.js","sap/ui/base/ManagedObject.js","sap/ui/integration/util/BindingHelper.js","sap/ui/model/Model.js"],
"sap/ui/integration/util/CacheAndRequestDataProvider.js":["sap/base/Log.js","sap/base/util/merge.js","sap/ui/core/Core.js","sap/ui/integration/util/RequestDataProvider.js"],
"sap/ui/integration/util/CardMerger.js":["sap/base/util/deepClone.js","sap/base/util/merge.js","sap/ui/core/Core.js","sap/ui/model/json/JSONModel.js"],
"sap/ui/integration/util/CardObserver.js":["sap/ui/base/Object.js","sap/ui/integration/library.js"],
"sap/ui/integration/util/ContentFactory.js":["sap/ui/integration/cards/AdaptiveContent.js","sap/ui/integration/cards/AnalyticalContent.js","sap/ui/integration/cards/AnalyticsCloudContent.js","sap/ui/integration/cards/CalendarContent.js","sap/ui/integration/cards/ComponentContent.js","sap/ui/integration/cards/ListContent.js","sap/ui/integration/cards/ObjectContent.js","sap/ui/integration/cards/TableContent.js","sap/ui/integration/cards/TimelineContent.js","sap/ui/integration/cards/WebPageContent.js","sap/ui/integration/cards/actions/CardActions.js","sap/ui/integration/util/BaseFactory.js"],
"sap/ui/integration/util/CsrfTokenHandler.js":["sap/base/util/isPlainObject.js","sap/base/util/merge.js","sap/ui/base/Object.js","sap/ui/model/json/JSONModel.js"],
"sap/ui/integration/util/DataProvider.js":["sap/ui/base/ManagedObject.js"],
"sap/ui/integration/util/DataProviderFactory.js":["sap/ui/base/Object.js","sap/ui/integration/util/BindingHelper.js","sap/ui/integration/util/CacheAndRequestDataProvider.js","sap/ui/integration/util/CsrfTokenHandler.js","sap/ui/integration/util/DataProvider.js","sap/ui/integration/util/ExtensionDataProvider.js","sap/ui/integration/util/JSONBindingHelper.js","sap/ui/integration/util/RequestDataProvider.js","sap/ui/integration/util/ServiceDataProvider.js"],
"sap/ui/integration/util/Destinations.js":["sap/base/Log.js","sap/ui/base/Object.js","sap/ui/integration/util/Utils.js"],
"sap/ui/integration/util/ExtensionDataProvider.js":["sap/ui/integration/util/DataProvider.js"],
"sap/ui/integration/util/HeaderFactory.js":["sap/base/strings/formatMessage.js","sap/ui/integration/cards/Header.js","sap/ui/integration/cards/NumericHeader.js","sap/ui/integration/cards/actions/CardActions.js","sap/ui/integration/library.js","sap/ui/integration/util/BaseFactory.js"],
"sap/ui/integration/util/JSONBindingHelper.js":["sap/ui/base/BindingParser.js","sap/ui/integration/util/BindingHelper.js"],
"sap/ui/integration/util/LoadingProvider.js":["sap/f/cards/loading/GenericPlaceholder.js","sap/f/cards/loading/ListPlaceholder.js","sap/ui/core/Element.js","sap/ui/integration/cards/ListContentRenderer.js","sap/ui/integration/library.js"],
"sap/ui/integration/util/Manifest.js":["sap/base/Log.js","sap/base/util/deepClone.js","sap/base/util/isEmptyObject.js","sap/base/util/isPlainObject.js","sap/ui/base/Object.js","sap/ui/core/Manifest.js","sap/ui/integration/util/CardMerger.js","sap/ui/integration/util/ParameterMap.js"],
"sap/ui/integration/util/ManifestResolver.js":["sap/ui/integration/util/BindingHelper.js","sap/ui/integration/util/BindingResolver.js","sap/ui/integration/util/Utils.js"],
"sap/ui/integration/util/ParameterMap.js":["sap/ui/core/Core.js"],
"sap/ui/integration/util/RequestDataProvider.js":["sap/base/Log.js","sap/ui/integration/util/DataProvider.js","sap/ui/model/odata/v4/ODataUtils.js","sap/ui/thirdparty/jquery.js"],
"sap/ui/integration/util/ServiceDataProvider.js":["sap/ui/integration/util/DataProvider.js"],
"sap/ui/integration/util/ServiceManager.js":["sap/base/Log.js","sap/ui/base/EventProvider.js"],
"sap/ui/integration/util/SkeletonCard.js":["sap/ui/integration/util/ManifestResolver.js","sap/ui/integration/widgets/Card.js"],
"sap/ui/integration/util/Utils.js":["sap/base/Log.js","sap/base/util/isPlainObject.js","sap/ui/core/Locale.js"],
"sap/ui/integration/widgets/Card.js":["sap/base/Log.js","sap/base/util/LoaderExtensions.js","sap/base/util/deepEqual.js","sap/base/util/merge.js","sap/f/CardBase.js","sap/f/library.js","sap/m/HBox.js","sap/m/Text.js","sap/ui/base/Interface.js","sap/ui/core/Core.js","sap/ui/core/Icon.js","sap/ui/integration/cards/Footer.js","sap/ui/integration/cards/actions/CardActions.js","sap/ui/integration/cards/filters/FilterBarFactory.js","sap/ui/integration/controls/ActionsToolbar.js","sap/ui/integration/formatters/IconFormatter.js","sap/ui/integration/library.js","sap/ui/integration/model/ContextModel.js","sap/ui/integration/model/ObservableModel.js","sap/ui/integration/util/BindingResolver.js","sap/ui/integration/util/CardObserver.js","sap/ui/integration/util/ContentFactory.js","sap/ui/integration/util/DataProviderFactory.js","sap/ui/integration/util/Destinations.js","sap/ui/integration/util/HeaderFactory.js","sap/ui/integration/util/LoadingProvider.js","sap/ui/integration/util/Manifest.js","sap/ui/integration/util/ServiceManager.js","sap/ui/integration/widgets/CardRenderer.js","sap/ui/model/json/JSONModel.js","sap/ui/model/resource/ResourceModel.js","sap/ui/thirdparty/jquery.js"],
"sap/ui/integration/widgets/CardRenderer.js":["sap/f/CardRenderer.js"]
}});
//# sourceMappingURL=library-h2-preload.js.map