/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(["sap/ui/base/Object","sap/ui/core/IconPool","sap/m/library","sap/m/OverflowToolbarLayoutData","sap/ui/core/InvisibleText"],function(B,I,m,O,a){"use strict";var b=m.OverflowToolbarPriority;var c=m.ButtonType;var S=B.extend("sap.f.semantic.SemanticConfiguration",{getInterface:function(){return this;}});S._Placement={titleText:"titleText",titleIcon:"titleIcon",footerLeft:"footerLeft",footerRight:"footerRight",shareMenu:"shareMenu"};S.isKnownSemanticType=function(t){return S.getConfiguration(t)!==null;};S.getConfiguration=function(t){return S._oTypeConfigs[t]||null;};S.getSettings=function(t){if(S.isKnownSemanticType(t)){return S._oTypeConfigs[t].getSettings();}return null;};S.getConstraints=function(t){if(S.isKnownSemanticType(t)){return S._oTypeConfigs[t].constraints||null;}return null;};S.getPlacement=function(t){if(S.isKnownSemanticType(t)){return S._oTypeConfigs[t].placement;}return null;};S.getOrder=function(t){if(S.isKnownSemanticType(t)){return S._oTypeConfigs[t].order;}return null;};S.shouldBePreprocessed=function(t){if(S.isKnownSemanticType(t)){return S._oTypeConfigs[t].needPreprocesing||false;}return false;};S.isMainAction=function(t){if(S.isKnownSemanticType(t)){return S._oTypeConfigs[t].mainAction||false;}return false;};S.isNavigationAction=function(t){if(S.isKnownSemanticType(t)){return S._oTypeConfigs[t].navigation||false;}return false;};S._oTypeConfigs=(function(){var t={},o=sap.ui.getCore().getLibraryResourceBundle("sap.f");t["sap.f.semantic.TitleMainAction"]={placement:S._Placement.titleText,order:0,mainAction:true,getSettings:function(){return{type:c.Emphasized,layoutData:new O({priority:b.NeverOverflow})};}};t["sap.f.semantic.EditAction"]={placement:S._Placement.titleText,order:1,getSettings:function(){return{text:o.getText("SEMANTIC_CONTROL_EDIT"),tooltip:o.getText("SEMANTIC_CONTROL_EDIT"),type:c.Transparent};}};t["sap.f.semantic.DeleteAction"]={placement:S._Placement.titleText,order:2,getSettings:function(){return{text:o.getText("SEMANTIC_CONTROL_DELETE"),type:c.Transparent};}};t["sap.f.semantic.CopyAction"]={placement:S._Placement.titleText,order:3,getSettings:function(){return{text:o.getText("SEMANTIC_CONTROL_COPY"),type:c.Transparent};}};t["sap.f.semantic.AddAction"]={placement:S._Placement.titleText,order:4,getSettings:function(){return{text:o.getText("SEMANTIC_CONTROL_ADD"),tooltip:o.getText("SEMANTIC_CONTROL_ADD"),type:c.Transparent};}};t["sap.f.semantic.FavoriteAction"]={placement:S._Placement.titleIcon,order:0,constraints:"IconOnly",getSettings:function(){return{icon:I.getIconURI("favorite"),text:o.getText("SEMANTIC_CONTROL_FAVORITE"),type:c.Transparent};}};t["sap.f.semantic.FlagAction"]={placement:S._Placement.titleIcon,order:1,constraints:"IconOnly",getSettings:function(){return{icon:I.getIconURI("flag"),text:o.getText("SEMANTIC_CONTROL_FLAG"),type:c.Transparent};}};t["sap.f.semantic.FullScreenAction"]={placement:S._Placement.titleIcon,order:0,constraints:"IconOnly",navigation:true,getSettings:function(){return{icon:I.getIconURI("full-screen"),tooltip:o.getText("SEMANTIC_CONTROL_FULL_SCREEN"),layoutData:new O({priority:b.NeverOverflow}),type:c.Transparent};}};t["sap.f.semantic.ExitFullScreenAction"]={placement:S._Placement.titleIcon,order:1,constraints:"IconOnly",navigation:true,getSettings:function(){return{icon:I.getIconURI("exit-full-screen"),tooltip:o.getText("SEMANTIC_CONTROL_EXIT_FULL_SCREEN"),layoutData:new O({priority:b.NeverOverflow}),type:c.Transparent};}};t["sap.f.semantic.CloseAction"]={placement:S._Placement.titleIcon,order:2,constraints:"IconOnly",navigation:true,getSettings:function(){return{icon:I.getIconURI("decline"),tooltip:o.getText("SEMANTIC_CONTROL_CLOSE"),layoutData:new O({priority:b.NeverOverflow}),type:c.Transparent};}};t["sap.f.semantic.MessagesIndicator"]={placement:S._Placement.footerLeft,order:0,mainAction:false,getSettings:function(){var T=a.getStaticId("sap.f","SEMANTIC_CONTROL_MESSAGES_INDICATOR");return{icon:I.getIconURI("message-popup"),text:{path:"message>/",formatter:function(M){return M.length||0;}},tooltip:o.getText("SEMANTIC_CONTROL_MESSAGES_INDICATOR"),ariaLabelledBy:T,type:c.Emphasized,visible:{path:"message>/",formatter:function(M){return M&&M.length>0;}},models:{message:sap.ui.getCore().getMessageManager().getMessageModel()},layoutData:new O({priority:b.NeverOverflow})};}};t["sap.m.DraftIndicator"]={placement:S._Placement.footerRight,order:0,needPreprocesing:true,mainAction:false,getSettings:function(){return{layoutData:new O({shrinkable:false})};}};t["sap.f.semantic.FooterMainAction"]={placement:S._Placement.footerRight,order:1,mainAction:true,getSettings:function(){return{type:c.Emphasized,text:o.getText("SEMANTIC_CONTROL_SAVE"),layoutData:new O({priority:b.NeverOverflow})};}};t["sap.f.semantic.PositiveAction"]={placement:S._Placement.footerRight,order:2,mainAction:false,getSettings:function(){return{type:c.Accept,text:o.getText("SEMANTIC_CONTROL_ACCEPT"),layoutData:new O({priority:b.NeverOverflow})};}};t["sap.f.semantic.NegativeAction"]={placement:S._Placement.footerRight,order:3,mainAction:false,getSettings:function(){return{type:c.Reject,text:o.getText("SEMANTIC_CONTROL_REJECT"),layoutData:new O({priority:b.NeverOverflow})};}};t["sap.f.semantic.SendEmailAction"]={placement:S._Placement.shareMenu,order:0,constraints:"IconOnly",getSettings:function(){return{icon:I.getIconURI("email"),text:o.getText("SEMANTIC_CONTROL_SEND_EMAIL"),type:c.Transparent};}};t["sap.f.semantic.DiscussInJamAction"]={placement:S._Placement.shareMenu,order:1,constraints:"IconOnly",getSettings:function(){return{icon:I.getIconURI("discussion-2"),text:o.getText("SEMANTIC_CONTROL_DISCUSS_IN_JAM"),type:c.Transparent};}};t["sap.f.semantic.ShareInJamAction"]={placement:S._Placement.shareMenu,order:2,constraints:"IconOnly",getSettings:function(){return{icon:I.getIconURI("share-2"),text:o.getText("SEMANTIC_CONTROL_SHARE_IN_JAM"),type:c.Transparent};}};t["sap.f.semantic.SendMessageAction"]={placement:S._Placement.shareMenu,order:3,constraints:"IconOnly",getSettings:function(){return{icon:I.getIconURI("discussion"),text:o.getText("SEMANTIC_CONTROL_SEND_MESSAGE"),type:c.Transparent};}};t["saveAsTileAction"]={placement:S._Placement.shareMenu,order:4,constraints:"IconOnly"};t["sap.f.semantic.PrintAction"]={placement:S._Placement.shareMenu,order:5,constraints:"IconOnly",getSettings:function(){return{icon:I.getIconURI("print"),text:o.getText("SEMANTIC_CONTROL_PRINT"),type:c.Transparent};}};return t;})();return S;});
