/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['./Button','./Dialog','./Text','./FormattedText','./Link','./VBox','sap/ui/core/IconPool','sap/ui/core/ElementMetadata','sap/ui/core/library','sap/ui/core/Control','sap/m/library',"sap/ui/thirdparty/jquery"],function(B,D,T,F,L,V,I,E,c,C,l,q){"use strict";var a=l.DialogType;var b=l.DialogRoleType;var d=c.TextDirection;var e=l.ButtonType;var f=l.TitleAlignment;var M={};M.Action={OK:"OK",CANCEL:"CANCEL",YES:"YES",NO:"NO",ABORT:"ABORT",RETRY:"RETRY",IGNORE:"IGNORE",CLOSE:"CLOSE",DELETE:"DELETE"};M.Icon={NONE:undefined,INFORMATION:"INFORMATION",WARNING:"WARNING",ERROR:"ERROR",SUCCESS:"SUCCESS",QUESTION:"QUESTION"};(function(){var A=M.Action,g=M.Icon;var _=function(){if(M._rb!==sap.ui.getCore().getLibraryResourceBundle("sap.m")){M._rb=sap.ui.getCore().getLibraryResourceBundle("sap.m");}};M.show=function(m,o){var h,j,v,r=null,k=[],i,s,t,n,p,u,w,x={id:E.uid("mbox"),initialFocus:null,textDirection:d.Inherit,verticalScrolling:true,horizontalScrolling:true,details:"",contentWidth:null},y={"INFORMATION":"sapMMessageBoxInfo","WARNING":"sapMMessageBoxWarning","ERROR":"sapMMessageBoxError","SUCCESS":"sapMMessageBoxSuccess","QUESTION":"sapMMessageBoxQuestion","STANDARD":"sapMMessageBoxStandard"},z={"INFORMATION":I.getIconURI("information"),"WARNING":I.getIconURI("alert"),"ERROR":I.getIconURI("error"),"SUCCESS":I.getIconURI("sys-enter-2"),"QUESTION":I.getIconURI("sys-help-2")};_();if(typeof o==="string"||arguments.length>2){s=arguments[1];t=arguments[2];n=arguments[3];p=arguments[4];u=arguments[5];w=arguments[6];o={icon:s,title:t,actions:n,onClose:p,id:u,styleClass:w};}if(o&&o.hasOwnProperty("details")){x.icon=g.INFORMATION;x.emphasizedAction=A.OK;x.actions=[A.OK,A.CANCEL];o=q.extend({},x,o);}o=q.extend({},x,o);if(typeof o.actions!=="undefined"&&!Array.isArray(o.actions)){if(o.emphasizedAction!==null){o.emphasizedAction=o.actions;}o.actions=[o.actions];}if(!o.actions||o.actions.length===0){o.emphasizedAction=A.OK;o.actions=[A.OK];}function G(O,H){var P;if(M.Action.hasOwnProperty(O)){P=M._rb.getText("MSGBOX_"+O);}var Q=new B({id:E.uid("mbox-btn-"),text:P||O,type:H,press:function(){r=O;h.close();}});return Q;}var H;for(i=0;i<o.actions.length;i++){H=o.emphasizedAction===o.actions[i]?e.Emphasized:e.Default;k.push(G(o.actions[i],H));}function J(o,j){var O,S,P=new V({items:[j]});if(!o.details){return P;}if(typeof o.details=='object'){o.details="<pre>"+JSON.stringify(o.details,null,'\t').replace(/{/gi,"&#x007B;")+"</pre>";}O=new F().setVisible(false).setHtmlText(o.details);S=new L({text:M._rb.getText("MSGBOX_LINK_TITLE"),press:function(){var Q=h.getInitialFocus();h.addAriaLabelledBy(O);O.setVisible(true);S.setVisible(false);h._setInitialFocus();if(!Q||Q===S.getId()){k[0].focus();}}});S.addStyleClass("sapMMessageBoxLinkText");O.addStyleClass("sapMMessageBoxDetails");P.addItem(S);P.addItem(O);return P;}function K(){if(typeof o.onClose==="function"){o.onClose(r);}h.detachAfterClose(K);h.destroy();}function N(){var i=0;var O=null;if(o.initialFocus){if(o.initialFocus instanceof C){O=o.initialFocus;}if(typeof o.initialFocus==="string"){for(i=0;i<k.length;i++){if(M.Action.hasOwnProperty(o.initialFocus)){if(M._rb.getText("MSGBOX_"+o.initialFocus).toLowerCase()===k[i].getText().toLowerCase()){O=k[i];break;}}else{if(o.initialFocus.toLowerCase()===k[i].getText().toLowerCase()){O=k[i];break;}}}}}return O;}if(typeof(m)==="string"){v=new T({textDirection:o.textDirection}).setText(m).addStyleClass("sapMMsgBoxText");j=v;}else if(m instanceof C){v=m.addStyleClass("sapMMsgBoxText");}if(o&&o.hasOwnProperty("details")&&o.details!==""){v=J(o,v);}h=new D({id:o.id,type:a.Message,title:o.title,titleAlignment:f.Auto,content:v,icon:z[o.icon],initialFocus:N(),verticalScrolling:o.verticalScrolling,horizontalScrolling:o.horizontalScrolling,afterClose:K,buttons:k,ariaLabelledBy:j?j.getId():undefined,contentWidth:o.contentWidth,closeOnNavigation:o.closeOnNavigation}).addStyleClass("sapMMessageBox");h.setProperty("role",b.AlertDialog);if(y[o.icon]){h.addStyleClass(y[o.icon]);}else{h.addStyleClass(y.STANDARD);}if(o.styleClass){h.addStyleClass(o.styleClass);}h.open();};M.alert=function(m,o){_();var h={icon:g.NONE,title:M._rb.getText("MSGBOX_TITLE_ALERT"),emphasizedAction:o&&o.actions?null:A.OK,actions:A.OK,id:E.uid("alert"),initialFocus:null},i,t,s,S;if(typeof o==="function"||arguments.length>2){i=arguments[1];t=arguments[2];s=arguments[3];S=arguments[4];o={onClose:i,title:t,id:s,styleClass:S};}o=q.extend({},h,o);return M.show(m,o);};M.confirm=function(m,o){_();var h={icon:g.QUESTION,title:M._rb.getText("MSGBOX_TITLE_CONFIRM"),emphasizedAction:o&&o.actions?null:A.OK,actions:[A.OK,A.CANCEL],id:E.uid("confirm"),initialFocus:null},i,t,s,S;if(typeof o==="function"||arguments.length>2){i=arguments[1];t=arguments[2];s=arguments[3];S=arguments[4];o={onClose:i,title:t,id:s,styleClass:S};}o=q.extend({},h,o);return M.show(m,o);};M.error=function(m,o){_();var h={icon:g.ERROR,title:M._rb.getText("MSGBOX_TITLE_ERROR"),emphasizedAction:null,actions:A.CLOSE,id:E.uid("error"),initialFocus:null};o=q.extend({},h,o);return M.show(m,o);};M.information=function(m,o){_();var h={icon:g.INFORMATION,title:M._rb.getText("MSGBOX_TITLE_INFO"),emphasizedAction:o&&o.actions?null:A.OK,actions:A.OK,id:E.uid("info"),initialFocus:null};o=q.extend({},h,o);return M.show(m,o);};M.warning=function(m,o){_();var h={icon:g.WARNING,title:M._rb.getText("MSGBOX_TITLE_WARNING"),emphasizedAction:o&&o.actions?null:A.OK,actions:A.OK,id:E.uid("warning"),initialFocus:null};o=q.extend({},h,o);return M.show(m,o);};M.success=function(m,o){_();var h={icon:g.SUCCESS,title:M._rb.getText("MSGBOX_TITLE_SUCCESS"),emphasizedAction:o&&o.actions?null:A.OK,actions:A.OK,id:E.uid("success"),initialFocus:null};o=q.extend({},h,o);return M.show(m,o);};}());return M;},true);
