/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['./library','sap/ui/core/Control','sap/ui/core/library','sap/m/Text','sap/ui/events/KeyCodes','./ObjectAttributeRenderer','sap/base/Log','sap/ui/base/ManagedObjectObserver','sap/ui/core/Core'],function(l,C,c,T,K,O,L,M,a){"use strict";var b=c.TextDirection;var E=l.EmptyIndicatorMode;var A=c.aria.HasPopup;var d=C.extend("sap.m.ObjectAttribute",{metadata:{library:"sap.m",designtime:"sap/m/designtime/ObjectAttribute.designtime",properties:{title:{type:"string",group:"Misc",defaultValue:null},text:{type:"string",group:"Misc",defaultValue:null},active:{type:"boolean",group:"Misc",defaultValue:null},textDirection:{type:"sap.ui.core.TextDirection",group:"Appearance",defaultValue:b.Inherit},ariaHasPopup:{type:"sap.ui.core.aria.HasPopup",group:"Accessibility",defaultValue:A.None}},aggregations:{customContent:{type:"sap.ui.core.Control",multiple:false},_textControl:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},events:{press:{parameters:{domRef:{type:"string"}}}},dnd:{draggable:true,droppable:false}}});d.prototype.init=function(){this.setAggregation('_textControl',new T());};d.prototype.exit=function(){if(this._oCustomContentObserver){this._oCustomContentObserver.disconnect();this._oCustomContentObserver=null;}if(this._oCustomContentCloning){this._oCustomContentCloning.destroy();}};d.prototype._getUpdatedTextControl=function(){var o=this._oCustomContentCloning||this.getAggregation('_textControl'),t=this.getTitle(),s=this.getAggregation('customContent')?this.getAggregation('customContent').getText():this.getText(),e=this.getTextDirection(),p=this.getParent(),P=sap.ui.getCore().getConfiguration().getRTL(),m,w=true,f='',g=sap.ui.getCore(),r;this._bEmptyIndicatorMode=this._isEmptyIndicatorMode();if(e===b.LTR&&P){f='\u200e';}if(e===b.RTL&&!P){f='\u200f';}s=f+s+f;if(t){r=t;if(g.getConfiguration().getLocale().getLanguage().toLowerCase()==="fr"){r+=" ";}r+=": "+s;}else{r=s;}if(this._bEmptyIndicatorMode){this.getAggregation('_textControl').setProperty("emptyIndicatorMode",E.On,true);}o.setProperty('text',r,true);o.setProperty('textDirection',e,true);if(p instanceof sap.m.ObjectListItem){w=false;m=O.MAX_LINES.SINGLE_LINE;}this._setControlWrapping(o,w,m);return o;};d.prototype._isEmptyIndicatorMode=function(){var o=this.getAggregation('customContent');return o&&o.getEmptyIndicatorMode()!==E.Off&&!o.getText();};d.prototype._setControlWrapping=function(o,w,m){if(o.isA("sap.m.Link")){o.setProperty('wrapping',w,true);}if(o.isA("sap.m.Text")){o.setProperty('maxLines',m,true);}};d.prototype.ontap=function(e){var t=e.target;t=t.id?t:t.parentElement;if(this._isSimulatedLink()&&(t.id===this.getId()+"-text")){this.firePress({domRef:this.getDomRef()});}};d.prototype.onsapenter=function(e){if(this._isSimulatedLink()){this.firePress({domRef:this.getDomRef()});e.setMarked();}};d.prototype.onsapspace=function(e){e.preventDefault();};d.prototype.onkeyup=function(e){if(e.which===K.SPACE){this.onsapenter(e);}};d.prototype._isEmpty=function(){if(this.getAggregation('customContent')&&!(this.getAggregation('customContent').isA("sap.m.Link")||this.getAggregation('customContent').isA("sap.m.Text"))){L.warning("Only sap.m.Link or sap.m.Text are allowed in \"sap.m.ObjectAttribute.customContent\" aggregation");return true;}return!(this.getText().trim()||this.getTitle().trim());};d.prototype.ontouchstart=function(e){if(this._isSimulatedLink()){e.originalEvent._sapui_handledByControl=true;}};d.prototype.getPopupAnchorDomRef=function(){return this.getDomRef("text");};d.prototype._isSimulatedLink=function(){return(this.getActive()&&this.getText()!=="")&&!this.getAggregation('customContent');};d.prototype.setCustomContent=function(o){var e=this.getCustomContent();if(this._oCustomContentCloning){this._oCustomContentCloning.destroy();}this._oCustomContentCloning=o&&o.clone();if(!this._oCustomContentObserver){this._oCustomContentObserver=new M(function(){this.invalidate();}.bind(this));}if(e){this._oCustomContentObserver.unobserve(e);}o&&this._oCustomContentObserver.observe(o,{properties:true});return this.setAggregation('customContent',o);};d.prototype._isClickable=function(){return(this.getActive()&&this.getText()!=="")||(this.getAggregation('customContent')&&this.getAggregation('customContent').isA('sap.m.Link'));};return d;});
