/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['sap/ui/unified/calendar/CalendarDate','sap/ui/unified/calendar/CalendarUtils','sap/ui/core/date/UniversalDate','sap/ui/core/IconPool','sap/ui/core/InvisibleText','./PlanningCalendarLegend','sap/ui/unified/library'],function(C,a,U,I,b,P,u){"use strict";var v=0.125;var A=0.125;var c=0.0625;var d=u.CalendarDayType;var S={apiVersion:2};S.render=function(r,o){r.openStart("div",o);r.class("sapMSinglePCGrid");r.openEnd();r.renderControl(o.getAggregation("_columnHeaders"));this.renderBlockersContainer(r,o);r.openStart("div");r.attr("role","grid");r.class("sapMSinglePCGridContent");r.openEnd();this.renderRowHeaders(r,o);this.renderNowMarker(r,o);this.renderColumns(r,o);r.close("div");r.close("div");};S.renderBlockersContainer=function(r,o){var e=o._getColumns(),m=o._getBlockersToRender().iMaxlevel,s=o.getStartDate(),f=(m+1)*o._getBlockerRowHeight()+0.1875,F=o._getDateFormatter(),g=o._getSpecialDates(),h=C.fromLocalJSDate(s),D=o._getColumnHeaders()._getDateTypes(h),t,l;r.openStart("div");r.attr("role","grid");r.class("sapMSinglePCBlockersRow");r.openEnd();r.openStart("div");r.attr("role","row");r.class("sapMSinglePCBlockersColumns");if(g&&o._getColumns()===1){if(D&&D[0]){t=D[0];r.class("sapUiCalItem"+t.type);l=P.findLegendItemForItem(sap.ui.getCore().byId(o._sLegendId),t);}r.class("sapMSpecialDaysInDayView");}r.style("height",f+"rem");r.openEnd();this.renderDndPlaceholders(r,o,o.getAggregation("_blockersPlaceholders"));for(var i=0;i<e;i++){var j=new C(s.getFullYear(),s.getMonth(),s.getDate()+i);r.openStart("div");r.attr("role","gridcell");r.attr("data-sap-start-date",F.format(j.toLocalJSDate()));r.attr("data-sap-end-date",F.format(j.toLocalJSDate()));r.attr("aria-labelledby",b.getStaticId("sap.m","SPC_BLOCKERS")+" "+"fullDay-"+F.format(j.toLocalJSDate())+"-Descr");r.class("sapMSinglePCBlockersColumn");r.attr("tabindex",-1);if(j.isSame(new C())){r.class("sapMSinglePCBlockersColumnToday");}if(a._isWeekend(j,o._getCoreLocaleData())){r.class("sapMSinglePCBlockersColumnWeekend");}r.openEnd();r.openStart("span","fullDay-"+F.format(j.toLocalJSDate())+"-Descr");r.class("sapUiInvisibleText");r.openEnd();r.text(o._getCellStartEndInfo(j.toLocalJSDate()));if(o._sLegendId&&l){r.text(l);}r.close("span");r.close("div");}this.renderBlockers(r,o);r.close("div");r.close("div");};S.renderBlockers=function(r,o){var t=this,B=o._getBlockersToRender().oBlockersList;r.openStart("div");r.attr("role","list");r.attr("aria-labelledby",b.getStaticId("sap.m","SPC_BLOCKERS"));r.class("sapMSinglePCBlockers");r.class("sapUiCalendarRowVisFilled");r.openEnd();B.getIterator().forEach(function(e){t.renderBlockerAppointment(r,o,e);});r.close("div");};S.renderBlockerAppointment=function(r,o,B){var g=C.fromLocalJSDate(o.getStartDate()),e=B.getData(),f=C.fromLocalJSDate(e.getStartDate()),h=C.fromLocalJSDate(e.getEndDate()),s=a._daysBetween(f,g),E=a._daysBetween(h,g),i=o._getColumns(),R=o._getBlockerRowHeight(),j=B.level,k=B.width,t=e.getTooltip_AsString(),T=e.getType(),l=e.getColor(),m=e.getTitle(),n=e.getText(),p=e.getIcon(),q=e.getId(),w={role:"listitem",labelledby:{value:b.getStaticId("sap.ui.unified","APPOINTMENT"),append:true},selected:null},x=o.getAriaLabelledBy(),L=s*(100/i),y=(i-E-1)*(100/i),z=sap.ui.getCore().getConfiguration().getRTL(),D;if(x.length>0){w["labelledby"].value=w["labelledby"].value+" "+x.join(" ");}if(m){w["labelledby"].value=w["labelledby"].value+" "+q+"-Title";}w["labelledby"].value=w["labelledby"].value+" "+q+"-Descr";if(n){w["labelledby"].value=w["labelledby"].value+" "+q+"-Text";}if(e.getTentative()){w["labelledby"].value=w["labelledby"].value+" "+b.getStaticId("sap.ui.unified","APPOINTMENT_TENTATIVE");}if(e.getSelected()){w["labelledby"].value=w["labelledby"].value+" "+b.getStaticId("sap.ui.unified","APPOINTMENT_SELECTED");}r.openStart("div",e);r.attr("data-sap-level",j);r.attr("data-sap-width",k);r.attr("tabindex",0);if(t){r.attr("title",t);}r.accessibilityState(e,w);r.class("sapMSinglePCAppointmentWrap");r.class("sapUiCalendarRowApps");if(!l&&T!==d.None){r.class("sapUiCalendarApp"+T);}if(l){if(sap.ui.getCore().getConfiguration().getRTL()){r.style("border-right-color",l);}else{r.style("border-left-color",l);}}r.style("top",R*j+0.0625+"rem");r.style(z?"right":"left",Math.max(L,0)+"%");r.style(z?"left":"right",Math.max(y,0)+"%");r.openEnd();r.openStart("div");r.class("sapUiCalendarApp");if(e.getSelected()){r.class("sapUiCalendarAppSel");}if(e.getTentative()){r.class("sapUiCalendarAppTent");}if(p){r.class("sapUiCalendarAppWithIcon");}r.openEnd();r.openStart("div");r.class("sapUiCalendarAppCont");if(l){r.style("background-color",e._getCSSColorForBackground(l));}r.openEnd();if(L<0){D=["sapUiCalendarAppArrowIconLeft","sapUiCalendarAppArrowIcon"];r.icon("sap-icon://arrow-left",D,{title:null,role:"img"});}if(p){D=["sapUiCalendarAppIcon"];var F={};F["id"]=q+"-Icon";F["title"]=null;F["role"]="img";r.icon(p,D,F);}if(m){r.openStart("span",q+"-Title");r.class("sapUiCalendarAppTitle");r.openEnd();r.text(m,true);r.close("span");}if(y<0){D=["sapUiCalendarAppArrowIconRight","sapUiCalendarAppArrowIcon"];r.icon("sap-icon://arrow-right",D,{title:null,role:"img"});}r.openStart("span",q+"-Descr");r.class("sapUiInvisibleText");r.openEnd();r.text(o._getAppointmentAnnouncementInfo(e));r.close("span");r.close("div");r.close("div");r.close("div");};S.renderRowHeaders=function(r,o){var s=o._getVisibleStartHour(),e=o._getVisibleEndHour(),f=new Date(),h=o._getHoursFormat(),g=o._getAMPMFormat();r.openStart("div");r.class("sapMSinglePCRowHeaders");r.openEnd();for(var i=s;i<=e;i++){f.setHours(i);r.openStart("span");r.class("sapMSinglePCRowHeader");r.class("sapMSinglePCRowHeader"+i);if(o._shouldHideRowHeader(i)){r.class("sapMSinglePCRowHeaderHidden");}r.openEnd();r.text(h.format(f));if(o._hasAMPM()){r.openStart("span");r.class("sapMSinglePCRowHeaderAMPM");r.openEnd();r.text(" "+g.format(f));r.close("span");}r.close("span");}r.close("div");};S.renderColumns=function(r,o){var e=o._getColumns(),s=o.getStartDate(),f=o._getAppointmentsToRender();r.openStart("div");r.attr("role","grid");r.attr("aria-labelledby",b.getStaticId("sap.m","SPC_APPOINTMENTS"));r.class("sapMSinglePCColumns");r.openEnd();for(var i=0;i<e;i++){var g=new C(s.getFullYear(),s.getMonth(),s.getDate()+i),F=o._getDateFormatter(),D=F.format(g.toLocalJSDate());r.openStart("div");r.attr("role","row");r.attr("data-sap-day",D);r.class("sapMSinglePCColumn");if(g.isSame(new C())){r.class("sapMSinglePCColumnToday");}if(a._isWeekend(g,o._getCoreLocaleData())){r.class("sapMSinglePCColumnWeekend");}r.openEnd();this.renderDndPlaceholders(r,o,o._dndPlaceholdersMap[g]);this.renderRows(r,o,D);this.renderAppointments(r,o,f[D],g,i);r.close("div");}r.close("div");};S.renderDndPlaceholders=function(r,o,p){r.openStart("div");r.class("sapMSinglePCOverlay");r.openEnd();p.forEach(r.renderControl,r);r.close("div");};S.renderRows=function(r,o,D){var s=o._getVisibleStartHour(),e=o._getVisibleEndHour(),f=o._getDateFormatter(),g,h;for(var i=s;i<=e;i++){g=o._parseDateStringAndHours(D,i);h=new Date(g.getFullYear(),g.getMonth(),g.getDate(),g.getHours()+1);r.openStart("div");r.attr("role","gridcell");r.class("sapMSinglePCRow");if(!o._isVisibleHour(i)){r.class("sapMSinglePCNonWorkingRow");}r.attr("data-sap-hour",i);r.attr("data-sap-start-date",f.format(g));r.attr("data-sap-end-date",f.format(h));r.attr("aria-labelledby",f.format(g)+"-Descr");r.attr("tabindex",-1);r.openEnd();r.openStart("span",f.format(g)+"-Descr");r.class("sapUiInvisibleText");r.openEnd();r.text(o._getCellStartEndInfo(g,h));r.close("span");r.close("div");}};S.renderAppointments=function(r,o,e,f,i){var t=this,g=0;if(e){r.openStart("div");r.attr("role","list");r.class("sapMSinglePCAppointments");r.class("sapUiCalendarRowVisFilled");r.openEnd();e.oAppointmentsList.getIterator().forEach(function(h){var m=e.iMaxLevel,l=h.level,w=h.width,j=h.getData();t.renderAppointment(r,o,m,l,w,j,f,i,g);g++;});r.close("div");}};S.renderAppointment=function(r,o,m,i,e,f,g,h,j){var G=C.fromLocalJSDate(o.getStartDate()),k=new C(G),R=o._getRowHeight(),l=new U(g.getYear(),g.getMonth(),g.getDate(),o._getVisibleStartHour()),n=new U(g.getYear(),g.getMonth(),g.getDate(),o._getVisibleEndHour(),59,59),p=f.getStartDate(),q=f.getEndDate(),s=C.fromLocalJSDate(p),t=C.fromLocalJSDate(q),T=f.getTooltip_AsString(),w=f.getType(),x=f.getColor(),y=f.getTitle(),z=f.getText(),B=f.getIcon(),D=f.getId(),L=this._getLineClamp(p,q),E={role:"listitem",labelledby:{value:b.getStaticId("sap.ui.unified","APPOINTMENT"),append:true},selected:null},F=o.getAriaLabelledBy(),H=l.getTime()>p.getTime(),J=n.getTime()<q.getTime(),K=H?0:o._calculateTopPosition(p),M=J?0:o._calculateBottomPosition(q),N=100/(m+1),O=f.getParent().getEnableAppointmentsDragAndDrop(),Q,V,W,X,Y;k.setDate(k.getDate()+o._getColumns()-1);Q=a._daysBetween(s,G);V=a._daysBetween(k,t);W=g.isSame(G);X=g.isSame(k);if(F.length>0){E["labelledby"].value=E["labelledby"].value+" "+F.join(" ");}if(y){E["labelledby"].value=E["labelledby"].value+" "+D+"-Title";}E["labelledby"].value=E["labelledby"].value+" "+D+"-Descr";if(z){E["labelledby"].value=E["labelledby"].value+" "+D+"-Text";}if(f.getTentative()){E["labelledby"].value=E["labelledby"].value+" "+b.getStaticId("sap.ui.unified","APPOINTMENT_TENTATIVE");}if(f.getSelected()){E["labelledby"].value=E["labelledby"].value+" "+b.getStaticId("sap.ui.unified","APPOINTMENT_SELECTED");}r.openStart("div",f.getId()+"-"+h+"_"+j);r.attr("draggable",O);r.attr("data-sap-ui-draggable",O);r.attr("data-sap-ui-related",f.getId());r.attr("data-sap-level",i);r.attr("data-sap-width",e);r.attr("tabindex",0);if(T){r.attr("title",T);}r.accessibilityState(f,E);r.class("sapMSinglePCAppointmentWrap");r.class("sapUiCalendarRowApps");if(!x&&w!==d.None){r.class("sapUiCalendarApp"+w);}if(x){if(sap.ui.getCore().getConfiguration().getRTL()){r.style("border-right-color",x);}else{r.style("border-left-color",x);}}r.style("top",K+"rem");r.style("bottom",M+"rem");r.style(sap.ui.getCore().getConfiguration().getRTL()?"right":"left",N*i+"%");r.style("width",N*e+"%");r.openEnd();r.openStart("div");r.class("sapUiCalendarApp");r.style("min-height",(R-(v+A+c))/2+"rem");if(f.getSelected()){r.class("sapUiCalendarAppSel");}if(f.getTentative()){r.class("sapUiCalendarAppTent");}if(B){r.class("sapUiCalendarAppWithIcon");}r.openEnd();r.openStart("div");r.class("sapUiCalendarAppCont");if(x){r.style("background-color",f._getCSSColorForBackground(x));}r.openEnd();if(W&&Q<0){Y=["sapUiCalendarAppArrowIconLeft","sapUiCalendarAppArrowIcon"];r.icon("sap-icon://arrow-left",Y,{title:null,role:"img"});}if(B){Y=["sapUiCalendarAppIcon"];var Z={};Z["id"]=D+"-Icon";Z["title"]=null;Z["role"]="img";r.icon(B,Y,Z);}r.openStart("div");r.class("sapUiCalendarAppTitleWrapper");r.class("sapUiSPCAppLineClamp"+L);r.openEnd();if(y){r.openStart("span",D+"-Title");r.class("sapUiCalendarAppTitle");r.openEnd();r.text(y,true);r.close("span");}if(z){r.openStart("span",D+"-Text");r.class("sapUiCalendarAppText");r.openEnd();r.text(z,true);r.close("span");}r.close("div");if(X&&V<0){Y=["sapUiCalendarAppArrowIconRight","sapUiCalendarAppArrowIcon"];r.icon("sap-icon://arrow-right",Y,{title:null,role:"img"});}r.openStart("span",D+"-Descr");r.class("sapUiInvisibleText");r.openEnd();r.text(o._getAppointmentAnnouncementInfo(f));r.close("span");r.close("div");if(o.getEnableAppointmentsResize()){this.renderResizeHandles(r,!H,!J);}r.close("div");r.close("div");};S.renderNowMarker=function(r,o){var D=new Date();r.openStart("div",o.getId()+"-nowMarker");r.style("top",o._calculateTopPosition(D)+"rem");r.class("sapMSinglePCNowMarker");if(!o._isVisibleHour(D.getHours())){r.class("sapMSinglePCNowMarkerHidden");}r.openEnd();r.openStart("span",o.getId()+"-nowMarkerText");r.class("sapMSinglePCNowMarkerText");r.openEnd();r.text(o._formatTimeAsString(D));if(o._hasAMPM()){r.openStart("span",o.getId()+"-nowMarkerAMPM");r.class("sapMSinglePCNowMarkerAMPM");r.openEnd();r.text(o._addAMPM(D));r.close("span");}r.close("span");r.close("div");};S.renderResizeHandles=function(r,R,e){if(e){r.openStart("span");r.class("sapMSinglePCAppResizeHandleBottom");r.openEnd();r.close("span");}if(R){r.openStart("span");r.class("sapMSinglePCAppResizeHandleTop");r.openEnd();r.close("span");}};S._getLineClamp=function(o,e){var m=a._minutesBetween(o,e);if(m>=51&&m<69){return"2";}else if(m>=69&&m<90){return"3";}else if(m>=90&&m<110){return"4";}else if(m>=110&&m<130){return"5";}else if(m>=130&&m<150){return"6";}else if(m>=150&&m<170){return"7";}else if(m>=170&&m<190){return"8";}else if(m>=190){return"9";}else{return"1";}};return S;},true);
