/*
 * ! OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(["sap/m/p13n/AbstractContainer","sap/m/Bar","sap/m/Button","sap/m/List","sap/m/IconTabBar","sap/m/IconTabFilter","sap/m/p13n/AbstractContainerItem","sap/ui/Device","sap/m/library","sap/m/StandardListItem","sap/m/CustomListItem","sap/ui/core/Control"],function(A,B,a,L,I,b,C,D,l,S,c,d){"use strict";var e=l.ButtonType;var f=l.ListType;var g=A.extend("sap.m.p13n.Container",{metadata:{library:"sap.m",properties:{listLayout:{type:"boolean",defaultValue:false}}},renderer:{apiVersion:2}});g.prototype.DEFAULT_KEY="$default";g.prototype.init=function(){A.prototype.init.apply(this,arguments);this.addStyleClass("sapMP13nContainer");this.setListLayout(D.system.phone);};g.prototype.setListLayout=function(h){this.setProperty("listLayout",h);this._getTabBar().removeAllItems();this._getNavigationList().removeAllItems();var H;if(h){this._getTabBar().setVisible(false);this._getNavigationList();this.switchView(this.DEFAULT_KEY);H=this._getNavBackBtn();}else{this._getTabBar().setVisible(true);var v=this.getViews();if(v.length>1){this.switchView(v[1].getKey());}H=this._getTabBar();}var o=this.getHeader();if(!o){var i=new B({contentLeft:[H]});this.setHeader(i);}else{o.removeAllContentLeft();o.addContentLeft(H);}this.getViews().forEach(function(V){this._addToNavigator(V);}.bind(this));return this;};g.prototype.switchView=function(k){A.prototype.switchView.apply(this,arguments);if(this._bPrevented){return;}var p=this.getParent();if(p&&p.isA("sap.ui.core.Control")){p.focus();p.invalidate();var h=p.getDependents();if(h){h.forEach(function(o){if(o&&o.isA("sap.ui.core.Control")){o.invalidate();}});}}this.oLayout.setShowHeader(k!==this.DEFAULT_KEY);this._getTabBar().setSelectedKey(k);this._getNavBackBtn().setVisible(k!==this.DEFAULT_KEY);this._getNavBackBtn().setText((this.getView(k)&&this.getView(k).getText())||k);};g.prototype.addView=function(o){A.prototype.addView.apply(this,arguments);this._addToNavigator(o);return this;};g.prototype.removeView=function(o){A.prototype.removeView.apply(this,arguments);this._removeFromNavigator(o);};g.prototype.addSeparator=function(){if(!this.getProperty("listLayout")){return;}var i=this._getNavigationList().getItems();var o=i[i.length-1];o.addStyleClass("sapMMenuDivider");return this;};g.prototype._getTabBar=function(){if(!this._oTabBar){this._oTabBar=new I({expandable:false,expanded:true,select:function(E){this.switchView(E.getParameter("key"));}.bind(this)});this.addDependent(this._oTabBar);}return this._oTabBar;};g.prototype._getNavigationList=function(){if(!this._oNavigationList){this._oNavigationList=new L({itemPress:function(E){var i=E.getParameter("listItem");this.switchView(i._key);}.bind(this)}).addStyleClass("p13nContainerDefaultList");this.addDependent(this._oNavigationList);}if(!this.getView(this.DEFAULT_KEY)){var o=new C({key:this.DEFAULT_KEY,content:this._oNavigationList});this.addView(o);}return this._oNavigationList;};g.prototype._getNavBackBtn=function(){if(!this._oNavBackBtn){this._oNavBackBtn=new a({type:e.Back,press:function(E){this.switchView(this.DEFAULT_KEY);}.bind(this)});this.addDependent(this._oNavBackBtn);}return this._oNavBackBtn;};g.prototype._addToNavigator=function(o){var k=o.getKey(),t=o.getText(),i=o.getIcon();if(k==this.DEFAULT_KEY){return;}if(this.getListLayout()){this.getView(this.DEFAULT_KEY);var h=new S({type:f.Navigation,icon:i,title:t});h._key=k;this._getNavigationList().addItem(h);}else{this._getTabBar().addItem(new b({key:k,text:t||k}));}};g.prototype._removeFromNavigator=function(o){var k=o.getKey();if(k==this.DEFAULT_KEY){return;}if(this.getListLayout()){var i=this._getNavigationList().getItems().find(function(h){return h._key===k;});this._getNavigationList().removeItem(i);}else{var t=this._getTabBar().getItems().find(function(t){return t.getKey()===k;});this._getTabBar().removeItem(t);}};g.prototype.exit=function(){A.prototype.exit.apply(this,arguments);if(this._oTabBar){this._oTabBar.destroy();this._oTabBar=null;}if(this._oNavigationList){this._oNavigationList.destroy();this._oNavigationList=null;}this._oNavBackBtn=null;};return g;});
