/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['./ExpressionParser','sap/ui/model/BindingMode','sap/ui/model/Filter','sap/ui/model/Sorter',"sap/base/Log","sap/base/util/JSTokenizer","sap/base/util/resolveReference"],function(E,B,F,S,L,J,r){"use strict";var a={_keepBindingStrings:false};var b=/^\{\s*('|"|)[a-zA-Z$_][a-zA-Z0-9$_]*\1\s*:/;var c=/(\\[\\\{\}])|(\{)/g;var d=/([\\\{\}])/g;function f(e,R){function l(){var i,n=e.length,m=new Array(n);for(i=0;i<n;i+=1){m[i]=e[i].apply(this,arguments);}if(R){return R.apply(this,m);}return n>1?m.join(" "):m[0];}l.textFragments=R&&R.textFragments||"sap.ui.base.BindingParser: composeFormatters";return l;}function g(e){var m=function(){var R=[],l=e.length,i;for(i=0;i<l;i++){if(typeof e[i]==="number"){R.push(arguments[e[i]]);}else{R.push(e[i]);}}return R.join('');};m.textFragments=e;return m;}function h(p){var P=p.indexOf(">"),o={path:p};if(P>0){o.model=p.slice(0,P);o.path=p.slice(P+1);}return o;}function j(o,s){try{a.mergeParts(o);}catch(e){L.error("Cannot merge parts: "+e.message,s,"sap.ui.base.BindingParser");}}function k(e,i){var V=Object.assign({".":e.oContext},e.mLocals);function l(o,P){if(typeof o[P]==="string"){var N=o[P];o[P]=r(o[P],V,{preferDotContext:e.bPreferContext,bindDotContext:!e.bStaticContext});if(typeof(o[P])!=="function"){if(e.bTolerateFunctionsNotFound){e.aFunctionsNotFound=e.aFunctionsNotFound||[];e.aFunctionsNotFound.push(N);}else{L.error(P+" function "+N+" not found!");}}}}function m(o){var t;var T=o.type;if(typeof T==="string"){t=r(T,V,{bindContext:false});if(typeof t==="function"){o.type=new t(o.formatOptions,o.constraints);}else{o.type=t;}if(!o.type){L.error("Failed to resolve type '"+T+"'. Maybe not loaded or a typo?");}delete o.formatOptions;delete o.constraints;}}function n(o){if(o!=null&&typeof o==='object'){for(var N in o){l(o,N);}}}function p(o,P){var v=o[P];if(Array.isArray(v)){v.forEach(function(O,I){p(v,I);});return;}if(v&&typeof v==='object'){l(v,'test');p(v,'filters');p(v,'condition');o[P]=new F(v);}}function s(o,P){var v=o[P];if(Array.isArray(v)){v.forEach(function(O,I){s(v,I);});return;}if(v&&typeof v==='object'){l(v,"group");l(v,"comparator");o[P]=new S(v);}}if(typeof i==='object'){if(Array.isArray(i.parts)){i.parts.forEach(function(P){k(e,P);});}m(i);p(i,'filters');s(i,'sorter');n(i.events);l(i,'formatter');l(i,'factory');l(i,'groupHeaderFactory');}return i;}function q(e,i,s){var p=J.parseJS,P,l;if(b.test(i.slice(s))){P=p(i,s);k(e,P.result);return P;}l=i.indexOf('}',s);if(l<s){throw new SyntaxError("no closing braces found in '"+i+"' after pos:"+s);}return{result:h(i.slice(s+1,l)),at:l+1};}a.simpleParser=function(s,C){if(s.startsWith("{")&&s.endsWith("}")){return h(s.slice(1,-1));}};a.simpleParser.escape=function(v){return v;};a.complexParser=function(s,C,u,t,e,P,l){var n=false,o={parts:[]},M=false,v={oContext:C,mLocals:l,aFunctionsNotFound:undefined,bPreferContext:P,bStaticContext:e,bTolerateFunctionsNotFound:t},w=[],U,p=0,m,x;function y(I,z,A){var D=E.parse(q.bind(null,v),s,z,null,l||(e?C:null));function G(D,H){if(D.parts){D.parts.forEach(function(K,i){if(typeof K==="string"){K=D.parts[i]={path:K};}G(K,i);});n=n||H!==undefined;}else{D.mode=A;}}if(I.charAt(D.at)!=="}"){throw new SyntaxError("Expected '}' and instead saw '"+I.charAt(D.at)+"' in expression binding "+I+" at position "+D.at);}D.at+=1;if(D.result){G(D.result);}else{w[w.length-1]=String(D.constant);U=true;}return D;}c.lastIndex=0;while((m=c.exec(s))!==null){if(p<m.index){w.push(s.slice(p,m.index));}if(m[1]){w.push(m[1].slice(1));U=true;}else{w.push(o.parts.length);if(s.indexOf(":=",m.index)===m.index+1){x=y(s,m.index+3,B.OneTime);}else if(s.charAt(m.index+1)==="="){x=y(s,m.index+2,B.OneWay);}else{x=q(v,s,m.index);}if(x.result){o.parts.push(x.result);M=M||"parts"in x.result;}c.lastIndex=x.at;}p=c.lastIndex;}if(p<s.length){w.push(s.slice(p));}if(o.parts.length>0){if(w.length===1){o=o.parts[0];M=n;}else{o.formatter=g(w);}if(M){j(o,s);}if(a._keepBindingStrings){o.bindingString=s;}if(v.aFunctionsNotFound){o.functionsNotFound=v.aFunctionsNotFound;}return o;}else if(u&&U){return w.join('');}};a.complexParser.escape=function(v){return v.replace(d,"\\$1");};a.mergeParts=function(o){var e=[],p=[];o.parts.forEach(function(v){var i,l=function(){return v;},n,s=p.length;function m(){return arguments[s];}if(v&&typeof v==="object"){if(v.parts){for(n in v){if(n!=="formatter"&&n!=="parts"){throw new Error("Unsupported property: "+n);}}p=p.concat(v.parts);i=p.length;if(v.formatter){l=function(){return v.formatter.apply(this,Array.prototype.slice.call(arguments,s,i));};}else if(i-s>1){l=function(){return Array.prototype.slice.call(arguments,s,i).join(" ");};}else{l=m;}}else if("path"in v){p.push(v);l=m;}}e.push(l);});o.parts=p;o.formatter=f(e,o.formatter);};a.parseExpression=function(i,s,e,l){e=e||{};if(l){e.mLocals=l;}return E.parse(q.bind(null,e),i,s,l);};return a;},true);
