/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(["sap/ui/Device"],function(D){"use strict";var c=document.createElement("title").style;var t=document.createElement("template");var A={value:function(e,n){if(e.tagName=="INPUT"){e.value=(n==null)?"":n;}},checked:function(e,n){if(e.tagName=="INPUT"){e.checked=(n==null)?false:true;}},selected:function(e,n){if(e.tagName=="OPTION"){e.selected=(n==null)?false:true;}}};if(D.browser.safari){A.style=function(e,n){if(n==null){e.style="";return true;}};}var a=function(T,p){if(T=="svg"){return document.createElementNS("http://www.w3.org/2000/svg","svg");}var n=p&&p.namespaceURI;if(!n||n=="http://www.w3.org/1999/xhtml"||p.localName=="foreignObject"){return document.createElement(T);}return document.createElementNS(n,T);};var P=function(){this._oRoot=null;this._oCurrent=null;this._oParent=null;this._oReference=null;this._oNewElement=null;this._oNewParent=null;this._oNewReference=null;this._iTagOpenState=0;this._sStyles="";this._sClasses="";this._mAttributes=Object.create(null);};P.prototype.setRootNode=function(r){if(this._oRoot){this.reset();}this._oRoot=r||document.createDocumentFragment();};P.prototype.getRootNode=function(){return this._oRoot;};P.prototype.getCurrentNode=function(){return this._oCurrent;};P.prototype.reset=function(){this._oRoot=this._oCurrent=this._oParent=this._oReference=this._oNewElement=this._oNewParent=this._oNewReference=null;this._iTagOpenState=0;};P.prototype._walkOnTree=function(){this._oReference=null;if(!this._oCurrent){if(this._oRoot.nodeType==11){this._oParent=this._oRoot;}else{this._oParent=this._oRoot.parentNode;this._oCurrent=this._oRoot;}}else if(this._iTagOpenState){this._oParent=this._oCurrent;this._oCurrent=this._oCurrent.firstChild;}else{this._oParent=this._oCurrent.parentNode;this._oCurrent=this._oCurrent.nextSibling;}};P.prototype._matchElement=function(i){if(!i){return;}if(!this._oCurrent){return;}if(this._oCurrent.id==i||this._oCurrent==this._oRoot){return;}var C=document.getElementById(i);if(C){this._oCurrent=this._oParent.insertBefore(C,this._oCurrent);return;}if(this._oCurrent.id){this._oReference=this._oCurrent;this._oCurrent=null;}};P.prototype._matchNodeName=function(n){if(!this._oCurrent){return;}var C=(this._oCurrent.nodeType==1)?this._oCurrent.localName:this._oCurrent.nodeName;if(C==n){return;}this._oReference=this._oCurrent;this._oCurrent=null;};P.prototype._getAttributes=function(){for(var i=0,b=this._oCurrent.getAttributeNames();i<b.length;i++){this._mAttributes[b[i]]=this._oCurrent.getAttribute(b[i]);}};P.prototype._setNewElement=function(n){if(!n){return;}if(!this._oNewElement){this._oNewElement=this._oCurrent;this._oNewParent=this._oParent;this._oNewReference=this._oReference;}else{this._oParent.insertBefore(this._oCurrent,this._oReference);}};P.prototype._insertNewElement=function(){if(this._oCurrent==this._oNewElement){this._oNewParent[this._oNewReference==this._oRoot?"replaceChild":"insertBefore"](this._oNewElement,this._oNewReference);this._oNewElement=this._oNewParent=this._oNewReference=null;}};P.prototype.openStart=function(T,i){this._walkOnTree();this._matchElement(i);this._matchNodeName(T);if(this._oCurrent){this._getAttributes();this._iTagOpenState=2;}else{this._oCurrent=a(T,this._oParent);this._setNewElement(this._oCurrent);this._iTagOpenState=1;}if(i){this.attr("id",i);}return this;};P.prototype.voidStart=P.prototype.openStart;P.prototype.attr=function(s,v){if(s==="style"){this._sStyles=v;return this;}if(this._iTagOpenState==1){this._oCurrent.setAttribute(s,v);return this;}var n=String(v);var o=this._mAttributes[s];var m=A[s];if(o!==undefined){delete this._mAttributes[s];}if(m&&m(this._oCurrent,n,o)){return this;}if(o!==n){this._oCurrent.setAttribute(s,n);}return this;};P.prototype.class=function(C){if(C){this._sClasses+=(this._sClasses)?" "+C:C;}return this;};P.prototype.style=function(n,v){if(!n||v==null||v==""){return this;}v=v+"";if(v.includes(";")){c.setProperty(n,v);v=c.getPropertyValue(n);}this._sStyles+=(this._sStyles?" ":"")+(n+": "+v+";");return this;};P.prototype.openEnd=function(){if(this._sClasses){this.attr("class",this._sClasses);this._sClasses="";}if(this._sStyles){if(this._mAttributes.style!=this._sStyles){this._oCurrent.style=this._sStyles;}delete this._mAttributes.style;this._sStyles="";}if(this._iTagOpenState==1){return this;}for(var s in this._mAttributes){var m=A[s];if(!m||!m(this._oCurrent,null)){this._oCurrent.removeAttribute(s);}delete this._mAttributes[s];}return this;};P.prototype.voidEnd=function(){this.openEnd();this._iTagOpenState=0;this._insertNewElement();return this;};P.prototype.text=function(T){this._walkOnTree();this._matchNodeName("#text");if(!this._oCurrent){this._oCurrent=document.createTextNode(T);this._oParent.insertBefore(this._oCurrent,this._oReference);}else if(this._oCurrent.data!=T){this._oCurrent.data=T;}this._iTagOpenState=0;return this;};P.prototype.close=function(T){if(this._iTagOpenState){this._iTagOpenState=0;this._oCurrent.textContent="";}else{var p=this._oCurrent.parentNode;for(var l=p.lastChild;l&&l!=this._oCurrent;l=p.lastChild){p.removeChild(l);}this._oCurrent=p;}this._insertNewElement();return this;};P.prototype.unsafeHtml=function(h,i,C){var r=null;var o=this._oCurrent;if(!o){r=this._oRoot;}else if(this._iTagOpenState){r=o.firstChild;if(h){this._iTagOpenState=0;o.insertAdjacentHTML("afterbegin",h);this._oCurrent=r?r.previousSibling:o.lastChild;}}else{r=o.nextSibling;if(h){if(o.nodeType==1){o.insertAdjacentHTML("afterend",h);}else{t.innerHTML=h;o.parentNode.insertBefore(t.content,r);}this._oCurrent=r?r.previousSibling:o.parentNode.lastChild;}}if(h&&C){var n=[this._oCurrent];for(var N=this._oCurrent.previousSibling;N&&N!=o;N=N.previousSibling){n.unshift(N);}C(n);}if(i&&r&&r.id==i){r.remove();}return this;};return P;});
