/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['sap/ui/core/support/Plugin','sap/ui/core/format/DateFormat',"sap/base/Log","sap/base/security/encodeXML"],function(P,D,L,e){"use strict";var T=P.extend("sap.ui.core.support.plugins.Trace",{constructor:function(s){P.apply(this,["sapUiSupportTrace","JavaScript Trace",s]);this._aEventIds=this.runsAsToolPlugin()?[this.getId()+"Entry"]:[];if(this.runsAsToolPlugin()){this._aLogEntries=[];this._iLogLevel=L.Level.ALL;this._oDateFormat=D.getDateTimeInstance();}else{var t=this;this._oldLogLevel=L.getLevel();L.setLevel(L.Level.ALL);L.addLogListener({onLogEntry:function(o){if(t.isActive()){s.sendEvent(t.getId()+"Entry",{"entry":o});}}});}}});T.prototype.onsapUiSupportTraceEntry=function(E){l(this,E.getParameter("entry"));};T.prototype.init=function(s){P.prototype.init.apply(this,arguments);if(!this.runsAsToolPlugin()){return;}var t=this;var r=sap.ui.getCore().createRenderManager();r.openStart("div").class("sapUiSupportToolbar").openEnd();r.openStart("button",this.getId()+"-clear").class("sapUiSupportRoundedButton").openEnd().text("Clear").close("button");r.openStart("label").class("sapUiSupportLabel").openEnd().text("Filter:").close("label");r.voidStart("input",this.getId()+"-filter").class("sapUiSupportTxtFld").attr("type","text").voidEnd();r.openStart("label").class("sapUiSupportLabel").openEnd().text("Log Level:").close("label");r.openStart("select",this.getId()+"-loglevel").class("sapUiSupportTxtFld").class("sapUiSupportSelect").openEnd();r.openStart("option").attr("value","0").openEnd().text("FATAL").close("option");r.openStart("option").attr("value","1").openEnd().text("ERROR").close("option");r.openStart("option").attr("value","2").openEnd().text("WARNING").close("option");r.openStart("option").attr("value","3").openEnd().text("INFO").close("option");r.openStart("option").attr("value","4").openEnd().text("DEBUG").close("option");r.openStart("option").attr("value","5").openEnd().text("TRACE").close("option");r.openStart("option").attr("value","6").attr("selected","").openEnd().text("ALL").close("option");r.close("select");r.close("div");r.openStart("div").class("sapUiSupportTraceCntnt").openEnd().close("div");r.flush(this.$().get(0));r.destroy();this._fClearHandler=function(){l(t);};this._fLogLevelHandler=function(){t._iLogLevel=t.$("loglevel").val();var R=[];for(var i=0;i<t._aLogEntries.length;i++){if(a(t._filter,t._iLogLevel,t._aLogEntries[i])){R.push(g(t,t._aLogEntries[i]));}}l(t,R.join(""));};this._fFilterHandler=function(){t._filter=t.$("filter").val();t._filter=t._filter?t._filter.toLowerCase():"";var R=[];for(var i=0;i<t._aLogEntries.length;i++){if(a(t._filter,t._iLogLevel,t._aLogEntries[i])){R.push(g(t,t._aLogEntries[i]));}}l(t,R.join(""));};this.$("clear").on("click",this._fClearHandler);this.$("filter").on("change",this._fFilterHandler);this.$("loglevel").on("change",this._fLogLevelHandler);};T.prototype.exit=function(s){if(this.runsAsToolPlugin()){if(this._fClearHandler){this.$("clear").off("click",this._fClearHandler);this._fClearHandler=null;}if(this._fFilterHandler){this.$("filter").off("change",this._fFilterHandler);this._fFilterHandler=null;}if(this._fLogLevelHandler){this.$("loglevel").off("change",this._fLogLevelHandler);this._fLogLevelHandler=null;}}else{L.setLevel(this._oldLogLevel);this._oldLogLevel=null;}P.prototype.exit.apply(this,arguments);};function l(p,E){var c=jQuery(".sapUiSupportTraceCntnt",p.$());if(!E){c.html("");p._aLogEntries=[];}else if(typeof(E)==="string"){c.html(e(E));c[0].scrollTop=c[0].scrollHeight;}else{E._levelInfo=b(E.level);if(a(p._filter,p._iLogLevel,E)){c.append(g(p,E));c[0].scrollTop=c[0].scrollHeight;}p._aLogEntries.push(E);}}function g(p,E){var c=E._levelInfo;var r="<div class='sapUiSupportTraceEntry'><span class='sapUiSupportTraceEntryLevel sapUiSupportTraceEntryLevel_"+c[0]+"'>"+c[0]+"</span><span class='sapUiSupportTraceEntryTime'>"+p._oDateFormat.format(new Date(E.timestamp))+"</span><span class='sapUiSupportTraceEntryMessage'>"+e(E.message||"")+"</div>";return r;}function a(f,c,E){var d=E._levelInfo;if(E._levelInfo[1]<=c){if(f){var p=f.split(" ");var r=true;for(var i=0;i<p.length;i++){r=r&&E.message.toLowerCase().indexOf(p[i])>=0||d[0].toLowerCase().indexOf(p[i])>=0;}return r;}return true;}return false;}function b(i){switch(i){case L.Level.FATAL:return["FATAL",i];case L.Level.ERROR:return["ERROR",i];case L.Level.WARNING:return["WARNING",i];case L.Level.INFO:return["INFO",i];case L.Level.DEBUG:return["DEBUG",i];case L.Level.TRACE:return["TRACE",i];default:return["unknown",i];}}return T;});
