/*
 * ! OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(["sap/ui/base/Object","sap/ui/base/ManagedObject","sap/ui/dt/ElementUtil","sap/ui/dt/OverlayUtil","sap/ui/dt/Util"],function(B,M,E,O,D){"use strict";var a=M.extend("sap.ui.dt.plugin.ElementMover",{metadata:{library:"sap.ui.dt",properties:{movableTypes:{type:"string[]",defaultValue:["sap.ui.core.Element"]}},associations:{},events:{validTargetZonesActivated:{}}}});a.prototype._getMovableTypes=function(){return this.getProperty("movableTypes")||[];};a.prototype.isMovableType=function(e){var m=this._getMovableTypes();return m.some(function(t){return B.isA(e,t);});};a.prototype.checkMovable=function(){return Promise.resolve(true);};a.prototype.getMovedOverlay=function(){return this._oMovedOverlay;};a.prototype.setMovedOverlay=function(m){if(m){this._source=O.getParentInformation(m);}else{delete this._source;}this._oMovedOverlay=m;};a.prototype._getSource=function(){return this._source;};a.prototype.activateAllValidTargetZones=function(d,A){return this._iterateAllAggregations(d,this._activateValidTargetZone.bind(this),A,true).then(function(){this.fireValidTargetZonesActivated();}.bind(this));};a.prototype._activateValidTargetZone=function(A,s){return this.checkTargetZone(A).then(function(v){if(v){A.setTargetZone(true);if(s){A.addStyleClass(s);}}}).catch(function(e){throw D.createError("ElementMover#_activateValidTargetZone","An error occured during activation of valid target zones: "+e);});};a.prototype.checkTargetZone=function(A,o,b){var m=o||this.getMovedOverlay();return E.checkTargetZone(A,m,b);};a.prototype._deactivateTargetZone=function(A,s){A.setTargetZone(false);if(s){A.removeStyleClass(s);}};a.prototype.activateTargetZonesFor=function(o,A){return this._iterateOverlayAggregations(o,this._activateValidTargetZone.bind(this),A,true).then(function(){this.fireValidTargetZonesActivated();}.bind(this));};a.prototype.deactivateTargetZonesFor=function(o,A){this._iterateOverlayAggregations(o,this._deactivateTargetZone.bind(this),A);};a.prototype.deactivateAllTargetZones=function(d,A){this._iterateAllAggregations(d,this._deactivateTargetZone.bind(this),A);};a.prototype._iterateAllAggregations=function(d,s,A,b){var o=d.getElementOverlays();var r=o.map(function(c){return this._iterateOverlayAggregations(c,s,A,b);},this);if(b){return Promise.all(r);}};a.prototype._iterateOverlayAggregations=function(o,s,A,b){var c=o.getAggregationOverlays();var r=c.map(function(d){return s(d,A);});if(b){return Promise.all(r);}};a.prototype.repositionOn=function(m,t,i){var o=m.getElement();var T=O.getParentInformation(t);var s=O.getParentInformation(m);var A;var p=m.getParentAggregationOverlay();var r=m.getRelevantContainer();var P=m.getParentElementOverlay();if(p&&P){var b=p.getAggregationName();A=P.getDesignTimeMetadata().getAggregation(b);}if(T.index!==-1){if(A&&A.beforeMove){A.beforeMove(r,o);}if(i){T.index++;if(s.aggregation===T.aggregation){T.index=E.adjustIndexForMove(s.parent,T.parent,s.index,T.index);}}E.insertAggregation(T.parent,T.aggregation,o,T.index);if(A&&A.afterMove){A.afterMove(r,o);}this._setSourceAndTargetParentInformation();}};a.prototype.insertInto=function(m,t,i){var o=m.getElement();var T=t.getElement();var A;var p=m.getParentAggregationOverlay();var r=m.getRelevantContainer();var P=m.getParentElementOverlay();if(p&&P){var s=p.getAggregationName();A=P.getDesignTimeMetadata().getAggregation(s);}var b=E.getAggregation(t.getElement(),t.getAggregationName());var I=b.indexOf(o);var c=i?b.length:0;if(!(I>-1&&I===(c===0?c:c-1))){if(A&&A.beforeMove){A.beforeMove(r,o);}var d=t.getAggregationName();E.insertAggregation(T,d,o,c);if(A&&A.afterMove){A.afterMove(r,o);}this._setSourceAndTargetParentInformation();}};a.prototype._compareSourceAndTarget=function(s,t){var p;for(p in s){switch(typeof(s[p])){case'object':if(s[p].getId()!==t[p].getId()){return false;}break;default:if(s[p]!==t[p]){return false;}}}return true;};a.prototype._setSourceAndTargetParentInformation=function(){var m=this.getMovedOverlay();if(!m){delete this._mSourceParentInformation;delete this._mTargetParentInformation;return;}var s=this._getSource();if(s){this._mSourceParentInformation={};Object.assign(this._mSourceParentInformation,s);}else{delete this._mSourceParentInformation;}var t=O.getParentInformation(m);if(t){this._mTargetParentInformation=t;}else{delete this._mTargetParentInformation;}};a.prototype.getSourceAndTargetParentInformation=function(){return{sourceParentInformation:this._mSourceParentInformation,targetParentInformation:this._mTargetParentInformation};};return a;});
