/*
 * ! OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(["sap/base/Log","sap/ui/core/Element","sap/ui/core/util/reflection/JsControlTreeModifier","sap/ui/fl/apply/_internal/changes/FlexCustomData","sap/ui/fl/apply/_internal/changes/Utils","sap/ui/fl/apply/_internal/flexState/changes/DependencyHandler","sap/ui/fl/Utils"],function(L,E,J,F,U,D,a){"use strict";var l=new a.FakePromise();function _(C,p){var s=C.getSelector&&C.getSelector();if(!s||(!s.id&&!s.name)){return Promise.reject(Error("No selector in change found or no selector ID."));}return p.modifier.bySelectorTypeIndependent(s,p.appComponent,p.view).then(function(o){if(!o){throw Error("A flexibility change tries to change a nonexistent control.");}var j=C.getDependentControlSelectorList();j.forEach(function(k){var m=p.modifier.bySelector(k,p.appComponent,p.view);if(!m){throw new Error("A dependent selector control of the flexibility change is not available.");}});return o;});}function b(C,o,m,j,p){var k=U.getControlIfTemplateAffected(o,C,p);var M=p.modifier;var H=!!F.sync.getAppliedCustomDataValue(k.control,o);var I=H||F.sync.hasChangeApplyFinishedCustomData(k.control,o);var n=o.isApplyProcessFinished();if(n&&!I){var q=U.checkIfDependencyIsStillValidSync.bind(null,p.appComponent,M,m);j._oChangePersistence.copyDependenciesFromInitialChangesMapSync(o,q,p.appComponent);o.setInitialApplyState();}else if(!n&&I){if(H){o.setRevertData(F.sync.getParsedRevertDataFromCustomData(C,o));}o.markFinished();}}function c(p){return p.modifier.targets==="xmlTree";}function d(C,o,m,j,p){var x=c(p);var k=U.getControlIfTemplateAffected(o,C,p);var M=p.modifier;return F.getAppliedCustomDataValue(k.control,o,M).then(function(n){var H=!!n;return Promise.all([H,(H||F.hasChangeApplyFinishedCustomData(k.control,o,M))]);}).then(function(n){var H=n[0];var I=n[1];var q=o.isApplyProcessFinished();var M=p.modifier;var r=p.appComponent;if(q&&!I){var P=new a.FakePromise();if(!x){var s=U.checkIfDependencyIsStillValid.bind(null,r,M,m);P=P.then(function(){return j._oChangePersistence.copyDependenciesFromInitialChangesMap(o,s,r);});}return P.then(o.setInitialApplyState.bind(o));}else if(!q&&I){if(H){return F.getParsedRevertDataFromCustomData(C,o,M).then(function(t){o.setRevertData(t);o.markFinished();});}o.markFinished();return undefined;}else if(q&&I){o.markFinished();}return undefined;});}function e(C,p){var s;if(c(p)&&C.getDefinition().jsOnly){s="Change cannot be applied in XML. Retrying in JS.";}if(s){C.setInitialApplyState();throw Error(s);}}function f(C,m,I,p){return Promise.resolve().then(function(){if(I instanceof E){m.control=I;}if(m.control){return p.modifier.updateAggregation(m.originalControl,C.getContent().boundAggregation);}return undefined;}).then(function(){return F.addAppliedCustomData(m.control,C,p,c(p));}).then(function(){var r={success:true};C.markFinished(r);return r;});}function g(o,C,m,p){var x=c(p);var r={success:false,error:o};var s=C.getId();var j="Change ''{0}'' could not be applied.";var k=o instanceof Error;var n=F.getCustomDataIdentifier(false,k,x);switch(n){case F.notApplicableChangesCustomDataKey:a.formatAndLogMessage("info",[j,o.message],[s]);break;case F.failedChangesCustomDataKeyXml:a.formatAndLogMessage("warning",[j,"Merge error detected while processing the XML tree."],[s],o.stack);break;case F.failedChangesCustomDataKeyJs:a.formatAndLogMessage("error",[j,"Merge error detected while processing the JS control tree."],[s],o.stack);break;}return F.addFailedCustomData(m.control,C,p,n).then(function(){if(x){C.setInitialApplyState();}else{C.markFinished(r);}return r;});}function h(o,C){var j=C.getDefinition();var s=j.changeType;var t=j.selector.id;var k=j.namespace+j.fileName+"."+j.fileType;var w="A flexibility change could not be applied.";w+="\nThe displayed UI might not be displayed as intedend.";if(o.message){w+="\n   occurred error message: '"+o.message+"'";}w+="\n   type of change: '"+s+"'";w+="\n   LRep location of the change: "+k;w+="\n   id of targeted control: '"+t+"'.";L.warning(w,undefined,"sap.ui.fl.apply._internal.changes.Applier");}function i(C,o,j){var p={appComponent:j,modifier:J};var k=J.bySelector(C.originalSelectorToBeAdjusted,j);var m=o.getBindingInfo(C.getContent().boundAggregation).template;if(k.getParent()){var s=[];var t=k;do{s.push({aggregation:t.sParentAggregationName,index:t.getParent().getAggregation(t.sParentAggregationName).indexOf(t)});t=t.getParent();}while(t.getParent());s.reverse();s.forEach(function(I){m=m.getAggregation(I.aggregation)[I.index];});}C.addDependentControl(m,"originalSelector",p);}var A={addPreConditionForInitialChangeApplying:function(p){l=l.then(function(){return p;});},applyChangeOnControl:function(C,o,p){var m=U.getControlIfTemplateAffected(C,o,p);return U.getChangeHandler(C,m,p).then(function(j){e(C,p);return j;}).then(function(j){if(C.hasApplyProcessStarted()){return C.addPromiseForApplyProcessing().then(function(r){C.markFinished();return r;});}else if(!C.isApplyProcessFinished()){return new a.FakePromise().then(function(){C.startApplying();return j.applyChange(C,m.control,p);}).then(function(I){return f(C,m,I,p);}).catch(function(k){return g(k,C,m,p);});}var r={success:true};C.markFinished(r);return r;}).catch(function(j){return{success:false,error:j};});},applyAllChangesForControl:function(G,o,j,C){var m=G();var s=C.getId();var k=m.mChanges[s]||[];var p={modifier:J,appComponent:o,view:a.getViewForControl(C)};k.forEach(function(n){b(C,n,m,j,p);if(!n.isApplyProcessFinished()&&!n._ignoreOnce){n.setQueuedForApply();}});l=l.then(function(C,p){var P=[];var s=C.getId();var k=m.mChanges[s]||[];var n;if(m.mControlsWithDependencies[s]){D.removeControlsDependencies(m,s);n=true;}k.forEach(function(q){if(q.originalSelectorToBeAdjusted){i(q,C,o);delete q.originalSelectorToBeAdjusted;}if(q._ignoreOnce){delete q._ignoreOnce;}else if(q.isApplyProcessFinished()){D.resolveDependenciesForChange(m,q.getId(),s);}else if(!m.mDependencies[q.getId()]){P.push(function(){return A.applyChangeOnControl(q,C,p).then(function(){D.resolveDependenciesForChange(m,q.getId(),s);});});}else{var r=A.applyChangeOnControl.bind(A,q,C,p);D.addChangeApplyCallbackToDependency(m,q.getId(),r);}});if(k.length||n){return a.execPromiseQueueSequentially(P).then(function(){return D.processDependentQueue(m,o,s);});}return undefined;}.bind(null,C,p));return l;},applyAllChangesForXMLView:function(p,C){if(!Array.isArray(C)){var s="No list of changes was passed for processing the flexibility on view: "+p.view+".";L.error(s,undefined,"sap.ui.fl.apply._internal.changes.Applier");C=[];}return C.reduce(function(P,o){var j;return P.then(_.bind(null,o,p)).then(function(r){j=r;o.setQueuedForApply();return d(j,o,undefined,undefined,p);}).then(function(){if(!o.isApplyProcessFinished()){return A.applyChangeOnControl(o,j,p);}return{success:true};}).then(function(r){if(!r.success){throw Error(r.error);}}).catch(function(k){h(k,o);});},new a.FakePromise()).then(function(){return p.view;});}};return A;});
