/*
 * ! OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(["sap/base/util/restricted/_omit","sap/base/util/each","sap/base/util/merge","sap/base/util/ObjectPath","sap/base/Log","sap/ui/core/Component","sap/ui/fl/apply/_internal/flexState/appDescriptorChanges/prepareAppDescriptorMap","sap/ui/fl/apply/_internal/flexState/changes/prepareChangesMap","sap/ui/fl/apply/_internal/flexState/compVariants/prepareCompVariantsMap","sap/ui/fl/apply/_internal/flexState/controlVariants/prepareVariantsMap","sap/ui/fl/apply/_internal/flexState/Loader","sap/ui/fl/apply/_internal/flexState/ManifestUtils","sap/ui/fl/initial/_internal/StorageUtils","sap/ui/fl/LayerUtils","sap/ui/fl/Utils"],function(_,e,m,O,L,C,p,a,b,c,d,M,S,f,U){"use strict";var F={};var g={};var h={};var i={};var j;var k;var l;var n;var o={appDescriptorChanges:{prepareFunction:p,pathInResponse:[]},changes:{prepareFunction:a,pathInResponse:["changes"]},variants:{prepareFunction:c,pathInResponse:["variants","variantChanges","variantDependentControlChanges","variantManagementChanges"]},compVariants:{prepareFunction:b,pathInResponse:["comp.variants","comp.standardVariants","comp.defaultVariants","comp.changes"]}};var q={compVariants:{},variants:{}};function u(P){var Q=C.get(P.componentId);g[P.reference].componentData=Q?Q.getComponentData():P.componentData;}function r(P){var Q=C.get(P.componentId);P.componentData=P.componentData||Q.getComponentData()||{};P.manifest=P.manifest||P.rawManifest||Q.getManifestObject();P.reference=P.reference||M.getFlexReference(P);}function s(R,P){if(!g[R]){throw new Error("State is not yet initialized");}if(!g[R].preparedMaps[P]){var Q={unfilteredStorageResponse:g[R].unfilteredStorageResponse,storageResponse:g[R].storageResponse,componentId:g[R].componentId,componentData:g[R].componentData};g[R].preparedMaps[P]=F.callPrepareFunction(P,Q);}return g[R].preparedMaps[P];}function t(R){return s(R,"appDescriptorChanges");}function v(R){return s(R,"changes");}function w(R){return s(R,"variants");}function x(R){return s(R,"compVariants");}function y(P){if(P.reference.endsWith(".Component")){var Q=P.reference.split(".");Q.pop();var R=Q.join(".");g[R]=m({},{storageResponse:{changes:S.getEmptyFlexDataResponse()},unfilteredStorageResponse:{changes:S.getEmptyFlexDataResponse()},preparedMaps:{},componentId:P.componentId,partialFlexState:P.partialFlexState});i[R]=i[P.reference];}}function z(R){var P=m({},R);var Q=P.changes;var T=K("URLParsing");if(f.isLayerFilteringRequired(T)){e(o,function(V,W){W.pathInResponse.forEach(function(X){O.set(X,f.filterChangeDefinitionsByMaxLayer(O.get(X,Q),T),Q);});});}return P;}function A(P){i[P.reference]=d.loadFlexData(P).then(function(R){g[P.reference]=m({},{unfilteredStorageResponse:R,preparedMaps:{},componentId:P.componentId,componentData:P.componentData,partialFlexState:P.partialFlexState});y(P);B(P.reference);return R;});return i[P.reference];}function B(R){var P=K("ShellNavigation");if(P){h[R]=E.bind(null,R);P.registerNavigationFilter(h[R]);}}function D(R){var P=K("ShellNavigation");if(P){if(h[R]){P.unregisterNavigationFilter(h[R]);delete h[R];}}}function E(R,P,Q){var T=K("ShellNavigation");if(T){try{var V=f.getMaxLayerTechnicalParameter(P,K("URLParsing"));var W=f.getMaxLayerTechnicalParameter(Q,K("URLParsing"));if(V!==W){F.clearFilteredResponse(R);}}catch(X){L.error(X.message);}return T.NavigationFilterStatus.Continue;}return undefined;}function G(R){g[R].preparedMaps={};}function H(P){var Q=g[P.reference];if(Q.partialFlexState===true&&P.partialFlexState!==true){Q.partialFlexState=false;P.partialFlexData=m({},Q.unfilteredStorageResponse.changes);P.reInitialize=true;}return P;}function I(P){var Q=g[P.reference].componentId;if(!P.reInitialize&&Q!==P.componentId){P.reInitialize=true;}return P;}function J(){return Promise.all([U.getUShellService("ShellNavigation"),U.getUShellService("URLParsing")]).then(function(P){j=P[0];k=P[1];}).catch(function(P){L.error("Error getting service from Unified Shell: "+P.message);});}function K(P){if(U.getUshellContainer()){if(P==="ShellNavigation"){return j;}else if(P==="URLParsing"){return k;}}return undefined;}function N(){return Promise.all([U.requireAsync("sap/ui/fl/ChangePersistenceFactory"),U.requireAsync("sap/ui/fl/FlexControllerFactory")]).then(function(P){l=P[0];n=P[1];}).catch(function(P){L.error("Error loading modules: "+P.message);});}F.initialize=function(P){return Promise.all([J(),N()]).then(function(){r(P);var Q=P.reference;if(i[Q]){return i[Q].then(H.bind(null,P)).then(I).then(function(R){return R.reInitialize?A(R):g[Q].unfilteredStorageResponse;});}return A(P);}).then(function(P,R){if(!g[P.reference].storageResponse){g[P.reference].storageResponse=z(R);u(P);}}.bind(null,P));};F.clearAndInitialize=function(P){r(P);F.clearState(P.reference);F.clearState(U.normalizeReference(P.reference));return F.initialize(P);};F.clearState=function(R){if(R){D(R);delete g[R];delete i[R];if(l&&l._instanceCache){delete l._instanceCache[R];}if(n&&n._instanceCache){delete n._instanceCache[R];}}else{Object.keys(g).forEach(function(R){D(R);});g={};i={};}};F.setInitialNonFlCompVariantData=function(R,P,Q,V){q.compVariants[R]={};q.compVariants[R][P]={};q.compVariants[R][P].standardVariant=Q;q.compVariants[R][P].variants=V;};F.getInitialNonFlCompVariantData=function(R){return q.compVariants[R];};F.setFakeStandardVariant=function(R,P,Q){var V=F.getVariantsState(R);if(!V[Object.keys(Q)[0]]){m(V,Q);q.variants[R]=q.variants[R]||{};q.variants[R][P]=q.variants[R][P]||{};m(q.variants[R][P],Q);}};F.resetFakedStandardVariants=function(R,P){if(q.variants[R]){delete q.variants[R][P];}};F.clearFilteredResponse=function(R,P){if(g[R]&&(!P||P===g[R].componentId)){G(R);delete g[R].storageResponse;}};F.getUIChanges=function(R){return v(R).changes;};F.getAppDescriptorChanges=function(R){return t(R).appDescriptorChanges;};F.getVariantsState=function(R){var V=w(R);if(q.variants[R]){e(q.variants[R],function(P,Q){if(g[R].componentId===P){e(Q,function(T,W){if(!V[T]){V[T]=W;}});}});}return V;};F.getUI2Personalization=function(R){return g[R].unfilteredStorageResponse.changes.ui2personalization;};F.getCompVariantsMap=function(R){return x(R);};F.callPrepareFunction=function(P,Q){return o[P].prepareFunction(Q);};F.getStorageResponse=function(R){if(i[R]){return i[R].then(function(){return g[R].unfilteredStorageResponse;});}return undefined;};F.getFlexObjectsFromStorageResponse=function(R){return g[R]&&g[R].unfilteredStorageResponse.changes;};return F;});
