/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(["sap/base/util/each","sap/ui/core/support/Plugin","sap/ui/core/support/Support","sap/ui/core/util/reflection/JsControlTreeModifier","sap/ui/model/json/JSONModel","sap/ui/fl/FlexController","sap/ui/fl/ChangePersistenceFactory","sap/ui/fl/support/apps/uiFlexibilityDiagnostics/helper/Extractor","sap/ui/core/mvc/XMLView","sap/ui/core/Component"],function(e,P,S,J,a,F,C,E,X,b){"use strict";var c=P.extend("sap.ui.fl.support.Flexibility",{constructor:function(s){P.apply(this,["sapUiSupportFlexibility","Flexibility",s]);this._oStub=s;if(this.runsAsToolPlugin()){this._aEventIds=[this.getId()+"SetApps",this.getId()+"SetChangesMaps"];}else{this._aEventIds=[this.getId()+"GetApps",this.getId()+"GetChangesMaps"];}}});c.prototype.sDelimiter=";";c.prototype.init=function(s){P.prototype.init.apply(this,arguments);var p="<div class='sapUiSmallMargin'>The applications listed below have been handled by the sap.ui.fl library in this session.</div>"+"<div class='sapUiSmallMarginBegin'>You can download a file containing the data that has been applied to an application as well as "+"relevant runtime information, and then upload this file to the UI Flexibility Diagnostics application for further investigation.</div>"+"<div class='sapUiSmallMarginBegin'>The UI Flexibility Diagnostics application displays graphs and is only available with SAPUI5.</div>";if(s.isToolStub()){this.addStylesheet("sap/ui/fl/support/flexibility");this.oChangesModel=new a();this.oAppModel=new a();this.oToolSettings=new a({hideDependingChanges:false,panelInfoText:p});this.oChangeDetails=new a();this._renderToolPlugin([]);S.getStub().sendEvent(this.getId()+"GetApps",{});}else{this.onsapUiSupportFlexibilityGetApps();}};c.prototype._renderToolPlugin=function(){var _=function(){var r=sap.ui.getCore().createRenderManager();r.write("<div id='"+this.getId()+"-FlexCacheArea' class='sapUiSizeCompact'></div>");r.flush(this.$().get(0));r.destroy();}.bind(this);var d=function(){this.oViewPromise=X.create({viewName:"sap.ui.fl.support.diagnostics.Flexibility",viewData:{plugin:this}}).then(function(v){this.oView=v;this.oView.placeAt(this.getId()+"-FlexCacheArea");this.oView.setModel(this.oAppModel,"flexApps");this.oView.setModel(this.oToolSettings,"flexToolSettings");this.oView.setModel(this.oChangesModel,"flexChanges");this.oView.setModel(this.oChangeDetails,"flexChangeDetails");}.bind(this));}.bind(this);_();d();};c.prototype.onRefresh=function(){S.getStub().sendEvent(this.getId()+"GetApps",{});};c.prototype.onsapUiSupportFlexibilityGetApps=function(){var A=[];if(C._instanceCache){e(C._instanceCache,function(r,o){A.push({key:r,text:r,additionalText:this.getAppVariantHierarchy(r),data:E.extractData(o)});}.bind(this));}this._oStub.sendEvent(this.getId()+"SetApps",A);};c.prototype.getAppVariantHierarchy=function(r){var R=b.registry.all();var A=[];Object.values(R).find(function(o){var i=o.getMetadata().getManifestEntry("/sap.app/id");var u=o.getMetadata().getManifestEntry("sap.ui5");if(i===r){u.appVariantIdHierarchy.forEach(function(h){A.push(h.appVariantId+" ("+h.version+")"+(h.layer?" in layer "+h.layer:""));});return true;}});return A.length?"App variant based on:\n"+A.join("\n"):"";};c.prototype.onsapUiSupportFlexibilityGetChangesMaps=function(o){var A=o.mParameters.appKey;var d=A.split(this.sDelimiter);var s=d[0];this._getChangesMapForApp(s);};c.prototype.onsapUiSupportFlexibilitySetApps=function(o){var A=o.getParameters();this.oAppModel.setData(A);};c.prototype.onsapUiSupportFlexibilitySetChangesMaps=function(o){var m=o.getParameters();this.oChangesModel.setData(m);this.oView.byId("Tree").expandToLevel(1000);};c.prototype.exit=function(){P.prototype.exit.apply(this,arguments);};c.prototype._getChangesMapForApp=function(A){var m={};var d={};var t=[];var o=C.getChangePersistenceForComponent(A);var f=o._mChanges.mChanges;var D=o._mChangesInitial.mDependencies;function g(d,l){m[l]=[];var n=f[l];var p=sap.ui.getCore().byId(l);var q=[];var r=[];var u=[];if(p){if(p.data(F.appliedChangesCustomDataKey)){q=p.data(F.appliedChangesCustomDataKey).split(",");}if(p.data(F.failedChangesCustomDataKeyJs)){r=p.data(F.failedChangesCustomDataKeyJs).split(",");}if(p.data(F.failedChangesCustomDataKeyXml)){u=p.data(F.failedChangesCustomDataKeyXml).split(",");}}m[l]=n.map(h.bind(this,p,q,r,u,d));}function h(l,n,p,q,d,r){var u={id:r.getId(),changeType:r.getChangeType(),selector:r.getSelector(),controlPresent:!!l,indexInAppliedChanges:undefined,indexOfFirstFailing:undefined,dependentControls:[],dependentChanges:[],someDirectDependingChangesFailed:false,someDirectDependingChangesNotApplied:false,isInSubTree:false};var v=p.concat(q);if(u.controlPresent&&n.indexOf(r.getId())>-1){u.indexInAppliedChanges=n.indexOf(r.getId());}if(u.controlPresent&&p.indexOf(r.getId())>-1){u.modifier="JS";u.indexOfFirstFailing=v.indexOf(r.getId());}if(u.controlPresent&&q.indexOf(r.getId())>-1){u.modifier="XML";u.indexOfFirstFailing=v.indexOf(r.getId());}if(r._aDependentSelectorList){var w=E.getAppComponentInstance(A);u.dependentControls=r._aDependentSelectorList.map(function(x){return{id:x.id,controlPresent:J.bySelector(x,w)};});}d[r.getId()]=u;return u;}function s(l,K,n){var p=n.dependencies;if(p.indexOf(l.id)!==-1){var q=JSON.stringify(d[K].selector)===JSON.stringify(l.selector);l.isInSubTree=l.isInSubTree||q;}}function i(l,n){n.forEach(function(p){jQuery.each(D,s.bind(this,p));p.allDependendingControlsPresent=p.dependentControls.every(function(q){return q.controlPresent;});if(D[p.id]&&D[p.id].dependencies){D[p.id].dependencies.forEach(function(q){var r=d[q];var u=r.indexInAppliedChanges===undefined;r=d[q];p.someDirectDependingChangesNotApplied=p.someDirectDependingChangesNotApplied||u;var v=r.indexOfFirstFailing===undefined;var w=v&&u;p.someDirectDependingChangesFailed=p.someDirectDependingChangesFailed||v;p.someDirectDependingChangesNotSuccessfulApplied=p.someDirectDependingChangesNotSuccessfulApplied||w;p.dependentChanges.push(r);});}p.isApplicable=!p.someDirectDependingChangesNotApplied&&p.controlPresent&&p.allDependendingControlsPresent&&!p.someDirectDependingChangesNotApplied;p.isPossibleRootCause=p.isApplicable&&p.indexInAppliedChanges===undefined;});}function j(l){l=l.filter(function(n){return!l.some(function(p){return p.dependentChanges.some(function(q){return q.id===n.id;});});});return l.map(function(n){return{id:n.id,text:n.changeType,nodes:n.dependentChanges?j(n.dependentChanges):[]};});}function k(l,n){t.push({text:l,nodes:j(n)});}Object.keys(f).forEach(g.bind(this,d));jQuery.each(m,i);jQuery.each(m,k);this._oStub.sendEvent(this.getId()+"SetChangesMaps",{changes:d,tree:t});};return c;});
