/*
 * ! OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(["sap/base/util/restricted/_omit","sap/base/util/restricted/_pick","sap/base/util/UriParameters","sap/ui/fl/Layer","sap/ui/fl/Change","sap/ui/fl/apply/_internal/flexObjects/UpdatableChange","sap/ui/fl/apply/_internal/flexObjects/CompVariant","sap/ui/fl/apply/_internal/flexObjects/RevertData","sap/ui/fl/apply/_internal/flexObjects/CompVariantRevertData","sap/ui/fl/apply/_internal/flexObjects/States","sap/ui/fl/Utils","sap/ui/fl/apply/_internal/flexState/FlexState","sap/ui/fl/apply/_internal/flexState/compVariants/CompVariantMerger","sap/ui/fl/registry/Settings","sap/ui/fl/write/_internal/Storage"],function(_,a,U,L,C,b,c,R,d,S,e,F,f,g,h){"use strict";function j(i,x){if(!["defaultVariant","updateVariant"].includes(i.getChangeType())){return false;}var y=i.getLayer()===x;var P=i.getDefinition().packageName;var N=!P||P==="$TMP";return y&&N;}function k(M,i){if(i.isVariant()){return M.variants;}switch(i.getChangeType()){case"defaultVariant":return M.defaultVariants;case"standardVariant":return M.standardVariants;default:return M.changes;}}function u(O,x){for(var i=0;i<O.length;i++){if(O[i].fileName===x.fileName){O.splice(i,1,x);break;}}}function l(i,x){return h.update({flexObject:i.getDefinition(),layer:i.getLayer(),transport:i.getRequest()}).then(function(y){if(y&&y.response){i.setResponse(y.response);}else{i.setState(S.PERSISTED);}return x;}).then(function(x){var O=k(x.changes.comp,i);u(O,i.getDefinition());return i.getDefinition();});}function m(x,y,z){function A(O,x){for(var i=O.length-1;i>=0;i--){if((O[i].fileName||O[i].getFileName())===x.fileName){O.splice(i,1);break;}}}return h.remove({flexObject:x.getDefinition(),layer:x.getLayer(),transport:x.getRequest()}).then(function(){delete y.byId[x.getId()];if(x.getChangeType()==="standardVariant"){y.standardVariantChange=undefined;}else{A(k(y,x),x.getDefinition());}return z;}).then(function(z){A(k(z.changes.comp,x),x.getDefinition());return x.getDefinition();});}function n(i){return i&&[S.NEW,S.DIRTY,S.DELETED].includes(i.getState());}function o(i){return i.variants.concat(i.changes).concat(i.defaultVariants).concat(i.standardVariantChange);}function p(P){var i={};if(typeof(P.texts)==="object"){Object.keys(P.texts).forEach(function(x){i[x]={value:P.texts[x],type:"XFLD"};});}return i;}function q(P){if(P.layer){return P.layer;}if(P.isUserDependent){return L.USER;}var i=U.fromQuery(window.location.search).get("sap-ui-layer")||"";i=i.toUpperCase();if(i){return i;}if(!P.fileType==="variant"){return L.CUSTOMER;}var x=g.getInstanceOrUndef().isPublicLayerAvailable();return x?L.PUBLIC:L.CUSTOMER;}function r(P){var i=F.getCompVariantsMap(P.reference)._getOrCreate(P.persistencyKey);return i.byId[P.id];}function s(i){if(i instanceof c){i.removeAllRevertInfo();}}function t(V,P){V.storeExecuteOnSelection(P.executeOnSelection);V.storeFavorite(P.favorite);V.storeContexts(P.contexts);if(P.name){V.setText("variantName",P.name);}V.storeContent(P.content||V.getContent());return V;}function v(V,P){V.setExecuteOnSelection(P.executeOnSelection);V.setFavorite(P.favorite);V.setContexts(P.contexts);if(P.name){V.setName(P.name);}V.setContent(P.content||V.getContent());return V;}var w={};w.setDefault=function(P){var i={defaultVariantName:P.defaultVariantId};P.layer=P.layer||U.fromQuery(window.location.search).get("sap-ui-layer")||L.USER;var x=F.getCompVariantsMap(P.reference)._getOrCreate(P.persistencyKey);var y="defaultVariant";var D=x.defaultVariants;var z=D[D.length-1];if(!z||!j(z,P.layer)){var A={fileName:e.createDefaultFileName(y),fileType:"change",changeType:y,layer:P.layer,content:i,namespace:e.createNamespace(P,"changes"),reference:P.reference,selector:{persistencyKey:P.persistencyKey},support:P.support||{}};A.support.generator=A.support.generator||"CompVariantState."+y;A.support.sapui5Version=sap.ui.version;z=new b(A);x.defaultVariants.push(z);x.byId[z.getId()]=z;z.addRevertInfo(new R({type:w.operationType.NewChange}));}else{z.addRevertInfo(new R({type:w.operationType.ContentUpdate,content:{previousState:z.getState(),previousContent:z.getContent()}}));z.setContent(i);}return z;};w.revertSetDefaultVariantId=function(P){var i=F.getCompVariantsMap(P.reference)._getOrCreate(P.persistencyKey);var D=i.defaultVariants;var x=D[D.length-1];var y=x.popLatestRevertInfo();if(y.getType()===w.operationType.ContentUpdate){x.setContent(y.getContent().previousContent);x.setState(y.getContent().previousState);}else{x.setState(C.states.DELETED);i.defaultVariants.pop();}};w.addVariant=function(P){if(!P){return undefined;}var i=P.changeSpecificData;var I={id:i.id,changeType:i.type,service:i.ODataService,content:i.content||{},reference:P.reference,fileType:"variant",packageName:i.packageName,layer:q(i),selector:{persistencyKey:P.persistencyKey},texts:p(i),command:P.command,generator:P.generator};if(i.favorite!==undefined){I.favorite=i.favorite;}if(i.executeOnSelection!==undefined){I.executeOnSelection=i.executeOnSelection;}if(i.contexts!==undefined){I.contexts=i.contexts;}var x=c.createInitialFileContent(I);var y=new c(x);var z=F.getCompVariantsMap(P.reference);var M=z._getOrCreate(P.persistencyKey);M.variants.push(y);M.byId[y.getId()]=y;return y;};w.updateVariant=function(P){function i(V,D){var G=V.getLayer()===D;var H=V.getPackage();var N=!H||H==="$TMP";var I=V.getChanges().some(function(J){return J.getLayer()===D;});return V.getPersisted()&&G&&N&&!I;}function x(V){return V.getChanges().reverse().find(function(G){return G.getChangeType()==="updateVariant"&&j(G,D);});}function y(P,V,O,G){var H={type:O,change:G,content:{previousState:V.getState(),previousContent:V.getContent(),previousFavorite:V.getFavorite(),previousExecuteOnSelection:V.getExecuteOnSelection(),previousContexts:V.getContexts()}};if(P.name){H.content.previousName=V.getText("variantName");}V.addRevertInfo(new d(H));}function z(P,V){y(P,V,w.operationType.ContentUpdate);if(P.executeOnSelection!==undefined){V.storeExecuteOnSelection(P.executeOnSelection);}if(P.favorite!==undefined){V.storeFavorite(P.favorite);}if(P.contexts){V.storeContexts(P.contexts);}if(P.name){V.storeName(P.name);}if(P.transportId){V.setRequest(P.transportId);}V.storeContent(P.content||V.getContent());}function A(P,V,G){var H=G.getRevertData()||[];var I=G.getContent();var J={previousContent:Object.assign({},I),previousState:G.getState(),change:a(Object.assign({},P),["favorite","executeOnSelection","contexts","content","name"])};H.push(J);G.setRevertData(H);if(P.executeOnSelection!==undefined){V.setExecuteOnSelection(P.executeOnSelection);I.executeOnSelection=P.executeOnSelection;}if(P.favorite!==undefined){V.setFavorite(P.favorite);I.favorite=P.favorite;}if(P.contexts){V.setContexts(P.contexts);I.contexts=P.contexts;}if(P.content){V.setContent(P.content);I.variantContent=P.content;}if(P.name){V.setName(P.name);I.texts={variantName:{value:P.name,type:"XFLD"}};}G.setContent(I);if(P.transportId){G.setRequest(P.transportId);}f.applyChangeOnVariant(V,G);y(P,V,w.operationType.UpdateVariantViaChangeUpdate,G);}function B(P,V){function G(I){var J=I.getDefinition();var K=F.getCompVariantsMap(I.getComponent());var M=I.getSelector().persistencyKey;K[M].changes.push(I);K[M].byId[I.getId()]=I;return J;}var H=C.createInitialFileContent({changeType:"updateVariant",layer:D,fileType:"change",reference:P.reference,packageName:P.packageName,content:{},selector:{persistencyKey:P.persistencyKey,variantId:V.getId()}});["favorite","executeOnSelection","contexts"].forEach(function(J){if(P[J]!==undefined){H.content[J]=P[J];}});if(P.content!==undefined){H.content.variantContent=P.content;}if(P.name){H.texts.variantName={value:P.name,type:"XFLD"};}var I=new C(H);if(P.transportId){I.setRequest(P.transportId);}G(I);y(P,V,w.operationType.NewChange,I);f.applyChangeOnVariant(V,I);}var V=r(P);var D=q(P);if(i(V,D)){z(P,V);}else{var E=x(V);if(E){A(P,V,E);}else{B(P,V);}}return V;};w.operationType={StateUpdate:"StateUpdate",ContentUpdate:"ContentUpdate",NewChange:"NewChange",UpdateVariantViaChange:"UpdateVariantViaChange",UpdateVariantViaChangeUpdate:"UpdateVariantViaChangeUpdate"};w.removeVariant=function(P){var V=r(P);if(!P.revert){var i=new d({type:w.operationType.StateUpdate,content:{previousState:V.getState()}});V.addRevertInfo(i);}V.markForDeletion();return V;};w.revert=function(P){function i(z){var B=z.getSelector().persistencyKey;var D=F.getCompVariantsMap(z.getComponent());delete D[B].byId[z.getId()];D[B].changes=D[B].changes.filter(function(E){return E!==z;});}var V=r(P);var x=V.getRevertInfo().pop();V.removeRevertInfo(x);var y=x.getContent();var z;switch(x.getType()){case w.operationType.ContentUpdate:t(V,Object.assign({name:y.previousName,content:y.previousContent,favorite:y.previousFavorite,executeOnSelection:y.previousExecuteOnSelection,contexts:y.previousContexts},a(P,["reference","persistencyKey","id"])));break;case w.operationType.NewChange:z=x.getChange();V.removeChange(z);i(z);v(V,Object.assign({name:y.previousName,content:y.previousContent,favorite:y.previousFavorite,executeOnSelection:y.previousExecuteOnSelection,contexts:y.previousContexts},a(P,["reference","persistencyKey","id"])));break;case w.operationType.UpdateVariantViaChangeUpdate:z=x.getChange();v(V,Object.assign({name:y.previousName,content:y.previousContent,favorite:y.previousFavorite,executeOnSelection:y.previousExecuteOnSelection,contexts:y.previousContexts},a(P,["reference","persistencyKey","id"])));var A=z.getRevertData().pop();z.setContent(A.previousContent);z.setState(A.previousState);break;case w.operationType.StateUpdate:default:break;}V.setState(y.previousState);return V;};w.overrideStandardVariant=function(P){var i=F.getCompVariantsMap(P.reference)[P.persistencyKey];var x=i.byId[i.standardVariant.getId()];x.setExecuteOnSelection(!!P.executeOnSelection);var y=x.getChanges();x.removeAllChanges();y.forEach(function(z){f.applyChangeOnVariant(x,z);});};w.persist=function(P){function i(E,B){return h.write({flexObjects:[E.getDefinition()],layer:E.getLayer(),transport:E.getRequest(),isLegacyVariant:E.isVariant()}).then(function(G){if(G&&G.response&&G.response[0]){E.setResponse(G.response[0]);}else{E.setState(S.PERSISTED);}return B;}).then(function(B){k(B.changes.comp,E).push(E.getDefinition());return E.getDefinition();});}var x=P.reference;var y=P.persistencyKey;var z=F.getCompVariantsMap(x);var A=z._getOrCreate(y);var B=F.getStorageResponse(x);var D=o(A).filter(n).map(function(E){switch(E.getState()){case S.NEW:s(E);return i(E,B);case S.DIRTY:s(E);return l(E,B);case S.DELETED:s(E);return m(E,A,B);default:break;}});return Promise.all(D);};w.persistAll=function(i){var x=_(F.getCompVariantsMap(i),"_getOrCreate","_initialize");var P=Object.keys(x).map(function(y){return w.persist({reference:i,persistencyKey:y});});return Promise.all(P);};return w;});
