/*!
* OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
*/
sap.ui.define(["./ActionsToolbarRenderer","sap/base/strings/capitalize","sap/ui/core/Control","sap/m/library","sap/ui/core/library","sap/m/Button","sap/m/ActionSheet","sap/ui/base/ManagedObjectObserver","sap/ui/core/Core","sap/ui/integration/cards/actions/CardActions"],function(A,c,C,l,a,B,b,M,d,e){"use strict";var f=l.ButtonType;var H=a.aria.HasPopup;function s(o,p,v,h){return new Promise(function(r){var R;if(typeof v==="function"){R=v(h);if(R instanceof Promise){R.then(function(i){o.setProperty(p,i);r();});return;}}else{R=v;}o.setProperty(p,R);r();});}var g=C.extend("sap.ui.integration.controls.ActionsToolbar",{metadata:{library:"sap.ui.integration",properties:{},aggregations:{actionDefinitions:{type:"sap.ui.integration.ActionDefinition",multiple:true},_toolbar:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"},_actionSheet:{type:"sap.m.ActionSheet",multiple:false,visibility:"hidden"}},events:{visibilityChange:{parameters:{visible:{type:"boolean"}}}}},renderer:A});g.prototype.init=function(){this.setAggregation("_actionSheet",new b());this._aActions=[];this._mActionObservers=new Map();this._oObserver=new M(this._observeActionsAggregation.bind(this));this._oObserver.observe(this,{aggregations:["actionDefinitions"]});};g.prototype.exit=function(){this._oCard=null;this._aActions=null;this._oObserver.disconnect();this._oObserver=null;this._mActionObservers.clear();this._mActionObservers=null;};g.prototype.onBeforeRendering=function(){this._updateVisibility();};g.prototype.initializeContent=function(o){var t=this,h,i=[],j=[],k=this.getAggregation("_actionSheet"),m=o.getHostInstance(),E=o.getAggregation("_extension");if(m){j=j.concat(m.getActions()||[]);}if(E){j=j.concat(E.getActions()||[]);}this._aActions=j;j.forEach(function(n){h=t._createActionButton(n,false);i.push(h);});if(this._aButtons){this._aButtons.forEach(function(n){n.destroy();});}i.forEach(k.addButton,k);this._aButtons=i;this._refreshButtons().then(this._updateVisibility.bind(this));};g.prototype.setCard=function(o){this._oCard=o;};g.prototype._open=function(){this._refreshButtons().then(function(){this.getAggregation("_actionSheet").openBy(this._getToolbar());}.bind(this));};g.prototype._getToolbar=function(){var t=this.getAggregation('_toolbar');if(!t){t=new B({id:this.getId()+"-overflowButton",icon:'sap-icon://overflow',type:f.Transparent,ariaHasPopup:H.Menu,press:function(E){this._open();}.bind(this)});this.setAggregation('_toolbar',t);}return t;};g.prototype._refreshButtons=function(){var h=this._aActions,o=this._oCard,j=this._aButtons,m,k,i,p=[];for(i=0;i<h.length;i++){m=h[i];k=j[i];p.push(s(k,'enabled',m.enabled,o));p.push(s(k,'visible',m.visible,o));}return Promise.all(p);};g.prototype._createActionButton=function(v,i){var S=i?this._getActionConfig(v):v;var o=new B({icon:S.icon,text:S.text,tooltip:S.tooltip,type:S.buttonType,visible:i?S.visible:false,press:function(E){var m=i?this._getActionConfig(v):v;e.fireAction({card:this._oCard,host:this._oCard.getHostInstance(),action:m,parameters:m.parameters,source:E.getSource()});}.bind(this)});if(i){o.setEnabled(S.enabled);}return o;};g.prototype._updateVisibility=function(){var v=this.getAggregation("_actionSheet").getButtons().some(function(o){return o.getVisible();});this.fireVisibilityChange({visible:v});this.setVisible(v);};g.prototype._getActionConfig=function(o){var S=["visible","enabled","icon","text","tooltip","parameters","buttonType","type"].reduce(function(m,k){m[k]=o["get"+c(k)]();return m;},{});S.action=function(){o.firePress();};return S;};g.prototype._observeActionsAggregation=function(o){var h=o.child;if(o.mutation==="insert"){var i=this._createActionButton(h,true);this.getAggregation("_actionSheet").addButton(i);h.setAssociation("_menuButton",i);var j=new M(this._observeSingleAction.bind(this));j.observe(h,{properties:true,aggregations:["tooltip"]});this._mActionObservers.set(h.getId(),j);this._updateVisibility();}else if(o.mutation==="remove"){d.byId(h.getAssociation("_menuButton")).destroy();this._mActionObservers.get(h.getId()).disconnect();this._mActionObservers.delete(h.getId());}};g.prototype._observeSingleAction=function(o){var h=o.object,n=o.name,i=d.byId(h.getAssociation("_menuButton")),v=o.current;if(["type","parameters"].indexOf(n)!==-1){return;}if(o.type==="aggregation"){v=o.child;}if(n==="buttonType"){n="type";}i["set"+c(n)](v);this._updateVisibility();};return g;});
