/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['./FormElement','sap/ui/layout/library'],function(F,l){"use strict";var S=F.extend("sap.ui.layout.form.SemanticFormElement",{metadata:{library:"sap.ui.layout",properties:{delimiter:{type:"string",group:"Data",defaultValue:"/"}},aggregations:{fieldLabels:{type:"sap.ui.core.Label",multiple:true},_delimiters:{type:"sap.ui.core.Control",multiple:true,visibility:"hidden"},_displayField:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}}}});S.prototype.init=function(){F.prototype.init.apply(this,arguments);this._oObserver.observe(this,{properties:["_editable","delimiter"],aggregations:["fieldLabels"]});};S.prototype.exit=function(){F.prototype.exit.apply(this,arguments);};S.prototype.enhanceAccessibilityState=function(E,A){var D=this.getAggregation("delimiters",[]);if(D.indexOf(E)<0){if(this.getProperty("_editable")){var i=this.indexOfField(E);if(i>=0){var n=this.getFieldLabels();var L=n[i];if(L){var t;if(typeof L==="string"){t=L;}else{t=L.getText();}var s=A["label"];if(!s){s=t;}else{s=s+" "+t;}A["label"]=s;var o=A["labelledby"];if(o){L=this.getLabelControl();var p=o.split(" ");i=p.indexOf(L.getId());if(i>=0){p.splice(i,1);o=p.join(" ");}A["labelledby"]=o;}return A;}}}}F.prototype.enhanceAccessibilityState.apply(this,arguments);};S.prototype.onLayoutDataChange=function(E){var o=E.srcControl;var L=o.getLayoutData();if(!L||!L._bSetBySemanticFormElement){m.call(this);}F.prototype.onLayoutDataChange.apply(this,arguments);};S.prototype.getFieldsForRendering=function(){var n=[];if(!this._bLayoutDataCreated){m.call(this);}if(this.getProperty("_editable")){var o=this.getFields();var D=this.getAggregation("_delimiters",[]);for(var i=0;i<o.length;i++){var p=o[i];if(p.getVisible()){if(n.length>0&&D[i-1]){n.push(D[i-1]);}n.push(p);}}}else{var q=this.getAggregation("_displayField");if(q){n.push(q);}}return n;};S.prototype._observeChanges=function(C){F.prototype._observeChanges.apply(this,arguments);if(C.object===this){if(C.name==="fields"){a.call(this,C.child,C.mutation);}else if(C.name==="_editable"){_.call(this,C.current);}else if(C.name==="delimiter"){b.call(this,C.current);}else if(C.name==="fieldLabels"){c.call(this,C.mutation,C.child);}}else{if(C.object.isA("sap.ui.core.Label")){e.call(this,C);}else{d.call(this,C);}}};function _(E){if(E){this.destroyAggregation("_displayField");f.call(this);}else{this.destroyAggregation("_delimiters");g.call(this);}}function a(o,M){if(M==="insert"){if(!o.isA("sap.ui.core.IFormContent")||!o.isA("sap.ui.core.ISemanticFormContent")){throw new Error(o+" is not valid Form content. "+this);}var p=["visible"];if(o.getFormValueProperty){p.push(o.getFormValueProperty());}else if(o.getMetadata().getProperty("value")){p.push("value");}else if(o.getMetadata().getProperty("text")){p.push("text");}this._oObserver.observe(o,{properties:p});}else{var L=o.getLayoutData();if(L&&L._bSetBySemanticFormElement){L.destroy();}}if(this.getProperty("_editable")){f.call(this);}else{g.call(this,true);}k.call(this);}function b(D){if(this.getProperty("_editable")){f.call(this);}else{h.call(this,false);}k.call(this);}function c(M,L){if(typeof L!=="string"){if(M==="insert"){this._oObserver.observe(L,{properties:["text"]});}else{this._oObserver.unobserve(L);}}k.call(this);}function d(C){var p=C.object.getFormValueProperty?C.object.getFormValueProperty():null;if(C.name===p||C.name==="value"||C.name==="text"){if(!this.getProperty("_editable")){h.call(this,false);}}else if(C.name==="visible"){if(this.getProperty("_editable")){f.call(this);}else{g.call(this,true);}k.call(this);this.invalidate();}}function e(C){k.call(this);}function f(){var n=this.getFields();var D=this.getAggregation("_delimiters",[]);var s=this.getDelimiter();var I=this.getId()+"-delimiter-";var i=0;for(i=0;i<n.length;i++){if(i<n.length-1){if(D.length>i){l.form.FormHelper.updateDelimiter(D[i],s);}else{var o=l.form.FormHelper.createDelimiter(s,I+i);this.addAggregation("_delimiters",o);}}}if(D.length>0&&D.length>n.length-1){for(i=n.length-1;i<D.length;i++){D[i].destroy();}}m.call(this);}var r={onBeforeRendering:function(){h.call(this,true);}};function g(s){var D=this.getAggregation("_displayField");if(D){h.call(this,false);}else{var i=this.getId()+"-display";D=l.form.FormHelper.createSemanticDisplayControl("",i);D.addDelegate(r,true,this);this.setAggregation("_displayField",D);}}function h(n){var D=this.getAggregation("_displayField");if(D&&(D.getDomRef()||n)){if(n&&D._bNoForceUpdate){D._bNoForceUpdate=false;return;}var o=this.getFields();var t=[];var A=false;for(var i=0;i<o.length;i++){var p=o[i];if(p.getVisible()){var P=p.getFormValueProperty?p.getFormValueProperty():null;var T;if(p.getFormFormattedValue){T=p.getFormFormattedValue();if(T instanceof Promise){A=true;}}else if(P){T=p.getProperty(P);}else if(p.getMetadata().getProperty("value")){T=p.getValue();}else if(p.getMetadata().getProperty("text")){T=p.getText();}t.push(T);}}D._bNoForceUpdate=true;if(A){Promise.all(t).then(function(t){var D=this.getAggregation("_displayField");var s=j.call(this,t);D._bNoForceUpdate=true;l.form.FormHelper.updateSemanticDisplayControl(D,s);}.bind(this));}else{var s=j.call(this,t);l.form.FormHelper.updateSemanticDisplayControl(D,s);}}else if(D&&D._bNoForceUpdate){D._bNoForceUpdate=false;}}function j(t){var D=this.getDelimiter();var T="";for(var i=0;i<t.length;i++){T=T+t[i];if(i<t.length-1){T=T+" "+D+" ";}}return T;}function k(){if(!this.getLabel()){var n=this.getFieldLabels();var o=this.getFields();var t=[];for(var i=0;i<n.length;i++){if(o[i]&&o[i].getVisible()){var p=n[i];if(typeof p==="string"){t.push(p);}else{t.push(p.getText());}}}var T=j.call(this,t);this._setInternalLabel(T);}}function m(){var n=this.getFields().filter(function(t){return t.getVisible();});var D=this.getAggregation("_delimiters",[]);var o=this.getParent();var p=o&&o.getParent();var L=p&&p.getLayout();var q;var i=0;if(!L||!L.getLayoutDataForDelimiter){return;}if(this.getProperty("_editable")){for(i=0;i<D.length;i++){var s=D[i];if(!s.getLayoutData()){q=L.getLayoutDataForDelimiter();if(q){if(q instanceof Promise){q.then(function(q){q._bSetBySemanticFormElement=true;this.setLayoutData(q);}.bind(s));}else if(q.isA("sap.ui.core.LayoutData")){q._bSetBySemanticFormElement=true;s.setLayoutData(q);}}}}if(n.length>1){for(i=0;i<n.length;i++){var t=n[i];q=t.getLayoutData();if(!q||q._bSetBySemanticFormElement){q=L.getLayoutDataForSemanticField(n.length,i+1,q);if(q){if(q instanceof Promise){q.then(function(q){q._bSetBySemanticFormElement=true;this.setLayoutData(q);}.bind(t));}else if(q.isA("sap.ui.core.LayoutData")&&!q._bSetBySemanticFormElement){q._bSetBySemanticFormElement=true;t.setLayoutData(q);}}}}}this._bLayoutDataCreated=true;}}return S;});
