/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(["sap/ui/core/Core","sap/ui/mdc/library","sap/ui/mdc/ActionToolbar","sap/m/OverflowToolbarRenderer","sap/m/OverflowToolbarButton","sap/m/OverflowToolbarToggleButton","sap/m/Title","sap/ui/mdc/library","sap/ui/mdc/chart/ChartTypeButton","sap/ui/mdc/chart/ChartSettings","./ChartSelectionDetails"],function(C,a,A,O,b,c,T,M,d,e,f){"use strict";var g=A.extend("sap.ui.mdc.chart.ChartToolbar",{metadata:{library:"sap.ui.mdc",interfaces:[],defaultAggregation:"",properties:{},aggregations:{},associations:{},events:{}},renderer:O});var h=sap.ui.getCore().getLibraryResourceBundle("sap.ui.mdc");g.prototype.init=function(){A.prototype.init.apply(this,arguments);};g.prototype.createToolbarContent=function(m){this.setEnabled(false);var t=new T(m.getId()+"-title",{text:m.getHeader()});this.addBegin(t);this._oChartSelectionDetails=new f(m.getId()+"-selectionDetails",{});this._oChartSelectionDetails.attachBeforeOpen(function(E){this._updateSelectionDetailsActions(m);}.bind(this));this.addEnd(this._oChartSelectionDetails);var p=m.getP13nMode()||[];if(p.indexOf("Item")>-1&&(!m.getIgnoreToolbarActions().length||m.getIgnoreToolbarActions().indexOf(M.ChartToolbarActionType.DrillDownUp)<0)){this._oDrillDownBtn=new b(m.getId()+"-drillDown",{icon:"sap-icon://drill-down",tooltip:h.getText("chart.CHART_DRILLDOWN_TITLE"),text:h.getText("chart.CHART_DRILLDOWN_TITLE"),press:function(E){m._showDrillDown(this._oDrillDownBtn);}.bind(this)});this.addEnd(this._oDrillDownBtn);}if(!m.getIgnoreToolbarActions().length||m.getIgnoreToolbarActions().indexOf(M.ChartToolbarActionType.Legend)<0){this._oLegendBtn=new c(m.getId()+"btnLegend",{type:"Transparent",text:h.getText("chart.LEGENDBTN_TEXT"),tooltip:h.getText("chart.LEGENDBTN_TOOLTIP"),icon:"sap-icon://legend",pressed:"{$mdcChart>/legendVisible}"});this.addEnd(this._oLegendBtn);}if(!m.getIgnoreToolbarActions().length||m.getIgnoreToolbarActions().indexOf(M.ChartToolbarActionType.ZoomInOut)){this.oZoomInButton=new b(m.getId()+"btnZoomIn",{icon:"sap-icon://zoom-in",tooltip:h.getText("chart.TOOLBAR_ZOOM_IN"),text:h.getText("chart.TOOLBAR_ZOOM_IN"),press:function i(o){m.zoomIn();this.toggleZoomButtons(m);}.bind(this)});this.oZoomOutButton=new b(m.getId()+"btnZoomOut",{icon:"sap-icon://zoom-out",tooltip:h.getText("chart.TOOLBAR_ZOOM_OUT"),text:h.getText("chart.TOOLBAR_ZOOM_OUT"),press:function i(o){m.zoomOut();this.toggleZoomButtons(m);}.bind(this)});this.addEnd(this.oZoomInButton);this.addEnd(this.oZoomOutButton);}if(p.indexOf("Sort")>-1||p.indexOf("Item")>-1){this._oSettingsBtn=new b(m.getId()+"-chart_settings",{icon:"sap-icon://action-settings",tooltip:h.getText('chart.PERSONALIZATION_DIALOG_TITLE'),text:h.getText('chart.PERSONALIZATION_DIALOG_TITLE'),press:function(E){m.getEngine().uimanager.show(m,m.getP13nMode());}});this.addEnd(this._oSettingsBtn);}if(m._getTypeBtnActive()){this._oChartTypeBtn=new d(m);this.addEnd(this._oChartTypeBtn);}};g.prototype.toggleZoomButtons=function(m){var z=this._getZoomEnablement(m);if(z.enabled){this.oZoomInButton.setEnabled(z.enabledZoomIn);this.oZoomOutButton.setEnabled(z.enabledZoomOut);}else{this.oZoomInButton.setEnabled(false);this.oZoomOutButton.setEnabled(false);}};g.prototype.updateToolbar=function(m){this.toggleZoomButtons(m);if(!this._toolbarInitialUpdated){this.setEnabled(true);this._toolbarInitialUpdated=true;}var s=m.getSelectionHandler();if(s){this._oChartSelectionDetails.attachSelectionHandler(s.eventId,s.listener);}};g.prototype._getZoomEnablement=function(m){var z;try{z=m.getZoomState();}catch(i){z={enabled:false};}if(z&&z.hasOwnProperty("currentZoomLevel")&&z.currentZoomLevel!=null&&z.enabled){var t={enabled:true};t.enabledZoomOut=z.currentZoomLevel>0;t.enabledZoomIn=z.currentZoomLevel<1;return t;}else{return{enabled:false};}};g.prototype._updateSelectionDetailsActions=function(m){var s=m.getSelectionDetailsActions(),o;if(s){var S=this._oChartSelectionDetails.getItems();S.forEach(function(I){var j=s.getDetailsItemActions();j.forEach(function(k){o=k.clone();I.addAction(o);});});var D=s.getDetailsActions();this._oChartSelectionDetails.removeAllActions();D.forEach(function(j){o=j.clone();this._oChartSelectionDetails.addAction(o);}.bind(this));var i=s.getActionGroups();this._oChartSelectionDetails.removeAllActionGroups();i.forEach(function(j){o=j.clone();this._oChartSelectionDetails.addActionGroup(o);}.bind(this));}};return g;});
