/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['sap/ui/mdc/field/ConditionType','sap/ui/model/SimpleType','sap/ui/model/FormatException','sap/ui/model/ParseException','sap/ui/model/ValidateException','sap/base/util/merge','sap/ui/base/SyncPromise'],function(C,S,F,P,V,m,a){"use strict";var b=S.extend("sap.ui.mdc.field.ConditionsType",{constructor:function(o,g){S.apply(this,arguments);this.sName="Conditions";o=_(o);this._oConditionType=new C(o,this.oConstraints);this._oResourceBundle=sap.ui.getCore().getLibraryResourceBundle("sap.ui.mdc");}});b.prototype.destroy=function(){S.prototype.destroy.apply(this,arguments);if(this._oConditionType){this._oConditionType.destroy();this._oConditionType=undefined;}this._bDestroyed=true;};b.prototype.setFormatOptions=function(o){S.prototype.setFormatOptions.apply(this,arguments);o=_(o);if(this._oConditionType){this._oConditionType.setFormatOptions(o);}};function _(o){o=m({},o);if(o.asyncParsing){delete o.asyncParsing;}return o;}b.prototype.setConstraints=function(o){S.prototype.setConstraints.apply(this,arguments);if(this._oConditionType){this._oConditionType.setConstraints(this.oConstraints);}};b.prototype.formatValue=function(g,I){if(g==undefined||g==null||this._bDestroyed){return null;}if(!Array.isArray(g)){throw new F("No valid conditions provided");}var v;if(!I||I==="string"||I==="any"){v="";}else if(I==="float"||I==="int"){v=0;}var M=e.call(this);var s=[];var h=function(o,I){return a.resolve().then(function(){return this._oConditionType.formatValue(o,I);}.bind(this));};for(var i=0;i<g.length;i++){s.push(h.call(this,g[i],I));if(M>0&&i>=M-1){break;}}return a.all(s).then(function(j){return c.call(this,j,v);}.bind(this)).unwrap();};function c(g,v){for(var i=0;i<g.length;i++){if(v){v=v+this._oResourceBundle.getText("field.SEPARATOR")+g[i];}else{v=g[i];}}return v;}b.prototype.parseValue=function(v,i){if(this._bDestroyed){return null;}if(e.call(this)!==1){throw new P("Only one condition supported for parsing");}var o=a.resolve().then(function(){return this._oConditionType.parseValue(v,i);}.bind(this)).then(function(o){return d.call(this,o);}.bind(this)).unwrap();if(o instanceof Promise&&this.oFormatOptions.asyncParsing){this.oFormatOptions.asyncParsing(o);}return o;};function d(o){var I=f(this.oFormatOptions.valueType);if(I&&this.oFormatOptions.getConditions){var u=o&&o.values[0][1];var g=o&&o.inParameters;var O=o&&o.outParameters;var h=this.oFormatOptions.getConditions();for(var i=0;i<h.length;i++){h[i].values[0][1]=u;if(u===undefined){h[i].values[0][0]=o.values[0][0];}h[i].values[0].splice(2);if(h[i].operator==="BT"){h[i].values[1][1]=u;if(u===undefined){h[i].values[1][0]=o.values[0][0];}h[i].values[1].splice(2);}if(g||h[i].inParameters){h[i].inParameters=g;}if(O||h[i].outParameters){h[i].outParameters=O;}}if(h.length===0){h.push(o);}return h;}else if(o){return[o];}else{return[];}}b.prototype.validateValue=function(g){if(g===undefined||g===null||this._bDestroyed){return;}if(!Array.isArray(g)){throw new V("No valid conditions provided");}for(var i=0;i<g.length;i++){var o=g[i];this._oConditionType.validateValue(o);}var M=e.call(this);if(g.length===0&&M===1){this._oConditionType.validateValue(null);}};function e(){var M=1;if(this.oFormatOptions.hasOwnProperty("maxConditions")){M=this.oFormatOptions.maxConditions;}return M;}function f(t){if(t&&t.isA("sap.ui.model.CompositeType")){var o=t.getFormatOptions();var s=!o||!o.hasOwnProperty("showMeasure")||o.showMeasure;var g=!o||!o.hasOwnProperty("showNumber")||o.showNumber;if(s&&!g){return true;}}return false;}return b;});
