/*
 * ! OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(["sap/ui/mdc/field/content/DefaultContent","sap/ui/mdc/enum/BaseType","sap/ui/mdc/util/DateUtil","sap/ui/mdc/condition/FilterOperatorUtil","sap/ui/mdc/condition/Operator","sap/ui/core/library"],function(D,B,a,F,O,c){"use strict";var C=c.CalendarType;var S;var b;var d;var e=Object.assign({},D,{getEditMultiLine:function(){return[null];},getEdit:function(){return["sap/m/DynamicDateRange","sap/ui/mdc/condition/OperatorDynamicDateOption","sap/ui/mdc/field/DynamicDateRangeConditionsType","sap/m/StandardDynamicDateRangeKeys","sap/m/DynamicDateUtil","sap/m/DynamicDateFormat"];},getEditOperator:function(){return{"EQ":{name:"sap/m/DatePicker",create:this._createDatePickerControl},"BT":{name:"sap/m/DateRangeSelection",create:this._createDateRangePickerControl}};},getEditForHelp:function(){return D.getEdit.apply(this,arguments);},getUseDefaultFieldHelp:function(){return{name:"defineConditions",oneOperatorSingle:false,oneOperatorMulti:true,single:false,multi:true};},createEditMultiLine:function(){throw new Error("sap.ui.mdc.field.content.DateContent - createEditMultiLine not defined!");},_createDatePickerControl:function(o,f,i){var g=f[0];var h=o.getConditionsType();o.setHideOperator(true);this._adjustDataTypeForDate(o);var j=new g(i,{value:{path:"$field>/conditions",type:h},displayFormat:o.getDisplayFormat(),valueFormat:o.getValueFormat(),placeholder:"{$field>/placeholder}",textAlign:"{$field>/textAlign}",textDirection:"{$field>/textDirection}",required:"{$field>/required}",editable:{path:"$field>/editMode",formatter:o.getMetadata()._oClass._getEditable},enabled:{path:"$field>/editMode",formatter:o.getMetadata()._oClass._getEnabled},valueState:"{$field>/valueState}",valueStateText:"{$field>/valueStateText}",width:"100%",tooltip:"{$field>/tooltip}",change:o.getHandleContentChange()});if(j.setDisplayFormatType){j.setDisplayFormatType(o.getCalendarType());}j._setPreferUserInteraction(true);o.setAriaLabelledBy(j);o.setBoundProperty("value");return[j];},_createDateRangePickerControl:function(o,f,i){var g=f[0];var h=o.getConditionsType();this._adjustDataTypeForDate(o);var j=new g(i,{value:{path:"$field>/conditions",type:h},displayFormat:o.getDisplayFormat(),valueFormat:o.getValueFormat(),delimiter:"...",displayFormatType:o.getCalendarType(),placeholder:"{$field>/placeholder}",textAlign:"{$field>/textAlign}",textDirection:"{$field>/textDirection}",required:"{$field>/required}",editable:{path:"$field>/editMode",formatter:o.getMetadata()._oClass._getEditable},enabled:{path:"$field>/editMode",formatter:o.getMetadata()._oClass._getEnabled},valueState:"{$field>/valueState}",valueStateText:"{$field>/valueStateText}",width:"100%",tooltip:"{$field>/tooltip}",change:o.getHandleContentChange()});j._setPreferUserInteraction(true);o.setAriaLabelledBy(j);o.setBoundProperty("value");return[j];},_adjustDataTypeForDate:function(o){var t=o.retrieveDataType();var f=t.getFormatOptions();this._getDatePattern(o,f);if(!f||f.style||!f.pattern||f.pattern!==o.getValueFormat()||!f.calendarType||f.calendarType!==C.Gregorian){o.setDateOriginalType(o.getDataType());o.setDataType(a.createInternalType(t,o.getValueFormat()));o.updateConditionType();}},_getDatePattern:function(o,f){var s=o.getField().getBaseType();switch(s){case B.Date:o.setValueFormat("yyyy-MM-dd");break;case B.DateTime:o.setValueFormat("yyyy-MM-dd'T'HH:mm:ss");break;case B.Time:o.setValueFormat("HH:mm:ss");break;default:return;}o.setDisplayFormat("medium");if(f){if(f.style){o.setDisplayFormat(f.style);}else if(f.pattern){o.setDisplayFormat(f.pattern);}if(f.calendarType){o.setCalendarType(f.calendarType);}}},createEdit:function(o,f,i){var g=f[0];var h=f[1];var j=f[2];if(!S||!b||!d){S=f[3];b=f[4];d=f[5];}var k=o.getConditionsType(false,j);var v;if(o.getField().getMetadata().hasProperty("operators")){var G=function(m){return this._getDateRangeOptions(m,o,h);}.bind(this);v={path:"$field>/operators",formatter:G};}else{v=this._getDateRangeOptions(undefined,o,h);}var l=new g(i,{value:{path:"$field>/conditions",type:k},formatter:this._getDateRangeFormatter(o),placeholder:"{$field>/placeholder}",required:"{$field>/required}",editable:{path:"$field>/editMode",formatter:o.getMetadata()._oClass._getEditable},enabled:{path:"$field>/editMode",formatter:o.getMetadata()._oClass._getEnabled},valueState:"{$field>/valueState}",valueStateText:"{$field>/valueStateText}",width:"100%",tooltip:"{$field>/tooltip}",options:v,change:o.getHandleContentChange()});o.setBoundProperty("value");o.setAriaLabelledBy(g);return[l];},createEditForHelp:function(o,f,i){return D.createEdit.apply(this,arguments);},_getDateRangeOptions:function(o,f,g){if(!o||o.length===0){o=f.getField()._getOperators();}var h=[];for(var i=0;i<o.length;i++){var s=o[i];var j=this._getDateRangeOption(s,f,g);if(j){h.push(j);}}return h;},_getDateRangeOption:function(o,f,g){var h=F.getOperator(o);var s=h.name;if(!S[s]){s=h.alias||s;}if(S[s]){return s;}else if(h){if(!b.getOption(s)){var t=f.retrieveDataType();var v=[];for(var j=0;j<h.valueTypes.length;j++){if(h.valueTypes[j]&&h.valueTypes[j]!==O.ValueType.Static){v.push("custom");}}b.addOption(new g({key:s,operator:h,type:t,valueTypes:v}));}return s;}},_getDateRangeFormatter:function(o){var t=o.retrieveDataType();var f=t.getFormatOptions();var g={};if(f.style){g.date={style:f.style};}else if(f.pattern){g.date={pattern:f.pattern};}return d.getInstance(g);}});return e;});
