/*
 * ! OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(["sap/ui/mdc/filterbar/p13n/GroupContainer","sap/ui/mdc/filterbar/p13n/FilterGroupLayout","sap/ui/mdc/filterbar/p13n/TableContainer","sap/ui/mdc/filterbar/p13n/FilterColumnLayout","sap/ui/mdc/filterbar/FilterBarBase","sap/ui/mdc/filterbar/FilterBarBaseRenderer"],function(G,F,T,a,b,c){"use strict";var A=b.extend("sap.ui.mdc.filterbar.p13n.AdaptationFilterBar",{metadata:{library:"sap.ui.mdc",properties:{adaptationControl:{type:"object"}},events:{change:{}}},renderer:c});A.prototype.init=function(){b.prototype.init.apply(this,arguments);this._bPersistValues=true;};A.prototype._initControlDelegate=function(){this._retrieveMetadata().then(function(){this._applyInitialFilterConditions();}.bind(this));};A.prototype.setMessageStrip=function(s){this._oFilterBarLayout.setMessageStrip(s);};A.prototype.setLiveMode=function(l,s){b.prototype.setLiveMode.apply(this,arguments);if(!l){this._oConditionModel.detachPropertyChange(this._handleConditionModelPropertyChange,this);}this._oConditionModel.attachPropertyChange(function(e){var k=e.getParameter("path").substring(12);if(this.oAdaptationModel){var i=this.oAdaptationModel.getProperty("/items");var I=i.find(function(o){return o.name==k;});if(I){I.isFiltered=this._getConditionModel().getConditions(k).length>0?true:false;this.oAdaptationModel.setProperty("/items",i);}}}.bind(this));return this;};A.prototype.createConditionChanges=function(){var C=this._getModelConditions(this._getConditionModel(),false,true);if(this._bPersistValues){return this.getEngine().createChanges({control:this.getAdaptationControl(),key:"Filter",state:C,suppressAppliance:true});}else{this.getAdaptationControl()._setXConditions(C,true);return Promise.resolve(null);}};A.prototype.setP13nModel=function(p){this.oAdaptationModel=p;this._oFilterBarLayout.update();};A.prototype.getP13nModel=function(p){return this.oAdaptationModel;};A.prototype._handleFilterItemSubmit=function(){return;};A.prototype._getWaitForChangesPromise=function(){return this.getEngine().waitForChanges(this.getAdaptationControl());};A.prototype.applyConditionsAfterChangesApplied=function(){b.prototype.applyConditionsAfterChangesApplied.apply(this,arguments);this.triggerSearch();};A.prototype.initPropertyHelper=function(){return this.getAdaptationControl().awaitPropertyHelper().then(function(p){this._oPropertyHelper=p;}.bind(this));};A.prototype.createFilterFields=function(){return this.initialized().then(function(){var C=this._bPersistValues?this.getAdaptationControl().getFilterConditions():this.getAdaptationControl()._getXConditions();this._setXConditions(C,true);if(this._bFilterFieldsCreated){return this;}var o=this.getAdaptationControl();var d=o.getControlDelegate();var f=this._checkAdvancedParent(o)?d:d.getFilterDelegate();this._mOriginalsForClone={};var e=[];this.oAdaptationModel.getProperty("/items").forEach(function(i,I){var g;g=this._checkExisting(i,f);g.then(function(h){var j;if(this._checkAdvancedParent(o)){if(h._bTemporaryOriginal){delete g._bTemporaryOriginal;this._mOriginalsForClone[h.getFieldPath()]=h;}j=h.clone();}else{j=h;}i.filterfield=j;}.bind(this));e.push(g);}.bind(this));return Promise.all(e).then(function(){this.oAdaptationModel.getProperty("/items").forEach(function(i){this.addAggregation("filterItems",i.filterfield);delete i.filterfield;}.bind(this));if(this._oFilterBarLayout.getInner().setP13nModel){this._oFilterBarLayout.getInner().setP13nModel(this.oAdaptationModel);}this._bFilterFieldsCreated=true;return this;}.bind(this));}.bind(this));};A.prototype._checkExisting=function(i,f){var o;var d=this.getAdaptationControl();var e=this._checkAdvancedParent(d)?d.getFilterItems():[];var E=e.reduce(function(m,g){m[g.getFieldPath()]=g;return m;},{});if(E[i.name]){o=Promise.resolve(E[i.name]);}else{o=f.addItem(i.name,this.getAdaptationControl());o=o.then(function(g){if(!g){throw new Error("No FilterField could be created for property: '"+i.name+"'.");}g._bTemporaryOriginal=true;return g;});}return o;};A.prototype.executeRemoves=function(){var e=this._oFilterBarLayout.getInner().getSelectedFields();var o=[];Object.keys(this._mOriginalsForClone).forEach(function(k){var d=this.getAdaptationControl().getControlDelegate();if(e.indexOf(k)<0){var r=d.removeItem.call(d,k,this.getAdaptationControl()).then(function(C){if(C&&this._mOriginalsForClone[k]){this._mOriginalsForClone[k].destroy();delete this._mOriginalsForClone[k];}}.bind(this));o.push(r);}}.bind(this));return Promise.all(o);};A.prototype._checkAdvancedParent=function(C){if(!C.isA("sap.ui.mdc.IFilterSource")&&!C.isA("sap.ui.mdc.IFilter")){throw new Error("The 'adaptationControl' needs to implement the IFilterSource or IFilter interface");}return C.isA("sap.ui.mdc.IFilter");};A.prototype.setAdaptationControl=function(C,s){this.setProperty("adaptationControl",C,s);this._checkAdvancedParent(C);this._cLayoutItem=this._checkAdvancedParent(C)?F:a;this._oFilterBarLayout=this._checkAdvancedParent(C)?new G():new T();this._oFilterBarLayout.getInner().setParent(this);this.setAggregation("layout",this._oFilterBarLayout,true);this.addStyleClass("sapUIAdaptationFilterBar");if(this._oFilterBarLayout.getInner().attachChange){this._oFilterBarLayout.getInner().attachChange(function(){this.fireChange();}.bind(this));}return this;};A.prototype.exit=function(){b.prototype.exit.apply(this,arguments);for(var k in this._mOriginalsForClone){this._mOriginalsForClone[k].destroy();}this._mOriginalsForClone=null;this.oAdaptationModel=null;};return A;});
