/*
 * ! OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['sap/ui/core/XMLComposite','sap/m/Text','sap/m/Link','sap/m/Label'],function(X,T,L,c){"use strict";var C=X.extend("sap.ui.mdc.link.ContactDetails",{metadata:{library:"sap.ui.mdc",defaultAggregation:"items",aggregations:{items:{type:"sap.ui.mdc.link.ContactDetailsItem",multiple:true,singularName:"item"}}}});C.prototype.applySettings=function(){X.prototype.applySettings.apply(this,arguments);var r=sap.ui.getCore().getLibraryResourceBundle("sap.ui.mdc");var v=this._getCompositeAggregation();v.getItems().forEach(function(s,i){this._addEmailsToSimpleForm(this.getItems()[i],s,r);this._addPhonesToSimpleForm(this.getItems()[i],s,r);this._addAddressesToSimpleForm(this.getItems()[i],s,r);},this);};C.prototype._addEmailsToSimpleForm=function(o,s,r){o.getEmails().filter(function(a){return!a.processed&&!!a.getTypes()&&(a.getTypes().indexOf("preferred")>-1||a.getTypes().indexOf("work")>-1);}).sort(function(a,b){if(a.getTypes().indexOf("preferred")>-1&&b.getTypes().indexOf("preferred")<0){return-1;}if(b.getTypes().indexOf("preferred")>-1&&a.getTypes().indexOf("preferred")<0){return 1;}return 0;}).forEach(function(a){this._addLabeledLink("email",r.getText("info.POPOVER_CONTACT_SECTION_EMAIL"),a,s);a.processed=true;},this);};C.prototype._addPhonesToSimpleForm=function(o,s,r){o.getPhones().filter(function(a){return!a.processed&&!!a.getTypes()&&a.getTypes().indexOf("work")>-1;}).sort(function(a,b){if(a.getTypes().indexOf("preferred")>-1){return-1;}if(b.getTypes().indexOf("preferred")>-1){return 1;}return 0;}).forEach(function(a){this._addLabeledLink("phone",r.getText("info.POPOVER_CONTACT_SECTION_PHONE"),a,s);a.processed=true;},this);o.getPhones().filter(function(a){return!a.processed&&!!a.getTypes()&&a.getTypes().indexOf("cell")>-1;}).sort(function(a,b){if(a.getTypes().indexOf("preferred")>-1){return-1;}if(b.getTypes().indexOf("preferred")>-1){return 1;}return 0;}).forEach(function(a){this._addLabeledLink("phone",r.getText("info.POPOVER_CONTACT_SECTION_MOBILE"),a,s);a.processed=true;},this);o.getPhones().filter(function(a){return!a.processed&&!!a.getTypes()&&a.getTypes().indexOf("fax")>-1;}).sort(function(a,b){if(a.getTypes().indexOf("preferred")>-1){return-1;}if(b.getTypes().indexOf("preferred")>-1){return 1;}return 0;}).forEach(function(a){this._addLabeledLink("phone",r.getText("info.POPOVER_CONTACT_SECTION_FAX"),a,s);a.processed=true;},this);o.getPhones().filter(function(a){return!a.processed&&!!a.getTypes()&&a.getTypes().indexOf("preferred")>-1;}).forEach(function(a){this._addLabeledLink("phone",r.getText("info.POPOVER_CONTACT_SECTION_PHONE"),a,s);a.processed=true;},this);};C.prototype._addAddressesToSimpleForm=function(o,s,r){o.getAddresses().filter(function(a){return!a.processed&&!!a.getTypes()&&(a.getTypes().indexOf("preferred")>-1||a.getTypes().indexOf("work")>-1);}).sort(function(a,b){if(a.getTypes().indexOf("preferred")>-1&&b.getTypes().indexOf("preferred")<0){return-1;}if(b.getTypes().indexOf("preferred")>-1&&a.getTypes().indexOf("preferred")<0){return 1;}return 0;}).forEach(function(a){this._addLabeledAddress(a,s,r);a.processed=true;},this);};C.prototype._addLabeledAddress=function(o,s,r){var a=function(S,d,e,R,f){var v=[];if(S){v.push(S);}if(d&&e){v.push(d+" "+e);}else{if(d){v.push(d);}if(e){v.push(e);}}if(R){v.push(R);}if(f){v.push(f);}return v.join(', ');};var A=function(S,d,e,R,f){return!!(S||d||e||R||f);};var p;var b;if(o.getBindingPath("street")&&o.getBindingPath("code")&&o.getBindingPath("locality")&&o.getBindingPath("region")&&o.getBindingPath("country")){p=[{path:o.getBindingPath("street")?o.getBindingPath("street"):"$notExisting"},{path:o.getBindingPath("code")?o.getBindingPath("code"):"$notExisting"},{path:o.getBindingPath("locality")?o.getBindingPath("locality"):"$notExisting"},{path:o.getBindingPath("region")?o.getBindingPath("region"):"$notExisting"},{path:o.getBindingPath("country")?o.getBindingPath("country"):"$notExisting"}];b=new T();b.bindProperty("text",{parts:p,formatter:a});b.bindProperty("visible",{parts:p,formatter:A});}else{b=new T({text:a(o.getStreet(),o.getCode(),o.getLocality(),o.getRegion(),o.getCountry()),visible:A(o.getStreet(),o.getCode(),o.getLocality(),o.getRegion(),o.getCountry())});}var l=new c({text:r.getText("info.POPOVER_CONTACT_SECTION_ADR"),labelFor:b.getId()});s.addContent(l);s.addContent(b);};C.prototype._addLabeledLink=function(l,s,o,S){var a;if(o.getBindingPath("uri")){a=new L();a.bindProperty("href",{path:o.getBindingPath("uri"),formatter:function(v){return(l==="email"?"mailto:":"tel:")+v;}});a.bindProperty("text",{path:o.getBindingPath("uri")});a.bindProperty("visible",{path:o.getBindingPath("uri"),formatter:function(v){return!!v;}});}else{a=new L({href:l==="email"?"mailto:":"tel:"+o.getUri(),text:o.getUri(),visible:!!o.getUri()});}var b=new c({text:s,labelFor:a.getId()});S.addContent(b);S.addContent(a);};return C;});
