/*
 * ! OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(["../../TableDelegate","../../util/loadModules","../../library","sap/m/ColumnPopoverSelectListItem","sap/m/MessageBox","sap/ui/core/Item","sap/ui/core/Core","sap/ui/core/library","sap/ui/core/format/ListFormat","sap/ui/base/ManagedObjectObserver"],function(T,l,a,C,M,I,b,c,L,d){"use strict";var f=a.TableType;var g=new window.WeakMap();var D=Object.assign({},T);D.fetchPropertyHelper=function(e,P,F){return l("sap/ui/mdc/table/V4AnalyticsPropertyHelper").then(function(R){return R[0];});};D.fetchPropertyExtensions=function(e,P){return Promise.resolve(null);};D.fetchPropertiesForBinding=function(e){return this.fetchProperties(e);};D.fetchPropertyExtensionsForBinding=function(e,P){return this.fetchPropertyExtensions(e,P);};D.formatGroupHeader=function(e,F,P){};D.preInit=function(e){if(!g.has(e)){g.set(e,{});}return y(e).then(function(){s(e);});};D.validateState=function(e,S,K){var F=T.validateState.apply(this,arguments);var V;var R=sap.ui.getCore().getLibraryResourceBundle("sap.ui.mdc");if(K=="Sort"&&S.sorters){if(x(e)&&!t(e,S.items,S.sorters)){V={validation:c.MessageType.Information,message:R.getText("table.PERSONALIZATION_DIALOG_SORT_RESTRICTION")};}}else if(K=="Group"&&S.aggregations){var G=Object.keys(S.aggregations);var H=[];var J=L.getInstance();G.forEach(function(P){var O=e.getPropertyHelper().getProperty(P);if(O&&O.groupable){H.push(P);}});if(H.length){V={validation:c.MessageType.Information,message:R.getText("table.PERSONALIZATION_DIALOG_GROUP_RESTRICTION",[J.format(H)])};}}else if(K=="Column"){var N;var G=S.aggregations&&Object.keys(S.aggregations);if(!t(e,S.items,G)){N=R.getText("table.PERSONALIZATION_DIALOG_TOTAL_RESTRICTION");}if(x(e)&&!t(e,S.items,S.sorters)){N=N?N+"\n"+R.getText("table.PERSONALIZATION_DIALOG_SORT_RESTRICTION"):R.getText("table.PERSONALIZATION_DIALOG_SORT_RESTRICTION");}if(N){V={validation:c.MessageType.Information,message:N};}}return u(F,V);};D.updateBinding=function(F,G,H){if(!H||H.getPath()!=G.path){this.rebindTable(F,G);return;}var R=H.getRootBinding();var J=R&&!R.isSuspended();try{if(J){R.suspend();}s(F,G);H.changeParameters(G.parameters);H.filter(G.filters,"Application");H.sort(G.sorter);}catch(e){this.rebindTable(F,G);if(R==H){J=false;}}finally{if(J&&R.isSuspended()){R.resume();}}};D.rebind=function(e,F){s(e,F);T.rebindTable(e,F);};D.addColumnMenuItems=function(e,F){var P=e.getPropertyHelper();var G=P.getProperty(F.getDataProperty());var H=[];if(!G){return[];}if(e.isGroupingEnabled()&&v(e)){var J=G.getGroupableProperties();if(J.length>0){H.push(h(J,F));}}if(e.isAggregationEnabled()&&w(e)){var K=G.getAggregatableProperties();if(K.length>0){H.push(i(K,F));}}var N=e._oPopover;if(N){N.getItems().forEach(function(O,Q,H){var R=O.getLabel();var S=b.getLibraryResourceBundle("sap.ui.mdc");if(R===S.getText("table.SETTINGS_GROUP")||R===S.getText("table.SETTINGS_TOTALS")){H[Q].destroy();}if(H.length==0){N.destroy();}});}return H;};function h(G,e){var F=G.map(function(H){return new I({text:H.label,key:H.name});});if(F.length>0){return new C({items:F,label:b.getLibraryResourceBundle("sap.ui.mdc").getText("table.SETTINGS_GROUP"),icon:"sap-icon://group-2",action:[{sName:"Group",oMDCColumn:e},j,this]});}}function i(e,F){var G=e.map(function(H){return new I({text:H.label,key:H.name});});if(G.length>0){return new C({items:G,label:b.getLibraryResourceBundle("sap.ui.mdc").getText("table.SETTINGS_TOTALS"),icon:"sap-icon://sum",action:[{sName:"Aggregate",oMDCColumn:F},j,this]});}}function j(e,F){var N=F.sName,G=F.oMDCColumn.getParent(),H=G.getCurrentState().groupLevels||[],J=G.getCurrentState().aggregations||{},K=Object.keys(J),O=false,P=e.getParameter("property"),Q=N==="Aggregate"?H:K,R=Q.filter(function(X){return N==="Aggregate"?X.name===P:X===P;}).length>0;if(R){var S=b.getLibraryResourceBundle("sap.ui.mdc");var U;var V;var W;if(N==="Aggregate"){U=S.getText("table.SETTINGS_WARNING_TITLE_TOTALS");V=S.getText("table.SETTINGS_MESSAGE2");W=S.getText("table.SETTINGS_WARNING_BUTTON_TOTALS");}else{U=S.getText("table.SETTINGS_WARNING_TITLE_GROUPS");V=S.getText("table.SETTINGS_MESSAGE1");W=S.getText("table.SETTINGS_WARNING_BUTTON_GROUP");}O=true;M.warning(V,{id:G.getId()+"-messageBox",title:U,actions:[W,S.getText("table.SETTINGS_WARNING_BUTTON_CANCEL")],onClose:function(X){if(X===W){k(N,G,P);}}});}if(N==="Aggregate"&&!O){o(N,G,P);}else if(N==="Group"&&!O){o(N,G,P);}}function o(e,F,P){if(e==="Group"){F._onCustomGroup(P);}else{F._onCustomAggregate(P);}}function k(N,e,P){if(N==="Aggregate"){e._onCustomGroup(P);e._onCustomAggregate(P);}else if(N==="Group"){e._onCustomAggregate(P);e._onCustomGroup(P);}}function s(e,F){var P=g.get(e).plugin;if(!P||P.isDestroyed()){return;}var G=e._getGroupedProperties().map(function(K){return K.name;});var H=Object.keys(e._getAggregatedProperties());var S=F?F.parameters["$search"]:undefined;if(S){delete F.parameters["$search"];}var J={visible:m(e),groupLevels:G,grandTotal:H,subtotals:H,columnState:n(e,H),search:S};P.setAggregationInfo(J);}function m(e){var V=new Set();var P=g.get(e).oPropertyHelperForBinding;e.getColumns().forEach(function(F){var G=P.getProperty(F.getDataProperty());if(!G){return;}if(G.isComplex()){G.getReferencedProperties().forEach(function(G){V.add(G.name);});}else{V.add(G.name);}});return Array.from(V);}function n(e,F){var G={};e.getColumns().forEach(function(H){var J=H.getId()+"-innerColumn";var K=q(e,H,F);var N=K.length>0;if(J in G){G[J].subtotals=N||G[J].subtotals;G[J].grandTotal=N||G[J].grandTotal;return;}G[J]={subtotals:N,grandTotal:N};r(e,K).forEach(function(U){J=U.getId()+"-innerColumn";if(J in G){G[J].subtotals=N||G[J].subtotals;G[J].grandTotal=N||G[J].grandTotal;}else{G[J]={subtotals:N,grandTotal:N};}});});return G;}function p(e,F){var P=e.getPropertyHelper().getProperty(F.getDataProperty());if(!P){return[];}else if(P.isComplex()){return P.getReferencedProperties();}else{return[P];}}function q(e,F,G){return p(e,F).filter(function(P){return G.includes(P.name);});}function r(e,P){var U=[];P.forEach(function(F){if(F.unitProperty){U.push(F.unitProperty);}});return e.getColumns().filter(function(F){return p(e,F).some(function(G){return U.includes(G);});});}function t(e,F,S){var P,G=[];F&&F.forEach(function(H){P=e.getPropertyHelper().getProperty(H.name);if(!P.isComplex()){G.push(P.name);}else{P.getReferencedProperties().forEach(function(R){G.push(R.name);});}});var O=S?S.every(function(H){return G.find(function(J){return H.name?H.name===J:H===J;});}):true;return O;}function u(e,V){var S={Error:1,Warning:2,Information:3,None:4};if(!V||S[V.validation]-S[e.validation]>0){return e;}else{return V;}}function v(e){return e._isOfType(f.Table);}function w(e){return e._isOfType(f.Table);}function x(e){return(e.isGroupingEnabled()||e.isAggregationEnabled())&&e._isOfType(f.Table);}function y(e){if(e._isOfType(f.Table)){return(x(e)?z(e):A(e)).then(function(){return E(e);});}return Promise.resolve();}function z(e){var F=g.get(e);var P=F.plugin;if(P&&!P.isDestroyed()){P.activate();return Promise.resolve();}return Promise.all([e.awaitPropertyHelper(),l("sap/ui/table/plugins/V4Aggregation")]).then(function(R){var V=R[1][0];var G=e.getControlDelegate();P=new V({groupHeaderFormatter:function(H,J){return G.formatGroupHeader(e,H,J);}});e._oTable.addDependent(P);F.plugin=P;return B(e);}).then(function(G){P.setPropertyInfos(G.getProperties());});}function A(e){var F=g.get(e);if(F.plugin){F.plugin.deactivate();}return Promise.resolve();}function B(e){var F=g.get(e);if(F.oPropertyHelperForBinding){return Promise.resolve(F.oPropertyHelperForBinding);}var G=e.getControlDelegate();var P;var H;return G.fetchPropertiesForBinding(e).then(function(J){P=J;return G.fetchPropertyExtensionsForBinding(e,P);}).then(function(J){H=J;return G.fetchPropertyHelper(e,P,H);}).then(function(J){var K=J.constructor===J;F.oPropertyHelperForBinding=K?J:new J(P,H,e);return F.oPropertyHelperForBinding;});}function E(e){var F=g.get(e);if(!F.observer){F.observer=new d(function(G){if(G.type==="destroy"){if(F.oPropertyHelperForBinding){F.oPropertyHelperForBinding.destroy();}}else{y(e);}});F.observer.observe(e,{properties:["p13nMode"],destroy:true});}}return D;});
