/*
* ! OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
*/
sap.ui.define(["./PropertyHelper","sap/m/Button","sap/m/Bar","sap/m/Title","sap/base/util/merge","sap/m/MessageBox","sap/ui/Device"],function(P,B,a,T,m,M,D){"use strict";var r=sap.ui.getCore().getLibraryResourceBundle("sap.ui.mdc");var b={createP13nPopover:function(p,d){return new Promise(function(c,e){sap.ui.require(["sap/m/ResponsivePopover"],function(R){b["_checkSettings"](p,d,e);var o=new R({title:d.title,horizontalScrolling:d.hasOwnProperty("horizontalScrolling")?d.horizontalScrolling:false,verticalScrolling:d.hasOwnProperty("verticalScrolling")?d.verticalScrolling:false,contentWidth:d.contentWidth?d.contentWidth:"24rem",resizable:d.hasOwnProperty("resizable")?d.resizable:true,contentHeight:d.contentHeight?d.contentHeight:"35rem",placement:d.placement?d.placement:"Bottom",content:p,afterClose:d.afterClose?d.afterClose:function(){}});if(d.reset){var C=b._createResetHeader({title:d.title,reset:d.reset.onExecute,idResetButton:d.reset.idButton,warningText:d.reset.warningText});o.setCustomHeader(C);}c(o);},e);});},createP13nDialog:function(p,d){return new Promise(function(c,e){b["_checkSettings"](p,d,e);var i=d.id;sap.ui.require(["sap/m/Dialog","sap/m/Button"],function(f,B){var R=sap.ui.getCore().getLibraryResourceBundle("sap.ui.mdc");var C=new f(i,{title:d.title,horizontalScrolling:d.hasOwnProperty("horizontalScrolling")?d.horizontalScrolling:false,verticalScrolling:d.hasOwnProperty("verticalScrolling")?d.verticalScrolling:true,contentWidth:d.contentWidth?d.contentWidth:"40rem",contentHeight:d.contentHeight?d.contentHeight:"55rem",draggable:true,resizable:true,stretch:D.system.phone,content:p,afterClose:d.afterClose?d.afterClose:function(){},buttons:[new B(i?i+"-confirmBtn":undefined,{text:d.confirm&&d.confirm.text?d.confirm.text:R.getText("p13nDialog.OK"),type:"Emphasized",press:function(){if(d.confirm&&d.confirm.handler){d.confirm.handler.apply(C,arguments);}}}),new B(i?i+"-cancelBtn":undefined,{text:R.getText("p13nDialog.CANCEL"),press:function(){d.cancel.apply(C,arguments);}})]});if(d.reset){var o=b._createResetHeader({title:d.title,idResetButton:d.reset.idButton,reset:d.reset.onExecute,warningText:d.reset.warningText});C.setCustomHeader(o);}var A=d.additionalButtons;if(A instanceof Array){A.forEach(function(g){if(!g.isA("sap.m.Button")){e("Please only provide sap.m.Button instances as 'additionalButtons'");}C.addButton(g);});}c(C);},e);});},_createResetHeader:function(s){var o=new a({contentLeft:[new T({text:s.title})]});if(s.reset){var i=s.idResetButton;o.addContentRight(new B(i,{text:sap.ui.getCore().getLibraryResourceBundle("sap.ui.mdc").getText("p13nDialog.RESET"),press:function(e){var d=e.getSource().getParent().getParent();var c=d.getParent();var R=s.warningText?s.warningText:sap.ui.getCore().getLibraryResourceBundle("sap.ui.mdc").getText("filterbar.ADAPT_RESET_WARNING");M.warning(R,{actions:[M.Action.OK,M.Action.CANCEL],emphasizedAction:M.Action.OK,onClose:function(A){if(A===M.Action.OK){d.getButtons()[0].focus();s.reset(c);}}});}}));}return o;},prepareAdaptationData:function(p,e,g){var o=p&&p.getProperties instanceof Function?p:new P(p);var i=[];var I=g?{}:null;var E=e instanceof Function;o.getProperties().forEach(function(c){var d={};if(E){var f=e(d,c);if(!f){return;}}d.name=c.name;d.label=c.label||c.name;d.tooltip=c.tooltip;if(I){d.group=c.group?c.group:"BASIC";d.groupLabel=c.groupLabel;I[d.group]=I[d.group]?I[d.group]:[];I[d.group].push(d);}i.push(d);});var A={items:i};if(I){A.itemsGrouped=this._buildGroupStructure(I);}return A;},sortP13nData:function(s,i){var p=s;var c=p.position;var S=p.visible;var l=sap.ui.getCore().getConfiguration().getLocale().toString();var C=window.Intl.Collator(l,{});i.sort(function(f,F){if(f[S]&&F[S]){return(f[c]||0)-(F[c]||0);}else if(f[S]){return-1;}else if(F[S]){return 1;}else if(!f[S]&&!F[S]){return C.compare(f.label,F.label);}});},_buildGroupStructure:function(i){var g=[];Object.keys(i).forEach(function(G){this.sortP13nData("generic",i[G]);g.push({group:G,groupLabel:i[G][0].groupLabel||r.getText("p13nDialog.FILTER_DEFAULT_GROUP"),groupVisible:true,items:i[G]});}.bind(this));return g;},_isExcludeProperty:function(p,i){return i.some(function(k){var I=k.ignoreKey;var v=k.ignoreValue;return p[I]===v;});},_checkSettings:function(p,d,o){if(!d){o("Please provide a settings object for p13n creation");}if(!d.title&&!d.customHeader){o("Please provide a title or customHeader in the settings object for p13n creation");}},arrayToMap:function(A){return A.reduce(function(c,p,i){c[p.name]=p;c[p.name].position=i;return c;},{});}};return b;});
