/*
 * ! OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(["./BasePanel","sap/m/Label","sap/base/util/deepEqual","sap/m/CustomListItem","sap/m/List","sap/m/Panel","sap/m/Toolbar","sap/m/Text","sap/ui/core/Icon","sap/ui/core/library","sap/m/HBox","sap/m/library"],function(B,L,d,C,a,P,T,b,I,c,H,l){"use strict";var e=c.IconColor;var F=l.FlexJustifyContent;var f=l.ListKeyboardMode;var G=B.extend("sap.ui.mdc.p13n.panels.GroupView",{metadata:{library:"sap.ui.mdc"},renderer:{apiVersion:2}});G.prototype.init=function(){B.prototype.init.apply(this,arguments);this.addStyleClass("sapUiMDCGroupView");var g=new C({visible:"{"+this.P13N_MODEL+">groupVisible}",accDescription:{path:this.P13N_MODEL+">groupLabel",formatter:function(s){return this.getResourceText("p13nDialog.FILTER_GROUP_DESCRIPTION",s);}.bind(this)},content:[this._createGroupPanelTemplate()]});this._bShowFactory=true;this.displayColumns();this._aInitializedLists=[];this.setTemplate(g);this._setMoveButtonVisibility(true);};G.prototype.getShowFactory=function(){return this._bShowFactory;};G.prototype.getPanels=function(){var p=[];this._oListControl.getItems().forEach(function(i){p.push(i.getContent()[0]);});return p;};G.prototype._createGroupPanelTemplate=function(){var g=this.P13N_MODEL;return new P({expandable:true,expanded:{path:this.P13N_MODEL+">group",formatter:function(){if(this.getBindingContext(g)){var E=this.getBindingContext(g).sPath.split("/")[2]==="0";return E;}else{return false;}}},expand:function(E){var s=E.getSource();var i=s.getContent()[0];this._addInitializedList(i);if(this.getShowFactory()){this._addFactoryControl(i);this.filterWithoutDestroy(this._aCurrentFilters);}}.bind(this),width:"100%",headerToolbar:[new T({content:[new L({wrapping:true,text:"{"+this.P13N_MODEL+">groupLabel}",design:"Bold"})]})],content:[this._createGroupListTemplate()]});};G.prototype._createGroupListTemplate=function(){var o=new a({keyboardMode:f.Navigation,selectionChange:function(g){var p=g.getParameter("listItem").getBindingContext(this.P13N_MODEL).sPath;var i=this.getP13nModel().getProperty(p);var h=this.getModel(this.P13N_MODEL);if(h&&i){h.setProperty(p+"/selected",i.visible);}this.fireChange({reason:i.visible?"Add":"Remove",item:i});}.bind(this),showSeparators:"None",mode:"MultiSelect"});o.bindItems(this._getItemsBinding());return o;};G.prototype._addFactoryControl=function(o){if(o.getItems().length==0||o.getItems()[0].getContent().length<2){o.getItems().forEach(function(i){var g=i.getBindingContext(this.P13N_MODEL);var h=this.getItemFactory().call(this,g);if(h){i.addContent(h);i.getContent()[0].getItems()[0].setLabelFor(h.getId());}if(i.getContent()[0].getItems().length>1){i.getContent()[0].removeItem(1);}}.bind(this));}this.addStyleClass("sapUiMDCAFLabelMarking");};G.prototype._createInnerListControl=function(){var o=new a(this.getId()+"-innerGroupViewList",Object.assign(this._getListControlConfig(),{mode:"None",infoToolbar:new T(),updateStarted:function(E){this._checkAllPanels();}.bind(this)}));return o;};G.prototype._getItemsBinding=function(){var g=function(){var i=[new H({width:"100%",justifyContent:F.SpaceBetween,items:[new L({required:"{"+this.P13N_MODEL+">required}",text:"{"+this.P13N_MODEL+">label}"})]})];return new C({selected:"{"+this.P13N_MODEL+">visible}",tooltip:"{"+this.P13N_MODEL+">tooltip}",content:i});}.bind(this);return{path:this.P13N_MODEL+">items",templateShareable:false,template:g()};};G.prototype._getIconTemplate=function(){return new H({width:"18.5%",justifyContent:F.Center,items:[new I({src:"sap-icon://circle-task-2",size:"0.5rem",color:e.Neutral,visible:{path:this.P13N_MODEL+">isFiltered",formatter:function(i){if(i){return true;}else{return false;}}}})]});};G.prototype._loopGroupList=function(g){this._oListControl.getItems().forEach(function(o){var p=o.getContent()[0];var i=p.getContent()[0];this._loopItems(i,function(h,k){g(h,k);});}.bind(this));};G.prototype._loopItems=function(o,i){o.getItems().forEach(function(g){var p=g.getBindingContextPath();var k=this.getP13nModel().getProperty(p).name;i.call(this,g,k);}.bind(this));};G.prototype._removeFactoryControl=function(){this._loopGroupList(function(i,k){if(i.getContent()[1]){i.removeContent(i.getContent()[1]);var o=i.getParent();this._addInitializedList(o);var g=this._getIconTemplate();i.getContent()[0].addItem(g);}}.bind(this));this.removeStyleClass("sapUiMDCAFLabelMarking");return this._aInitializedLists||[];};G.prototype._addInitializedList=function(o){var s=o.getId();if(this._aInitializedLists.indexOf(s)<0){this._aInitializedLists.push(s);}};G.prototype._getInitializedLists=function(){var g=[];this._aInitializedLists.forEach(function(s){var o=sap.ui.getCore().byId(s);if(o){g.push(o);}});return g;};G.prototype.getSelectedFields=function(){var s=[];this._oListControl.getItems().forEach(function(o){var p=o.getContent()[0];var i=p.getContent()[0];this._loopItems(i,function(g,k){if(g.getSelected()){s.push(k);}});}.bind(this));return s;};G.prototype.filterWithoutDestroy=function(g){if(!this._bInitialized||d(g,this._aCurrentFilters)){return;}var i=this._removeFactoryControl();this._oListControl.getItems().forEach(function(o){var p=o.getContent()[0];var h=p.getContent()[0];if(h.getBinding("items")){h.getBinding("items").filter(g,true);this._togglePanelVisibility(p);}if(this.getShowFactory()&&i.indexOf(h.getId())>-1){this._addFactoryControl(h);}}.bind(this));this._aCurrentFilters=g;};G.prototype.showFactory=function(s){this._bShowFactory=s;this.displayColumns();if(s){this._getInitializedLists().forEach(function(i){this._addFactoryControl(i);}.bind(this));}else{this._removeFactoryControl();}};G.prototype._checkAllPanels=function(){this._oListControl.getItems().forEach(function(o){var p=o.getContent()[0];this._togglePanelVisibility(p);}.bind(this));};G.prototype.setGroupExpanded=function(g,E){this._oListControl.getItems().forEach(function(o){var p=o.getContent()[0];var s=p.getBindingContext(this.P13N_MODEL).sPath;var i=this.getP13nModel().getProperty(s);if(i.group===g){p.setExpanded(E);}},this);};G.prototype._togglePanelVisibility=function(p){var i=p.getContent()[0];var o=p.getBindingContext(this.P13N_MODEL);if(o){var s=o.sPath;var g=this.getP13nModel().getProperty(s);g.groupVisible=i.getVisibleItems().length<1?false:true;this.getP13nModel().setProperty(s,g);}};G.prototype._checkFirstGroup=function(){if(!this._bInitialized&&this._oListControl&&this._oListControl.getItems().length>0){this._bInitialized=true;var o=this._oListControl.getItems()[0].getContent()[0].getContent()[0];this._addFactoryControl(o);this._addInitializedList(o);}};G.prototype.displayColumns=function(){var p=this._oListControl.getInfoToolbar().removeAllContent();p.forEach(function(o){o.destroy();});this._oListControl.getInfoToolbar().addContent(new b({width:"75%",text:this.getResourceText("p13nDialog.LIST_VIEW_COLUMN")}).addStyleClass("firstColumnPadding"));if(!this._bShowFactory){this._oListControl.getInfoToolbar().addContent(new b({textAlign:"Center",width:"25%",text:this.getResourceText("p13nDialog.LIST_VIEW_ACTIVE")}).addStyleClass("firstColumnPadding"));}};G.prototype.setP13nModel=function(m){this.setModel(m,this.P13N_MODEL);this._bindListItems();this._checkFirstGroup();this._checkAllPanels();};G.prototype._bindListItems=function(){this._oListControl.bindItems(Object.assign({path:this.P13N_MODEL+">/itemsGrouped",templateShareable:false,key:"group",template:this.getTemplate().clone()}));};G.prototype.exit=function(){B.prototype.exit.apply(this,arguments);this._aInitializedLists=null;this._bShowFactory=false;this._bInitialized=false;};return G;});
