/*
 * ! OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['sap/base/util/array/diff','sap/ui/base/Object','sap/ui/mdc/p13n/FlexUtil','sap/ui/mdc/p13n/P13nBuilder','sap/base/util/merge','sap/base/util/deepEqual','sap/ui/model/json/JSONModel','sap/m/p13n/SelectionPanel'],function(d,B,F,P,m,a,J,S){"use strict";var b=B.extend("sap.ui.mdc.p13n.subcontroller.BaseController",{constructor:function(c){B.call(this);this._oAdaptationControl=c;this._oP13nData=null;this._bLiveMode=false;this._bResetEnabled=false;}});b.prototype.getUISettings=function(){return{title:"Adaptation Dialog"};};b.prototype.getAdaptationControl=function(){return this._oAdaptationControl;};b.prototype.getLiveMode=function(){return this._bLiveMode;};b.prototype.getChangeOperations=function(){return{add:null,remove:null,move:null};};b.prototype.getResetEnabled=function(){return this._bResetEnabled;};b.prototype.getSelectorForReset=function(){return this._oAdaptationControl;};b.prototype.sanityCheck=function(s){return s;};b.prototype.getAdaptationUI=function(p){var s=new S();var A=this.mixInfoAndState(p);s.setP13nData(A.items);this._oPanel=s;return Promise.resolve(s);};b.prototype.getCurrentState=function(){return this._oAdaptationControl.getCurrentState().items;};b.prototype.getDelta=function(p){var s=this._getPresenceAttribute(p.externalAppliance);var n;var f=function(i){return i.hasOwnProperty(s)&&i[s]===false?false:true;};n=p.applyAbsolute?p.changedState.filter(f):this._getFilledArray(p.existingState,p.changedState,s).filter(f);p.changedState=n;if(a(p.existingState,n)){return[];}else{return this.getArrayDeltaChanges(p);}};b.prototype.getArrayDeltaChanges=function(D){var e=D.existingState;var c=D.changedState;var C=D.control;var i=D.changeOperations.add;var r=D.changeOperations.remove;var M=D.changeOperations.move;var g=D.generator;var f=D.deltaAttributes||[];var s=function(o){var k="";f.forEach(function(A){k=k+o[A];});return k;};var R=d(e,c,s);var h=function(o,A){return A.filter(function(E){return E&&(E.name===o.name);})[0];};var j=[];var p=e.slice(0);R.forEach(function(o){if(o.type==="delete"&&p[o.index]===undefined){p.splice(o.index,1);return;}var k,E,l;if(o.type==="insert"){E=h(c[o.index],p);if(E){E.index=p.indexOf(E);p.splice(E.index,1,undefined);j=j.concat(this._createAddRemoveChange(C,r,F._getChangeContent(E,f),g));}}k=o.type==="delete"?p[o.index]:c[o.index];k.index=o.index;if(o.type==="delete"){p.splice(k.index,1);}else{p.splice(k.index,0,k);}if(M){l=j.length;if(l){E=j[l-1];E=E?E.changeSpecificData.content:undefined;}if(E&&E.name===k.name&&o.index!=E.index){j.pop();j=j.concat(this._createMoveChange(E.id,E.name,o.index,M,C,M!=="moveSort",g));return;}}j=j.concat(this._createAddRemoveChange(C,o.type==="delete"?r:i,F._getChangeContent(k,f),g));}.bind(this));return j;};b.prototype._createAddRemoveChange=function(c,o,C){var A={selectorElement:c,changeSpecificData:{changeType:o,content:C}};return A;};b.prototype._createMoveChange=function(i,p,n,M,c,e){var o={selectorElement:c,changeSpecificData:{changeType:M,content:{id:i,name:p,index:n}}};if(!e){delete o.changeSpecificData.content.id;}return o;};b.prototype._getPresenceAttribute=function(c){return"visible";};b.prototype.getBeforeApply=function(){return Promise.resolve();};b.prototype.mixInfoAndState=function(p){var i=this.getCurrentState();var I=P.arrayToMap(i);var o=P.prepareAdaptationData(p,function(c,e){var E=I[e.name];c.visible=!!E;c.position=E?E.position:-1;return e.visible;});P.sortP13nData({visible:"visible",position:"position"},o.items);o.items.forEach(function(c){delete c.position;});return o;};b.prototype.getP13nData=function(){return this._oPanel?this._oPanel.getP13nData():this._oAdaptationModel.getProperty("/items");};b.prototype.model2State=false;b.prototype.update=function(p){if(this._oPanel){var A=this.mixInfoAndState(p);this._oPanel.setP13nData(A.items);}else if(this._oAdaptationModel){var o=this.mixInfoAndState(p);this._oAdaptationModel.setProperty("/items",o.items);this._oAdaptationModel.setProperty("/itemsGrouped",o.itemsGrouped);}};b.prototype._getFilledArray=function(p,n,r){var N=m([],p);var c=m([],n);var e=P.arrayToMap(p);c.forEach(function(i){var E=e[i.name];if(!i.hasOwnProperty(r)||i[r]){var f=i.position;if(E){f=f>-1?f:E.position;var o=E.position;N.splice(f,0,N.splice(o,1)[0]);}else{f=f>-1?f:N.length;N.splice(f,0,i);}N[f]=i;}else if(E){N[E.position][r]=false;}});return N;};b.prototype._getP13nModel=function(p){if(!this._oAdaptationModel){this._oAdaptationModel=new J(this.mixInfoAndState(p));this._oP13nData=this._oAdaptationModel.getData();this._oAdaptationModel.setSizeLimit(10000);}else{this.update(p);}return this._oAdaptationModel;};b.prototype.destroy=function(){B.prototype.destroy.apply(this,arguments);this._oAdaptationControl=null;this._bLiveMode=null;this._oPanel=null;this._bResetEnabled=null;this._oAdaptationModel=null;};return b;});
