/*
 * ! OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(["sap/ui/mdc/valuehelp/base/ListContent","sap/ui/mdc/util/loadModules","sap/ui/mdc/enum/ConditionValidated","sap/ui/model/ParseException","sap/ui/mdc/enum/SelectType"],function(L,l,C,P,S){"use strict";var F=L.extend("sap.ui.mdc.valuehelp.content.FixedList",{metadata:{library:"sap.ui.mdc",interfaces:["sap.ui.mdc.valuehelp.ITypeaheadContent","sap.ui.mdc.valuehelp.IDialogContent"],properties:{groupable:{type:"boolean",group:"Appearance",defaultValue:false},filterList:{type:"boolean",group:"Appearance",defaultValue:true}},aggregations:{items:{type:"sap.ui.mdc.field.ListFieldHelpItem",multiple:true,singularName:"item"}},defaultAggregation:"items",events:{}}});F.prototype.init=function(){L.prototype.init.apply(this,arguments);this._oResourceBundle=sap.ui.getCore().getLibraryResourceBundle("sap.ui.mdc");};F.prototype.exit=function(){if(this._oManagedObjectModel){this._oManagedObjectModel.destroy();delete this._oManagedObjectModel;}L.prototype.exit.apply(this,arguments);};F.prototype.getContent=function(){return this._retrievePromise("content",function(){return l(["sap/m/List","sap/m/DisplayListItem","sap/m/library","sap/ui/model/Filter","sap/ui/model/Sorter","sap/ui/model/base/ManagedObjectModel"]).then(function(m){var i=m[0];var D=m[1];var k=m[2];var n=m[3];var o=m[4];var M=m[5];this._oManagedObjectModel=new M(this);var I=new D(this.getId()+"-item",{type:k.ListType.Active,label:"{$help>text}",value:"{$help>additionalText}",valueTextDirection:"{$help>textDirection}"}).addStyleClass("sapMComboBoxNonInteractiveItem");var p=new n({path:"text",test:c.bind(this),caseSensitive:true});var s;if(this.getGroupable()){s=new o("groupKey",false,f.bind(this));}var q=new i(this.getId()+"-List",{width:"100%",showNoData:false,mode:k.ListMode.SingleSelectMaster,rememberSelections:false,items:{path:"$help>/items",template:I,filters:p,sorter:s,templateShareable:false},itemPress:a.bind(this)}).addStyleClass("sapMComboBoxBaseList").addStyleClass("sapMComboBoxList");q.setModel(this._oManagedObjectModel,"$help");this.setAggregation("displayContent",q,true);return q;}.bind(this));}.bind(this));};function _(){return this.getAggregation("displayContent");}function a(E){var i=E.getParameter("listItem");var s=i.getSelected();if(s){var o=h.call(this,i);var k=j.call(this,o);b.call(this,k,i.getLabel());this.fireSelect({type:S.Set,conditions:this.getConditions()});this.fireConfirm();}}function b(k,v){var o=this._createCondition(k,v);this.setProperty("conditions",[o],true);return o;}function c(t){var i=this.getFilterList();return!i||d.call(this,t,this.getFilterValue());}function d(t,s){return!s||(typeof s==="string"&&(this.getCaseSensitive()?t.startsWith(s):t.toLowerCase().startsWith(s.toLowerCase())));}function e(){var o=_.call(this);if(o){var B=o.getBinding("items");B.update();o.updateItems();o.invalidate();g.call(this);}}function f(o){var k=o.getProperty('groupKey');var t=o.getProperty('groupText');return{key:k,text:t};}function g(){var o=_.call(this);if(o){var k=this.getConditions();var s;var m=this.getFilterValue();var u=this.getUseFirstMatch();var n=false;if(k.length>0&&(k[0].validated===C.Validated||k[0].operator==="EQ")){s=k[0].values[0];}var I=o.getItems();for(var i=0;i<I.length;i++){var p=I[i];if(p.isA("sap.m.DisplayListItem")){var O=h.call(this,p);if(k.length>0&&j.call(this,O)===s){p.setSelected(true);}else if(k.length===0&&u&&m&&!n&&d.call(this,p.getLabel(),m)){p.setSelected(true);n=true;}else if(this.hasOwnProperty("_iNavigateIndex")&&i===this._iNavigateIndex){p.setSelected(true);}else{p.setSelected(false);}}}}}function h(i){var p=i.getBindingContextPath();return this._oManagedObjectModel.getProperty(p);}function j(i){var B=i.getBinding("key");if(B){return B.getInternalValue();}else{return i.getKey();}}F.prototype.getItemForValue=function(o){return Promise.resolve().then(function(){if(o.value===null||o.value===undefined){return null;}else if(!o.value&&o.checkDescription){return null;}var I=this.getItems();var k;var i=0;var K;var t;for(i=0;i<I.length;i++){k=I[i];K=j.call(this,k);t=k.getText();if((o.checkKey&&K===o.parsedValue)||(o.checkDescription&&(t===o.value||K==o.value))){return{key:K,description:k.getText()};}}if(o.checkKey&&o.value===""){return null;}if(this.getUseFirstMatch()){for(i=0;i<I.length;i++){k=I[i];t=o.checkDescription?k.getText():k.getKey();if(d.call(this,t,o.value)){K=j.call(this,k);return{key:K,description:k.getText()};}}}var E=this._oResourceBundle.getText("valuehelp.VALUE_NOT_EXIST",[o.value]);var m=o.exception||P;throw new m(E);}.bind(this));};F.prototype.isValidationSupported=function(o){return true;};F.prototype.isSearchSupported=function(){return true;};F.prototype._handleConditionsUpdate=function(o){g.call(this);};F.prototype._handleFilterValueUpdate=function(o){e.call(this);};F.prototype.removeFocus=function(){var o=_.call(this);if(o){o.removeStyleClass("sapMListFocus");}};F.prototype.navigate=function(s){var o=_.call(this);if(!o){return;}o.addStyleClass("sapMListFocus");var k=o.getSelectedItem();var I=o.getItems();var m=I.length;var n=0;var p=this.getFilterList();var q=this.getFilterValue();var r=false;if(!p&&!k){var i=0;if(s>=0){for(i=0;i<I.length;i++){if(!I[i].isA("sap.m.GroupHeaderListItem")&&d.call(this,I[i].getLabel(),q)){n=i;break;}}}else{for(i=I.length-1;i>=0;i--){if(!I[i].isA("sap.m.GroupHeaderListItem")&&d.call(this,I[i].getLabel(),q)){n=i;break;}}}}else if(k){n=o.indexOfItem(k);n=n+s;}else if(s>=0){n=s-1;}else{n=m+s;}var t;if(n<0){n=0;t=true;r=true;}else if(n>=m-1){n=m-1;t=false;}else{t=s>=0;}while(I[n]&&I[n].isA("sap.m.GroupHeaderListItem")){if(t){n++;}else{n--;}}if(n<0||n>m-1){t=!t;r=n<0;n=n<0?0:m-1;while(I[n]&&I[n].isA("sap.m.GroupHeaderListItem")){if(t){n++;}else{n--;}}}var u=I[n];if(u){var U=this.getUseFirstMatch();if(u!==k||(U&&!r)){var O=h.call(this,u);var K=j.call(this,O);if(this.getParent().isOpen()){o.scrollToIndex(n);}else{this._iNavigateIndex=n;}u.setSelected(true);var v=b.call(this,K,u.getLabel());this.fireNavigated({condition:v,itemId:u.getId(),leaveFocus:false});}else if(r){this.fireNavigated({condition:undefined,itemId:undefined,leaveFocus:r});}}};F.prototype.onShow=function(){L.prototype.onShow.apply(this,arguments);var o=_.call(this);if(!o){return;}var s=o.getSelectedItem();if(s){var i=o.indexOfItem(s);o.scrollToIndex(i);}if(this.hasOwnProperty("_iNavigateIndex")){delete this._iNavigateIndex;}};F.prototype.onHide=function(){this.removeFocus();};F.prototype.getValueHelpIcon=function(){if(this.getUseAsValueHelp()){return"sap-icon://slim-arrow-down";}else{return null;}};F.prototype.getAriaAttributes=function(m){return{contentId:this.getId()+"-List",ariaHasPopup:"listbox",roleDescription:null};};F.prototype.shouldOpenOnClick=function(){return!this.getFilterList();};F.prototype.isFocusInHelp=function(){return false;};F.prototype._isSingleSelect=function(E){return true;};F.prototype.shouldOpenOnNavigate=function(){return!L.prototype._isSingleSelect.apply(this);};return F;});
