/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(["./_AggregationHelper","./_Cache","./_ConcatHelper","./_GroupLock","./_Helper","./_MinMaxHelper","sap/base/Log","sap/ui/base/SyncPromise"],function(_,a,b,c,d,e,L,S){"use strict";function f(r,R,A,q,h){var C=function(){},l=null,t=this;a.call(this,r,R,q,true);this.oAggregation=A;this.sDownloadUrl=a.prototype.getDownloadUrl.call(this,"");this.aElements=[];this.aElements.$byPredicate={};this.aElements.$count=undefined;this.aElements.$created=0;this.oLeavesPromise=undefined;if(q.$count&&A.groupLevels.length){q.$$leaves=true;this.oLeavesPromise=new S(function(g){l=function(o){g(parseInt(o.UI5__leaves));};});}this.oFirstLevel=this.createGroupLevelCache(null,h||!!l);this.oGrandTotalPromise=undefined;if(h){this.oGrandTotalPromise=new S(function(g){b.enhanceCache(t.oFirstLevel,A,[l,function(G){var o;if(A["grandTotal like 1.84"]){_.removeUI5grand__(G);}_.setAnnotations(G,true,true,0,_.getAllProperties(A));if(A.grandTotalAtBottomOnly===false){o=Object.assign({},G,{"@$ui5.node.isExpanded":undefined});d.setPrivateAnnotation(G,"copy",o);d.setPrivateAnnotation(o,"predicate","($isTotal=true)");}d.setPrivateAnnotation(G,"predicate","()");g(G);},C]);});}else if(l){b.enhanceCache(t.oFirstLevel,A,[l,C]);}}f.prototype=Object.create(a.prototype);f.prototype.addElements=function(r,o,C,s){var E=this.aElements;function g(h,i){var O=E[o+i],p,P=d.getPrivateAnnotation(h,"predicate");if(O){if(O===h){return;}p=d.getPrivateAnnotation(O,"parent");if(!p){throw new Error("Unexpected element");}if(p!==C||d.getPrivateAnnotation(O,"index")!==s+i){throw new Error("Wrong placeholder");}}else if(o+i>=E.length){throw new Error("Array index out of bounds: "+(o+i));}if(P in E.$byPredicate&&E.$byPredicate[P]!==h){throw new Error("Duplicate predicate: "+P);}E[o+i]=h;E.$byPredicate[P]=h;}if(o<0){throw new Error("Illegal offset: "+o);}if(Array.isArray(r)){r.forEach(g);}else{g(r,0);}};f.prototype.collapse=function(g){var C,h=0,E=this.aElements,G=this.fetchValue(c.$cached,g).getResult(),k=G["@$ui5.node.level"],I=E.indexOf(G),i=I+1;function l(j){delete E.$byPredicate[d.getPrivateAnnotation(E[j],"predicate")];h+=1;}C=d.getPrivateAnnotation(G,"collapsed");d.updateAll(this.mChangeListeners,g,G,C);while(i<E.length&&E[i]["@$ui5.node.level"]>k){l(i);i+=1;}if(this.oAggregation.subtotalsAtBottomOnly!==undefined&&Object.keys(C).length>1){l(i);}d.setPrivateAnnotation(G,"spliced",E.splice(I+1,h));E.$count-=h;return h;};f.prototype.createGroupLevelCache=function(g,h){var A=this.oAggregation,i=_.getAllProperties(A),C,G,l,j,q,t;j=g?g["@$ui5.node.level"]+1:1;l=j>A.groupLevels.length;G=l?A.groupLevels.concat(Object.keys(A.group).sort()):A.groupLevels.slice(0,j);q=_.filterOrderby(this.mQueryOptions,A,j);t=!l&&Object.keys(A.aggregate).some(function(s){return A.aggregate[s].subtotals;});if(g){q.$$filterBeforeAggregate=d.getPrivateAnnotation(g,"filter")+(q.$$filterBeforeAggregate?" and ("+q.$$filterBeforeAggregate+")":"");}if(!h){delete q.$count;q=_.buildApply(A,q,j);}q.$count=true;C=a.create(this.oRequestor,this.sResourcePath,q,true);C.calculateKeyPredicate=f.calculateKeyPredicate.bind(null,g,G,i,l,t);return C;};f.prototype.expand=function(g,G){var C,h,E=this.aElements,o=typeof G==="string"?this.fetchValue(c.$cached,G).getResult():G,I,s=d.getPrivateAnnotation(o,"spliced"),t=this;if(G!==o){d.updateAll(this.mChangeListeners,G,o,_.getOrCreateExpandedObject(this.oAggregation,o));}if(s){d.deletePrivateAnnotation(o,"spliced");I=E.indexOf(o)+1;this.aElements=E.concat(s,E.splice(I));this.aElements.$byPredicate=E.$byPredicate;h=s.length;this.aElements.$count=E.$count+h;s.forEach(function(i){var p=d.getPrivateAnnotation(i,"predicate");if(p){t.aElements.$byPredicate[p]=i;if(d.getPrivateAnnotation(i,"expanding")){d.deletePrivateAnnotation(i,"expanding");h+=t.expand(c.$cached,i).getResult();}}});d.updateAll(t.mChangeListeners,G,o,{"@$ui5.node.groupLevelCount":d.getPrivateAnnotation(o,"groupLevelCount")});return S.resolve(h);}C=d.getPrivateAnnotation(o,"cache");if(!C){C=this.createGroupLevelCache(o);d.setPrivateAnnotation(o,"cache",C);}return C.read(0,this.iReadLength,0,g).then(function(r){var I=t.aElements.indexOf(o)+1,l=o["@$ui5.node.level"],j=d.getPrivateAnnotation(o,"collapsed"),k=t.oAggregation.subtotalsAtBottomOnly!==undefined&&Object.keys(j).length>1,i;if(!o["@$ui5.node.isExpanded"]){d.deletePrivateAnnotation(o,"spliced");return 0;}if(!I){d.setPrivateAnnotation(o,"expanding",true);return 0;}h=r.value.$count;d.setPrivateAnnotation(o,"groupLevelCount",h);d.updateAll(t.mChangeListeners,G,o,{"@$ui5.node.groupLevelCount":h});if(k){h+=1;}if(I===t.aElements.length){t.aElements.length+=h;}else{for(i=t.aElements.length-1;i>=I;i-=1){t.aElements[i+h]=t.aElements[i];delete t.aElements[i];}}t.addElements(r.value,I,C,0);for(i=I+r.value.length;i<I+r.value.$count;i+=1){t.aElements[i]=_.createPlaceholder(l+1,i-I,C);}if(k){j=Object.assign({},j);_.setAnnotations(j,undefined,true,l,_.getAllProperties(t.oAggregation));d.setPrivateAnnotation(j,"predicate",d.getPrivateAnnotation(o,"predicate").slice(0,-1)+",$isTotal=true)");t.addElements(j,I+h-1);}t.aElements.$count+=h;return h;},function(i){d.updateAll(t.mChangeListeners,G,o,d.getPrivateAnnotation(o,"collapsed"));throw i;});};f.prototype.fetchValue=function(g,p,D,l){if(p==="$count"){if(this.oLeavesPromise){return this.oLeavesPromise;}if(this.oAggregation.groupLevels.length){L.error("Failed to drill-down into $count, invalid segment: $count",this.toString(),"sap.ui.model.odata.v4.lib._Cache");return S.resolve();}return this.oFirstLevel.fetchValue(g,p,D,l);}this.registerChange(p,l);return this.drillDown(this.aElements,p,g);};f.prototype.getDownloadQueryOptions=function(q){return _.buildApply(this.oAggregation,_.filterOrderby(q,this.oAggregation),0,true);};f.prototype.getDownloadUrl=function(g,h){return this.sDownloadUrl;};f.prototype.read=function(I,l,p,g,D){var C,F=I,h=l,G,k,H=!!this.oGrandTotalPromise,m=H&&this.oAggregation.grandTotalAtBottomOnly!==true,r=[],i,n,t=this;function o(k,j){var q=G,Q=G.getQueryOptions(),s=d.getPrivateAnnotation(t.aElements[k],"index"),u=t.aElements[k];if(Q.$count){delete Q.$count;G.setQueryOptions(Q,true);}r.push(G.read(s,j-k,0,g.getUnlockedCopy(),D).then(function(R){var v=false,E;if(u!==t.aElements[k]&&R.value[0]!==t.aElements[k]){v=true;k=t.aElements.indexOf(u);if(k<0){k=t.aElements.indexOf(R.value[0]);if(k<0){E=new Error("Collapse before read has finished");E.canceled=true;throw E;}}}t.addElements(R.value,k,q,s);if(v){E=new Error("Collapse or expand before read has finished");E.canceled=true;throw E;}}));}if(m&&!I&&l===1){if(p!==0){throw new Error("Unsupported prefetch length: "+p);}g.unlock();return this.oGrandTotalPromise.then(function(j){return{value:[j]};});}else if(this.aElements.$count===undefined){this.iReadLength=l+p;if(m){if(F){F-=1;}else{h-=1;}}r.push(this.oFirstLevel.read(F,h,p,g,D).then(function(R){var q,s,O=0,j;t.aElements.length=t.aElements.$count=R.value.$count;if(H){t.aElements.$count+=1;t.aElements.length+=1;q=t.oGrandTotalPromise.getResult();switch(t.oAggregation.grandTotalAtBottomOnly){case false:O=1;t.aElements.$count+=1;t.aElements.length+=1;t.addElements(q,0);s=d.getPrivateAnnotation(q,"copy");t.addElements(s,t.aElements.length-1);break;case true:t.addElements(q,t.aElements.length-1);break;default:O=1;t.addElements(q,0);}}t.addElements(R.value,F+O,t.oFirstLevel,F);for(j=0;j<t.aElements.$count;j+=1){if(!t.aElements[j]){t.aElements[j]=_.createPlaceholder(1,j-O,t.oFirstLevel);}}}));}else{for(i=I,n=Math.min(I+l,this.aElements.length);i<n;i+=1){C=d.getPrivateAnnotation(this.aElements[i],"parent");if(C!==G){if(k){o(k,i);G=k=undefined;}if(C){k=i;G=C;}}}if(k){o(k,i);}g.unlock();}return S.all(r).then(function(){var E=t.aElements.slice(I,I+l);E.$count=t.aElements.$count;return{value:E};});};f.prototype.refreshKeptElements=function(){};f.prototype.toString=function(){return this.sDownloadUrl;};f.calculateKeyPredicate=function(g,G,A,l,t,E,T,m){var p;if(!(m in T)){return undefined;}if(g){A.forEach(function(P){if(Array.isArray(P)){d.inheritPathValue(P,g,E);}else if(!(P in E)){E[P]=g[P];}});}p=l&&d.getKeyPredicate(E,m,T)||d.getKeyPredicate(E,m,T,G,true);d.setPrivateAnnotation(E,"predicate",p);if(!l){d.setPrivateAnnotation(E,"filter",d.getKeyFilter(E,m,T,G));}_.setAnnotations(E,l?undefined:false,t,g?g["@$ui5.node.level"]+1:1,g?null:A);return p;};f.create=function(r,R,D,A,q,s,g){var h,H,i;if(A){h=_.hasGrandTotal(A.aggregate);H=!!A.groupLevels.length;i=_.hasMinOrMax(A.aggregate);if(q.$filter&&(h&&!A["grandTotal like 1.84"]||H)){throw new Error("Unsupported system query option: $filter");}if(q.$search&&(h||H)){throw new Error("Unsupported system query option: $search");}if(i){if(h){throw new Error("Unsupported grand totals together with min/max");}if(H){throw new Error("Unsupported group levels together with min/max");}}if(h||H||i){if("$expand"in q){throw new Error("Unsupported system query option: $expand");}if("$select"in q){throw new Error("Unsupported system query option: $select");}return i?e.createCache(r,R,A,q):new f(r,R,A,q,h);}}if(q.$$filterBeforeAggregate){q.$apply="filter("+q.$$filterBeforeAggregate+")/"+q.$apply;delete q.$$filterBeforeAggregate;}return a.create(r,R,q,s,D,g);};return f;},false);
