/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(["sap/ui/fl/Utils","sap/ui/rta/appVariant/AppVariantUtils","sap/ui/core/BusyIndicator","sap/base/util/UriParameters","sap/ui/fl/registry/Settings","sap/ui/fl/write/_internal/appVariant/AppVariantFactory","sap/ui/fl/write/api/FeaturesAPI","sap/base/util/merge","sap/base/Log"],function(F,A,B,U,S,a,b,m,L){"use strict";var o;var c;var r;var C;var _;var g=function(){return F.getAppDescriptor(r);};var G=function(){return S.getInstance();};var s=function(){window.onbeforeunload=_;};var f=function(i){var M=i?"MSG_DO_NOT_CLOSE_BROWSER_CURRENTLY_ADAPTING":"MSG_DO_NOT_CLOSE_BROWSER";_=window.onbeforeunload;window.onbeforeunload=A.handleBeforeUnloadEvent;return A.showMessage(M);};var t=function(i,j){return c.triggerCatalogPublishing(i,j,true);};var T=function(i){return c.triggerCatalogPublishing(i,null,false);};var R=function(i,j){if(o){A.closeOverviewDialog();return this.onGetOverview(true,j);}else if(!o&&i){B.hide();return this.onGetOverview(true,j);}return Promise.resolve();};var d=function(i,I,j){return i?A.navigateToFLPHomepage():R.call(this,!I,j);};var e=function(i,j){if(i&&i.response&&i.response.IAMId){return c.notifyKeyUserWhenPublishingIsReady(i.response.IAMId,j,true);}return Promise.resolve();};var h=function(i,j){if(i&&i.response&&i.response.IAMId&&i.response.inProgress){return c.notifyKeyUserWhenPublishingIsReady(i.response.IAMId,j,false);}return Promise.resolve();};sap.ui.getCore().getEventBus().subscribe("sap.ui.rta.appVariant.manageApps.controller.ManageApps","navigate",function(){if(o){o.destroy();o=null;}});return{onGetOverview:function(i,l){var D=g();return new Promise(function(j){var k=function(){A.closeOverviewDialog();};sap.ui.require(["sap/ui/rta/appVariant/AppVariantOverviewDialog"],function(n){if(!o){o=new n({idRunningApp:D["sap.app"].id,isOverviewForKeyUser:i,layer:l});}o.attachCancel(k);o.oPopup.attachOpened(function(){j(o);});o.open();});});},isOverviewExtended:function(){var u=U.fromQuery(window.location.search);var M=u.get("sap-ui-xx-app-variant-overview-extended");if(!M){return false;}return M.toLowerCase()==='true';},isManifestSupported:function(){var D=g();return A.getManifirstSupport(D["sap.app"].id).then(function(i){return i.response;}).catch(function(E){L.error("Response status code is: "+E.status,"Stacktrace: "+E.stack);return false;});},isSaveAsAvailable:function(i,j,l){r=i;C=l;var D=g();if(D["sap.app"]&&D["sap.app"].id){return b.isSaveAsAvailable(j).then(function(I){if(I){if(D["sap.app"].crossNavigation&&D["sap.app"].crossNavigation.inbounds){return A.getInboundInfo(D["sap.app"].crossNavigation.inbounds);}return A.getInboundInfo();}return undefined;}).then(function(I){return!!I;});}return Promise.resolve(false);},getAppVariantDescriptor:function(i){r=i;var D=g();if(D["sap.app"]&&D["sap.app"].id){return a.load({id:D["sap.app"].id});}return Promise.resolve(false);},_determineSelector:function(i,D){return i?r:{appId:D["sap.app"].id,appVersion:D["sap.app"].applicationVersion.version};},onSaveAs:function(i,j,k,l){var I;var n;var D=g();var p=true;if(l&&l["sap.app"].id===D["sap.app"].id){j=true;D=m({},l);l=null;}else if(l){p=false;D=m({},l);l=null;}var v=this._determineSelector(p,D);return new Promise(function(q){var P=function(){return c.processSaveAsDialog(D,i);};var u=function(K){B.show();return c.createAllInlineChanges(K,v);};var w=function(K){var M=K.slice();return A.addChangesToPersistence(M,v);};var x=function(){var K=A.getNewAppVariantId();return c.createAppVariant(K,v).catch(function(M){var N=M.messageKey;if(!N){N="MSG_SAVE_APP_VARIANT_FAILED";}return A.catchErrorDialog(M,N,K);});};var y=function(K){n=null;n=m({},K.response);return c.clearRTACommandStack(j);};var z=function(){var K=F.getUshellContainer();if(K&&j){K.setDirtyFlag(false);}};var E=function(K){z();I=A.isS4HanaCloud(K);var M=A.buildSuccessInfo(n.id,i,I);return c.showSuccessMessage(M);};var H=function(){var K=A.buildFinalSuccessInfoS4HANACloud();return c.showSuccessMessage(K);};var J=function(){B.show();if(I){var K;return f().then(function(){return t(n.id,n.reference);}).then(function(M){K=Object.assign({},M);B.hide();return d.call(this,i,null,k);}.bind(this)).then(function(){return e(K,n.id);}).then(function(){s();return H();}).then(function(){return i?q():d.call(this,i,I,k);}.bind(this));}B.hide();return d.call(this,i,I,k);};sap.ui.require(["sap/ui/rta/appVariant/AppVariantManager"],function(K){if(!c){c=new K({commandSerializer:C,layer:k});}return P().then(u).then(w).then(x).then(y).then(G).then(E).then(J.bind(this)).then(q).catch(function(M){if(!M){return false;}if(I){s();}return d.call(this,null,I,k).then(q);}.bind(this));}.bind(this));}.bind(this));},onDeleteFromOverviewDialog:function(i,j,k){var I;return new Promise(function(l){sap.ui.require(["sap/ui/rta/appVariant/AppVariantManager"],function(n){if(!c){c=new n({rootControl:r,commandSerializer:C,layer:k});}var D=function(){return c.deleteAppVariant(i).catch(function(E){if(E==='cancel'){return Promise.reject("cancel");}var M=E.messageKey;if(!M){M="MSG_DELETE_APP_VARIANT_FAILED";}return A.catchErrorDialog(E,M,i);});};var p=function(){A.closeOverviewDialog();var v=A.buildDeleteSuccessMessage(i,I);return c.showSuccessMessage(v);};var q=function(v){I=A.isS4HanaCloud(v);if(I){var w;return f(j).then(function(){return T(i);}).then(function(x){w=Object.assign({},x);return R.call(this,!j,k);}.bind(this)).then(function(){return h(w,i);});}B.show();return Promise.resolve();};var u=function(){if(I){s();}B.hide();return j?l():R.call(this,!I,I,k).then(l);};if(j){A.closeOverviewDialog();A.navigateToFLPHomepage();}return G().then(q.bind(this)).then(D).then(p).then(u.bind(this)).catch(function(E){if(E==='cancel'){return false;}if(I){s();}return R.call(this,null,I,k).then(l);}.bind(this));}.bind(this));}.bind(this));}};});
