/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(["sap/ui/dt/plugin/ElementMover","sap/ui/dt/OverlayUtil","sap/ui/dt/ElementUtil","sap/ui/rta/Utils","sap/ui/rta/command/CommandFactory","sap/ui/rta/plugin/Plugin","sap/ui/dt/OverlayRegistry"],function(E,O,a,U,C,P,b){"use strict";var R=E.extend("sap.ui.rta.plugin.RTAElementMover",{metadata:{library:"sap.ui.rta",properties:{commandFactory:{type:"any",defaultValue:C},movableTypes:{type:"string[]",defaultValue:["sap.ui.core.Element"]}},associations:{},events:{}}});R.prototype.init=function(){this.oBasePlugin=new P({commandFactory:this.getCommandFactory()});};R.prototype.exit=function(){this.oBasePlugin.destroy();};R.prototype.setCommandFactory=function(o){this.setProperty("commandFactory",o);this.oBasePlugin.setCommandFactory(o);};R.prototype.isEditable=function(o,d){var e=o.getElement();if(!this.isMovableType(e)){return Promise.resolve(false);}return this.checkMovable(o,d).then(function(m){o.setMovable(m);return m;});};function i(o,d){var D=o.getDesignTimeMetadata();var p=o.getParentElementOverlay();var n=D.markedAsNotAdaptable();if(!D||!p||n){return Promise.resolve(false);}var e=o.getElement();if(a.isElementDirectTemplateChild(e)){return Promise.resolve(false);}var r=o.getRelevantContainer();var f=b.getOverlay(r);if(!f){return Promise.resolve(false);}return this.isMoveAvailableOnRelevantContainer(o).then(function(v){if(v){v=this.oBasePlugin.hasStableId(o)&&this.oBasePlugin.hasStableId(p)&&this.oBasePlugin.hasStableId(f);}return v;}.bind(this)).then(function(v){if(v){return c.call(this,o,f,d);}return v;}.bind(this));}function c(o,r,d){var e=O.findAllUniqueAggregationOverlaysInContainer(o,r);var v=e.map(function(A){return this.checkTargetZone(A,o,d).then(function(V){return V?A:undefined;});}.bind(this));return Promise.all(v).then(function(V){V=V.filter(function(g){return!!g;});if(V.length<1){return false;}else if(V.length===1){var f=V[0].getChildren().filter(function(g){var h=g.getElement();return(h&&h.getVisible()&&h.getParent());});return f.length>1;}return true;});}E.prototype._getMoveAction=function(o){var p;var d=o.getParentAggregationOverlay();if(d){p=d.getDesignTimeMetadata();}return p?p.getAction("move",o.getElement()):undefined;};E.prototype.isMovableType=function(){return true;};R.prototype.checkMovable=function(o,d){return i.call(this,o,d);};R.prototype.checkTargetZone=function(A,o,d){var m=o||this.getMovedOverlay();return U.checkTargetZone(A,m,this.oBasePlugin,d);};R.prototype.isMoveAvailableOnRelevantContainer=function(o){var d;var m=this._getMoveAction(o);if(m&&m.changeType){d=o.getRelevantContainer();var r=b.getOverlay(d);if(!this.oBasePlugin.hasStableId(r)){return Promise.resolve(false);}return this.oBasePlugin.hasChangeHandler(m.changeType,d);}return Promise.resolve(false);};R.prototype.isMoveAvailableForChildren=function(o){var d=o.getDesignTimeMetadata();var A=d.getAggregationNamesWithAction("move");var e=[];A.forEach(function(f){var g=o.getAggregationOverlay(f);if(g){var h=g.getChildren();var j=h.map(this.checkMovable.bind(this));e=e.concat(j);}else{e.push(Promise.resolve(false));}}.bind(this));return Promise.all(e).then(function(m){return m.some(function(M){return M;});});};R.prototype.buildMoveCommand=function(){var m=this.getMovedOverlay();var p=m.getParentAggregationOverlay();var M=m.getElement();var s=this._getSource();var r=m.getRelevantContainer();var t=O.getParentInformation(m);var S=s.index;var T=t.index;var d=this._compareSourceAndTarget(s,t);if(d){return Promise.resolve();}delete s.index;delete t.index;var v=this.oBasePlugin.getVariantManagementReference(m);return this.getCommandFactory().getCommandFor(r,"Move",{movedElements:[{element:M,sourceIndex:S,targetIndex:T}],source:s,target:t},p.getDesignTimeMetadata(),v);};return R;});
