/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(["sap/ui/dt/OverlayRegistry","sap/ui/dt/ElementOverlay","sap/ui/dt/AggregationOverlay","sap/ui/dt/Util","sap/ui/fl/Utils","sap/ui/fl/write/api/ExtensionPointRegistryAPI","sap/base/util/deepEqual","sap/base/util/isEmptyObject","sap/base/util/merge","sap/base/util/restricted/_omit","sap/ui/core/mvc/View","sap/base/Log"],function(O,E,A,D,F,a,d,i,m,_,V,L){"use strict";function g(v,C){var e=a.getExtensionPointInfoByViewId({viewId:v});return _(e,C);}function c(o){return _(o,["bIsView"]);}return function(r,p){var o={};o.mExtensionPointMetadata={palette:{icons:{svg:"sap/ui/core/designtime/Icon.icon.svg"}}};o._aConsideredExtensionPoints=[];o._attachNotConsideredExtensionPoints=function(l,n){var v=F.getViewForControl(l.getElement()).getId();var q=g(v,this._aConsideredExtensionPoints);Object.keys(q).forEach(function(s,I){var t=q[s];var u=this._getExtensionPointData(t);u.id=v;n.elements.splice(I,0,u);this._aConsideredExtensionPoints.push(u.name);}.bind(this));};o._getOutline=function(I,l){var R;if(!l&&D.isInteger(I)){l=I;I=undefined;}var n=[];if(!I){n=r._oDesignTime.getRootElements().map(function(s){return O.getOverlay(s);});}else{var P=O.getOverlay(I);if(!P){throw D.createError("services.Outline#get","Cannot find element with id= "+I+". A valid or empty value for the initial element id should be provided.","sap.ui.rta");}n.push(P);}R=n.map(function(q){return this._getChildrenNodes(q,l);},this);this._aConsideredExtensionPoints=[];return R;};o._getExtensionPoints=function(l){var P=l.id;var s=l.technicalName;return a.getExtensionPointInfoByParentId({parentId:P}).filter(function(n){return n.aggregationName===s;});};o._getExtensionPointData=function(l){return{id:l.targetControl.getId(),name:l.name,technicalName:"sap.ui.extensionpoint",type:"extensionPoint",icon:this.mExtensionPointMetadata.palette.icons.svg,extensionPointInfo:{defaultContent:l.defaultContent.map(function(C){return C.getId();})}};};o._enrichExtensionPointData=function(l,n){var I=sap.ui.getCore().getConfiguration().getDesignMode();if(!I){return undefined;}if(l.type==="aggregation"){var q=this._getExtensionPoints(l).sort(function(s,t){return t.index-s.index;});q.forEach(function(s){var t=this._getExtensionPointData(s);l.elements.splice(s.index,0,t);this._aConsideredExtensionPoints.push(t.name);}.bind(this));}else if(l.bIsView){return this._attachNotConsideredExtensionPoints(n,l);}};function b(C,t,I){var s=C.getAggregationName&&C.getAggregationName();if(s){var l=C.getParent().getId();if(I[s]){return Object.assign({templateFor:l},I[s]);}return((t&&t.elements)||[]).map(function(u){if(u.type==="aggregationBindingTemplate"||u.parentAggregationName===s){return Object.assign({templateFor:l},u);}return u.technicalName===s&&u;}).filter(Boolean)[0];}var n=(C.getParentElementOverlay().getAggregationBindingTemplateOverlays&&C.getParentElementOverlay().getAggregationBindingTemplateOverlays().reduce(function(u,v){return u.concat(v.getChildren());},[]))||[];if(n.includes(C)){return undefined;}if(!t){return undefined;}var P=C.getParentElementOverlay();if(P.getId()===t.templateFor){return t;}var q=C.getParent().getChildren().indexOf(C);return t.elements[q];}o._getChildrenNodes=function(l,n,P,t){var v=D.isInteger(n);var q={};if(l.getShouldBeDestroyed()){return{};}var s=this._getNodeProperties(l,P,t)||{};var C=l.getChildren();var u=(l.getAggregationBindingTemplateOverlays&&l.getAggregationBindingTemplateOverlays())||[];if(u.length>0){C=u.reduce(function(w,x){var T=x.getChildren()[0];q[T.getId()]=x.getAggregationName();return[T].concat(w);},C);}if((!v||(v&&n>0))&&C.length>0&&!i(s)){n=v?n-1:n;var I={};s.elements=C.map(function(w){var N=b(w,t,I);var x=this._getChildrenNodes(w,n,w.getParent(),N);if(x.type==="aggregationBindingTemplate"){var y=q[w.getId()];I[y]=m({},x);}return x;},this).filter(function(w){return!i(w);});this._enrichExtensionPointData(s,l);}return c(s);};function e(l,P,s){var n=l.getParentElementOverlay();return n&&s&&n.getAggregationOverlay(s,"AggregationBindingTemplateOverlays")===P;}function f(l,n,q){var s={editable:l.getEditable(),bIsView:l.getElement()instanceof V};if(typeof l.isVisible()==="boolean"){s.visible=l.isVisible();}var P=l.getParent()&&l.getParentAggregationOverlay();var t=(P&&P.getAggregationName())||"";if(e(l,P,t)){s.type="aggregationBindingTemplate";s.icon="sap-icon://attachment-text-file";s.parentAggregationName=t;}else{s.type="element";}var u=q.getName(n);if(u&&u.singular){s.name=u&&u.singular;}return s;}function h(l,P,n){var s=l.getAggregationName();var q={technicalName:l.getAggregationName(),editable:false,type:"aggregation",bIsView:l.getElement()instanceof V};if(P.getAggregation(s)){var t=P.getDesignTimeMetadata().getAggregationDescription(s,n);if(t.singular){q.name=t.singular;}}if(P.getAggregationBindingTemplateOverlays().length){q.icon="sap-icon://card";}return q;}function j(l,n,t){var q={id:l.getId(),technicalName:l.getMetadata().getName(),editable:false,type:null};if(t){q.templateReference=t.id;}var s=k(n);if(s){q.icon=s;}var I=n.getLabel(l);if(I&&I!==q.id){q.instanceName=I;}return q;}function k(l){var n=l.getData();return n.palette&&n.palette.icons&&n.palette.icons.svg||undefined;}o._getNodeProperties=function(l,P,t){var n=l.getElement();var q=l.getDesignTimeMetadata();var s=j(n,q,t);if(l instanceof E){return Object.assign(s,f(l,n,q));}return Object.assign(s,h(l,P,n));};o._removeDuplicate=function(R,l){return R.filter(function(u){return!d(l,u,Infinity);});};o._updatesHandler=function(l){var P=l.getParameters();if(this.sStatus==="initial"){this.aUpdates=[];}var R=m({},P);var s=R.id?O.getOverlay(R.id).getElement().getId():undefined;var t=R.targetId?O.getOverlay(R.targetId).getElement().getId():undefined;switch(l.getId()){case"elementOverlayCreated":if(P.elementOverlay.isRoot()){var n=P.elementOverlay.getElement().getId();R.element=o._getOutline(n)[0];R.type="new";break;}return;case"elementOverlayAdded":R.element=o._getOutline(s)[0];R.targetId=t;R.type="new";break;case"elementOverlayMoved":R.element=o._getOutline(s,0)[0];R.targetId=t;R.type="move";break;case"elementOverlayDestroyed":var q=R.elementOverlay.getParentAggregationOverlay();if((q instanceof A&&!q._bIsBeingDestroyed)||R.elementOverlay.isRoot()){R.element={};R.element.id=R.elementOverlay.getElement()?R.elementOverlay.getElement().getId():R.elementOverlay.getAssociation("element");R.type="destroy";break;}return;case"elementOverlayEditableChanged":R.element={id:s,editable:R.editable};R.type="editableChange";break;case"elementPropertyChanged":R.element=o._getOutline(s,0)[0];R.type="elementPropertyChange";break;default:L.error("Event type is not 'expected' by handler");}R=_(R,["elementOverlay","editable","target","id","elementId"]);this.aUpdates=o._removeDuplicate(this.aUpdates,R);this.aUpdates.push(R);if(this.sStatus==="initial"){setTimeout(function(){if(Array.isArray(this.aUpdates)&&this.aUpdates.length>0){this.sStatus="initial";p("update",this.aUpdates);}}.bind(o),200);}this.sStatus="processing";};o.destroy=function(){r._oDesignTime.detachEvent("elementOverlayCreated",this._updatesHandler,this);r._oDesignTime.detachEvent("elementOverlayAdded",this._updatesHandler,this);r._oDesignTime.detachEvent("elementOverlayMoved",this._updatesHandler,this);r._oDesignTime.detachEvent("elementOverlayDestroyed",this._updatesHandler,this);r._oDesignTime.detachEvent("elementPropertyChanged",this._updatesHandler,this);r._oDesignTime.detachEvent("elementOverlayEditableChanged",this._updatesHandler,this);delete this.aUpdates;delete this.sStatus;};o.aUpdates=[];o.sStatus="initial";r._oDesignTime.attachEvent("elementOverlayCreated",o._updatesHandler,o);r._oDesignTime.attachEvent("elementOverlayAdded",o._updatesHandler,o);r._oDesignTime.attachEvent("elementOverlayMoved",o._updatesHandler,o);r._oDesignTime.attachEvent("elementOverlayDestroyed",o._updatesHandler,o);r._oDesignTime.attachEvent("elementPropertyChanged",o._updatesHandler,o);r._oDesignTime.attachEvent("elementOverlayEditableChanged",o._updatesHandler,o);return{events:["update"],exports:{get:o._getOutline.bind(o)},destroy:o.destroy.bind(o)};};});
