/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(["sap/base/util/isEmptyObject","sap/base/util/values","sap/ui/base/ManagedObject","sap/ui/dt/plugin/ContextMenu","sap/ui/dt/plugin/TabHandling","sap/ui/dt/plugin/ToolHooks","sap/ui/fl/Layer","sap/ui/fl/registry/Settings","sap/ui/rta/command/CommandFactory","sap/ui/rta/plugin/additionalElements/AdditionalElementsPlugin","sap/ui/rta/plugin/additionalElements/AddElementsDialog","sap/ui/rta/plugin/additionalElements/AdditionalElementsAnalyzer","sap/ui/rta/plugin/iframe/AddIFrame","sap/ui/rta/plugin/Combine","sap/ui/rta/plugin/CompVariant","sap/ui/rta/plugin/ControlVariant","sap/ui/rta/plugin/CreateContainer","sap/ui/rta/plugin/CutPaste","sap/ui/rta/plugin/DragDrop","sap/ui/rta/plugin/Remove","sap/ui/rta/plugin/Rename","sap/ui/rta/plugin/RTAElementMover","sap/ui/rta/plugin/Selection","sap/ui/rta/plugin/Settings","sap/ui/rta/plugin/Split","sap/ui/rta/plugin/Stretch","sap/ui/rta/plugin/LocalReset"],function(i,v,M,C,T,a,L,S,b,A,c,d,e,f,g,h,j,k,R,l,m,n,o,p,q,r,s){"use strict";var P=M.extend("sap.ui.rta.util.PluginManager",{metadata:{properties:{plugins:{type:"any",defaultValue:{}}}}});P.prototype.init=function(){this.iEditableOverlaysCount=0;};P.prototype.getEditableOverlaysCount=function(){return this.iEditableOverlaysCount;};P.prototype.getDefaultPlugins=function(F){if(!this._mDefaultPlugins){this._oCommandFactory=new b({flexSettings:F});this._mDefaultPlugins={};this._mDefaultPlugins["selection"]=new o({commandFactory:this._oCommandFactory,multiSelectionRequiredPlugins:[f.getMetadata().getName(),l.getMetadata().getName()],elementEditableChange:this.onElementEditableChange.bind(this)});this._oRTAElementMover=new n({commandFactory:this._oCommandFactory});this._mDefaultPlugins["dragDrop"]=new R({elementMover:this._oRTAElementMover,commandFactory:this._oCommandFactory,dragStarted:this.handleStopCutPaste.bind(this)});this._mDefaultPlugins["rename"]=new m({commandFactory:this._oCommandFactory,editable:this.handleStopCutPaste.bind(this)});this._mDefaultPlugins["additionalElements"]=new A({commandFactory:this._oCommandFactory});this._mDefaultPlugins["createContainer"]=new j({commandFactory:this._oCommandFactory});this._mDefaultPlugins["remove"]=new l({commandFactory:this._oCommandFactory});this._mDefaultPlugins["cutPaste"]=new k({elementMover:this._oRTAElementMover,commandFactory:this._oCommandFactory});this._mDefaultPlugins["settings"]=new p({commandFactory:this._oCommandFactory});this._mDefaultPlugins["combine"]=new f({commandFactory:this._oCommandFactory});this._mDefaultPlugins["split"]=new q({commandFactory:this._oCommandFactory});this._mDefaultPlugins["contextMenu"]=new C();this._mDefaultPlugins["tabHandling"]=new T();this._mDefaultPlugins["stretch"]=new r();var t=S.getInstanceOrUndef();if(t&&t.isVariantAdaptationEnabled()){this._mDefaultPlugins["compVariant"]=new g({commandFactory:this._oCommandFactory});}this._mDefaultPlugins["controlVariant"]=new h({commandFactory:this._oCommandFactory});this._mDefaultPlugins["addIFrame"]=new e({commandFactory:this._oCommandFactory});this._mDefaultPlugins["toolHooks"]=new a();if(F.layer===L.CUSTOMER&&t&&!t.isVersioningEnabled(F.layer)){this._mDefaultPlugins["localReset"]=new s({commandFactory:this._oCommandFactory});}}return Object.assign({},this._mDefaultPlugins);};P.prototype.preparePlugins=function(F,H,t){if(i(this.getPlugins())){this.setPlugins(this.getDefaultPlugins(F));}else{this._destroyDefaultPlugins(this.getPlugins());}Object.keys(this.getPlugins()).forEach(function(u){if(this.getPlugin(u).attachElementModified){this.getPlugin(u).attachElementModified(H);}}.bind(this));this.provideCommandStack("settings",t);};P.prototype.getPluginList=function(){return v(this.getPlugins());};P.prototype.getPlugin=function(t){return this.getPlugins()[t];};P.prototype.provideCommandStack=function(t,u){if(this.getPlugin(t)){this.getPlugin(t).setCommandStack(u);}};P.prototype.onElementEditableChange=function(E){var t=E.getParameter("editable");if(t){this.iEditableOverlaysCount+=1;}else{this.iEditableOverlaysCount-=1;}};P.prototype.handleStopCutPaste=function(){var t=this.getPlugin("cutPaste");if(t){t.stopCutAndPaste();}};P.prototype._destroyDefaultPlugins=function(t){for(var D in this._mDefaultPlugins){var u=this._mDefaultPlugins[D];if(u&&!u.bIsDestroyed){if(!t||t[D]!==u){u.destroy();}}}};return P;});
