/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(["sap/base/Log","sap/base/util/extend","sap/base/util/ObjectPath","sap/ui/VersionInfo","sap/ui/support/supportRules/RuleSet","sap/ui/support/supportRules/CommunicationBus","sap/ui/support/supportRules/WCBChannels","sap/ui/support/supportRules/RuleSerializer","sap/ui/support/supportRules/Constants","sap/ui/support/supportRules/util/EvalUtils","sap/ui/support/supportRules/util/Utils","sap/ui/thirdparty/jquery","sap/ui/thirdparty/URI"],function(L,b,O,V,R,C,c,d,f,E,U,q,g){"use strict";var h=(function(){var a;return function(u){if(!a){a=document.createElement('a');}a.href=u;return a.href.replace(/\/$/,'');};})();var s="sprt";var S=sap.ui.require.toUrl("sap/ui/support");var j=S.replace('/sap/ui/support','');var A=h(j);var l={};l._mRuleSets={};l.getRuleSets=function(){return this._mRuleSets;};l.addRuleSet=function(a,r){this._mRuleSets[a]=r;};l.getRuleSet=function(a){return this._mRuleSets[a];};l._fetchSupportRuleSets=function(r,m){var t=this,a=m||sap.ui.getCore().getLoadedLibraries(),o=this._fetchLibraryNamesWithSupportRules(a);var M=new Promise(function(e){V.load({library:"sap.ui.core"}).then(function(i){R.versionInfo=i;o.then(function(k){var n=t._fetchLibraryFiles(k,l._fetchRuleSet);Promise.all(n).then(function(){t._bRulesCreated=true;C.publish(c.UPDATE_SUPPORT_RULES,{sRuleSet:d.serialize(t._mRuleSets),oVersionInfo:R.versionInfo});e();if(r&&typeof r==="function"){r();}});});});});return M;};l.loadAdditionalRuleSets=function(a){var t=this,e=t._fetchLibraryFiles(a,t._fetchRuleSet);Promise.all(e).then(function(){t._bRulesCreated=true;C.publish(c.UPDATE_SUPPORT_RULES,{sRuleSet:d.serialize(t._mRuleSets)});});};l._fetchLibraryNamesWithSupportRules=function(o){return new Promise(function(m){U.canLoadInternalRulesAsync().then(function(a){var e={publicRules:[],internalRules:[],allRules:[]};o=o||{};var i=[];Object.keys(o).forEach(function(k){var M=new Promise(function(r){var n=A+"/"+k.replace(/\./g,'/')+"/.supportrc";q.ajax({type:"GET",dataType:"json",url:n,success:function(p){r({lib:k,rcData:p});},error:function(){r({lib:k,rcData:null});}});});i.push(M);});Promise.all(i).then(function(k){k.forEach(function(n){if(n.rcData){var H=false;if(n.rcData.publicRules){e.publicRules.push(n.lib);H=true;}if(a&&n.rcData.internalRules){e.internalRules.push(n.lib);H=true;}if(H&&e.allRules.indexOf(n.lib)<0){e.allRules.push(n.lib);}}m(e);});});});});};l._fetchLibraryFiles=function(a,p,e){var i=[],t=this,k=sap.ui.require.toUrl("sap/ui/support"),m=k.replace("sap/ui/support",""),n=U.canLoadInternalRules(),H=n&&a.internalRules.length>0,P=0,r=a.publicRules.length;var o=sap.ui.getCore().getConfiguration().getSupportMode();var u=o&&o.indexOf("silent")>-1;if(H){r+=a.internalRules.length;}function v(){P+=1;var w=Math.ceil((P/r)*100);C.publish(c.CURRENT_LOADING_PROGRESS,{value:w});}if(a.publicRules.length>0){a.publicRules.forEach(function(w){var x=t._registerLibraryPath(w,k,m);if(x){var y=t._requireRuleSet(x.customizableLibName,p);if(!u&&!e){y.then(function(){v();});}i.push(y);}});}if(n&&a.internalRules.length>0){a.internalRules.forEach(function(w){var x=t._registerLibraryPath(w,k,m);if(x){var y=t._requireRuleSet(x.internalLibName,p);if(!u&&!e){y.then(function(){v();});}i.push(y);}});}return i;};l._registerLibraryPath=function(a,e,i){if(this._mRuleSets[a]){return null;}var k=a.replace(/\./g,"/");var m=k;var n=this._getLoadFromSupportOrigin();var p={};if(n){m+='/'+s;p[m]=i+k;}var o=m+'/internal';var r=i.replace('resources/','')+'test-resources/'+k+'/internal';p[o]=r;sap.ui.loader.config({paths:p});return{internalLibName:o.replace(/\//g,"."),customizableLibName:m.replace(/\//g,".")};};l._requireRuleSet=function(a,p){var t=this;return new Promise(function(r){try{sap.ui.require([a.replace(/\./g,"/")+"/library.support"],function(){p.call(t,a);r();},r);}catch(e){r();}});};l._fetchRuleSet=function(a){try{var n,o,i,k=O.get(a).library.support;if(!k){throw"The library.support file was not fetched successfully.";}n=a.replace("."+s,"").replace(".internal","");o=b({},k);i=this._mRuleSets[n];if(!(o.ruleset instanceof R)){o=this._createRuleSet(o);}if(i){i.ruleset._mRules=b(i.ruleset._mRules,o.ruleset._mRules);}else{i=o;}this._mRuleSets[n]=i;}catch(e){L.error("["+f.SUPPORT_ASSISTANT_NAME+"] Failed to load RuleSet for "+a+" library",e);}};l._getLoadFromSupportOrigin=function(){var a=false;var e=new g(sap.ui.require.toUrl("sap/ui/core"));var i=new g(sap.ui.require.toUrl("sap/ui/support"));if(e.protocol()!==i.protocol()||e.host()!==i.host()){a=true;}return a;};l.fetchNonLoadedRuleSets=function(a){var n=[],o={};sap.ui.getVersionInfo().libraries.forEach(function(e){o[e.name]=e;});this._fetchLibraryNamesWithSupportRules(o).then(function(e){e.allRules.forEach(function(i){if(a.indexOf(i)<0){n.push(i);}});C.publish(c.POST_AVAILABLE_LIBRARIES,{libNames:n});});};l._onLibraryChanged=function(e){var t=this;if(e.getParameter("stereotype")==="library"&&l._bRulesCreated){t._oMainPromise=l._fetchSupportRuleSets();}};l.updateRuleSets=function(r){this._oMainPromise=l._fetchSupportRuleSets(r);};l._createRuleSet=function(o){var a={name:o.name,niceName:o.niceName};var r=new R(a);for(var i=0;i<o.ruleset.length;i++){var e=o.ruleset[i];if(Array.isArray(e)){for(var k=0;k<e.length;k++){r.addRule(e[k]);}}else{r.addRule(e);}}return{lib:a,ruleset:r};};l.getAllRules=function(){var r={};Object.keys(this._mRuleSets).map(function(a){r=b(r,this._mRuleSets[a].ruleset.getRules());},this);return r;};l.getAllRuleDescriptors=function(){var r=this.getAllRules();return Object.keys(r).map(function(a){return{libName:r[a].libName,ruleId:a};});};if(E.isEvalAllowed()){l.addRuleSet(f.TEMP_RULESETS_NAME,{lib:{name:f.TEMP_RULESETS_NAME},ruleset:new R({name:f.TEMP_RULESETS_NAME})});}return l;},true);
