/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['sap/ui/thirdparty/jquery','sap/base/Log','sap/base/security/encodeXML','sap/base/util/isEmptyObject','sap/base/util/isPlainObject','sap/ui/support/supportRules/report/Archiver','sap/ui/support/supportRules/report/IssueRenderer'],function(q,L,e,b,c,A,I){'use strict';var r=sap.ui.require.toUrl('sap/ui/support/supportRules/report/resources');var t={line:function(a,i,v,y,z){a.push("<tr><td ",i?"align='right' ":"","valign='top'>","<label class='sapUiSupportLabel'>",e(y||""),"</label></td><td",v?" class='sapUiSupportTechInfoBorder'":"",">");var B=z;if(typeof z==="function"){B=z(a);}a.push(e(B||""));a.push("</td></tr>");},multiline:function(a,y,z,B,C){var D=this;D.line(a,y,z,B,function(a){a.push("<table border='0' cellspacing='0' cellpadding='3'>");q.each(C,function(i,v){var E="";if(v){if(typeof(v)==="string"||typeof(v)==="string"||typeof(v)==="boolean"){E=v;}else if(Array.isArray(v)||c(v)){E=JSON.stringify(v);}}D.line(a,false,false,i,""+E);});a.push("</table>");});},subheader:function(a,i){a.push("<tr class='sapUiSupportTitle'><td valign='top' colspan='2'>","<label class='sapUiSupportLabel'>",e(i||""),"</label></td></tr>");}};function g(a){return q.ajax({type:'GET',url:r+"/"+a,dataType:'text'}).then(function(i){return i;});}function d(a){var y='';if(!a){return y;}try{a.modules.sort();var z=["<div class='sapUiSupportToolbar'>","<div><div class='sapUiSupportTechInfoCntnt'>","<table border='0' cellpadding='3'>"];t.subheader(z,"Support Assistant Information");t.line(z,true,true,"Location",a.supportAssistant.location);t.line(z,true,true,"Version",a.supportAssistant.versionAsString);t.subheader(z,"Application Information");t.line(z,true,true,"SAPUI5 Version",function(i){var v=a.sapUi5Version;if(v&&v.version){var V=v.version;var C=e(V.version||"");i.push(C," (built at ",e(V.buildTimestamp||""),", last change ",e(V.scmRevision||""),")");}else{i.push("not available");}});t.line(z,true,true,"Core Version",function(i){return a.version+" (built at "+a.build+", last change "+a.change+")";});t.line(z,true,true,"Loaded jQuery Version",function(i){return a.jquery;});t.line(z,true,true,"User Agent",function(i){return a.useragent+(a.docmode?", Document Mode '"+a.docmode+"'":"");});t.line(z,true,true,"Application",a.appurl);t.multiline(z,true,true,"Configuration (bootstrap)",a.bootconfig);t.multiline(z,true,true,"Configuration (computed)",a.config);if(!b(a.libraries)){t.multiline(z,true,true,"Libraries",a.libraries);}t.multiline(z,true,true,"Loaded Libraries",a.loadedLibraries);t.line(z,true,true,"Loaded Modules",function(C){q.each(a.modules,function(i,v){if(v.indexOf("sap.ui.core.support")<0){C.push("<span>",e(v||""),"</span>");if(i<a.modules.length-1){C.push(", ");}}});});t.multiline(z,true,true,"URI Parameters",a.uriparams);z.push("</table></div>");y=z.join('');}catch(B){L.warning('There was a problem extracting technical info.');}return y;}function f(v){var a='<td>';if(v){a+=e(v);}a+='</td>';return a;}function h(a){var v='';if(!a){return v;}v+='<table class="sapUiTable"><tr><th>Component ID</th><th>Type</th><th>Title</th><th>Subtitle</th><th>Application version</th><th>Description</th><th>BCP Component</th></tr>';try{for(var i=0;i<a.length;i++){var y=a[i];v+='<tr>';v+=f(y.id);v+=f(y.type);v+=f(y.title);v+=f(y.subTitle);if(y.applicationVersion){v+=f(y.applicationVersion.version);}else{v+='<td></td>';}v+=f(y.description);v+=f(y.ach);v+='</tr>';}v+='</table>';}catch(z){L.warning('There was a problem extracting app info.');v='';}return v;}function j(a){var i='';i+='<div><span class="sapUiSupportLabel">'+a.displayName+'</span>';i+='<span> ('+a.description+')</span></div>';return i;}function k(a,i){var v='';v+='<div><span class="sapUiSupportLabel">'+i.displayName+' with id:</span> '+a;v+='<span> ('+i.description+')</span></div>';return v;}function l(a,v){var y='';if(a.length>5){y+='<div class="expandable-control collapsed-content" data-expandableElement="execution-scope-components">';y+='<span class="expandable-title"><span class="sapUiSupportLabel">'+v.displayName+'</span>';y+='<span> ('+v.description+')</span></span></div>';}else{y+='<div><span class="sapUiSupportLabel">'+v.displayName+'</span>';y+='<span> ('+v.description+')</span></div>';}y+='<ol id="execution-scope-components" class="top-margin-xsmall">';for(var i=0;i<a.length;i++){y+='<li>'+a[i]+'</li>';}y+='</ol>';return y;}function m(a){var i='';try{var v=a.executionScope.getType();var y=a.scopeDisplaySettings.executionScopes[v];var z=a.scopeDisplaySettings.executionScopeTitle;i+='<div class="sapUiSupportLabel">'+z+': </div>';switch(v){case'global':i+=j(y);break;case'subtree':i+=k(a.executionScope._getContext().parentId,y);break;case'components':i+=l(a.executionScope._getContext().components,y);break;}}catch(B){L.warning('There was a problem extracting scope info.');i='';}return i;}function n(a){var i='';if(!a){return i;}try{var v=1;i+='<table class="sapUiTable"><tbody><tr><th>Name</th><th>Description</th><th>Categories</th><th>Audiences</th></tr></tbody>';for(var y in a){var z=a[y];var B='collapsed-content';if(v===1){B='expanded-content';}var C=a[y].selected?' ('+a[y].issueCount+' issues)':'';var D='<span class="'+(a[y].selected?'checked':'unchecked')+'"></span>';i+='<tbody><tr><td colspan="100" ';i+='class="expandable-control '+B+'" data-expandableElement="section-selected-rules-group'+v+'">'+D;i+='<span class="sapUiSupportLabel expandable-title">'+y+C+'</span>';i+='</td></tr></tbody>';var E='';for(var F in z){var G=z[F].selected?' ('+z[F].issueCount+' issues)':'';var H='<span class="'+(z[F].selected?'checked':'unchecked')+'"></span>';E+='<tr>';E+='<td>'+H+z[F].title+G+'</td>';E+='<td>'+z[F].description+'</td>';E+='<td>'+z[F].categories.join(', ')+'</td>';E+='<td>'+z[F].audiences.join(', ')+'</td>';E+='</tr>';}i+='<tbody id="section-selected-rules-group'+v+'">'+E+'</tbody>';v++;}i+='</table>';}catch(J){L.warning('There was a problem extracting selected rules info.');i='';}return i;}function o(i){return I.render(i,true);}function p(R){if(!R){return"none";}return"<strong>"+R.title+"/"+R.id+"</strong>";}function s(D,B){if(!B){B=r+"/";}return g("ReportTemplate.html").then(function(T){var C={baseUrl:B,technicalInfo:d(D.technical),issues:o(D.issues),appInfo:h(D.application),rules:n(D.rules),rulePreset:p(D.rulePreset),metadataTitle:D.name+' Analysis Results',metadataTitleTechnicalInfo:'Technical Information',metadataTitleIssues:'Issues',metadataTitleAppInfo:'Application Information',metadataTitleSelectedRules:'Available and (<span class="checked"></span>) Selected Rules',metadataTimestamp:new Date(),metadataScope:m(D.scope),metadataAnalysisDuration:D.analysisDuration,metadataAnalysisDurationTitle:D.analysisDurationTitle};return u(T,C);});}function u(T,C){var P,v;for(P in C){v=C[P];T=T.replace(new RegExp("\{\{"+P+"\}\}","ig"),v);}return T;}function w(D){var P=[this.getReportHtml(D,"./"),g("styles.css"),g("index.js"),g("images/checked.svg"),g("images/collapsed.svg"),g("images/expanded.svg"),g("images/unchecked.svg")];Promise.all(P).then(function(a){var i={'issues':D.issues},v={'appInfos':D.application},y={'technicalInfo':D.technical},z=new A();z.add('technicalInfo.json',y,'json');z.add('issues.json',i,'json');z.add('appInfos.json',v,'json');z.add('report.html',a[0]);z.add('abap.json',D.abap,'json');z.add('styles.css',a[1],'css');z.add('index.js',a[2],'js');z.add('images/checked.svg',a[3],'svg');z.add('images/collapsed.svg',a[4],'svg');z.add('images/expanded.svg',a[5],'svg');z.add('images/unchecked.svg',a[6],'svg');z.download("SupportAssistantReport");z.clear();});}function x(D){var i='';var a=q('<a class="sapUiHidden"></a>');a.on('click',function(){var v=window.open('','_blank');v.opener=null;q(v.document).ready(function(){v.document.documentElement.innerHTML='';v.document.write(i);});});q('body').append(a);this.getReportHtml(D).then(function(v){i=v;a[0].click();a.remove();});}return{getReportHtml:s,downloadReportZip:w,openReport:x};},true);
