/*!
 * OpenUI5
 * (c) Copyright 2009-2022 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(["sap/base/Log","sap/base/util/merge","sap/base/util/UriParameters","sap/ui/thirdparty/jquery","sap/ui/core/Core"],function(L,m,U,q){"use strict";var r=/\/\$batch($|\?)/,a=/(?:^|\r\n)Content-Id\s*:\s*(\S+)/i,b=/^(.*)?:\s*(.*)$/,j="application/json;charset=UTF-8;IEEE754Compatible=true",M={},s="\r\nContent-Type: application/http\r\n"+"Content-Transfer-Encoding: binary\r\n",c=/^Content-Type:\s*multipart\/mixed;\s*boundary=/i,u=U.fromQuery(window.location.search),A=u.get("autoRespondAfter"),R=u.get("realOData"),d=/^(\S+) (\S+)$/,e=/^(GET|DELETE|MERGE|PATCH|POST) (\S+) HTTP\/1\.1$/,D={},f=/^(OData-Version|DataServiceVersion)$/,g=R==="true"||R==="direct",h=0,S=u.get("supportAssistant")==="true",T;if(g){document.title=document.title+" (real OData)";}function k(o,E,P){var i=QUnit.objectType(o),l=QUnit.objectType(E),n;if(i==="string"&&l==="regexp"){if(!E.test(o)){throw new Error(P+": actual value "+o+" does not match expected regular expression "+E);}return;}if(i!==l){throw new Error(P+": actual type "+i+" does not match expected type "+l);}if(i==="array"){if(o.length<E.length){throw new Error(P+": array length: "+o.length+" < "+E.length);}}if(i==="array"||i==="object"){for(n in E){k(o[n],E[n],P==="/"?P+n:P+"/"+n);}}else if(o!==E){throw new Error(P+": actual value "+o+" does not match expected value "+E);}}function p(o,E,i,l){try{k(o,E,"/");QUnit.assert.pushResult({result:l,actual:o,expected:E,message:i});}catch(n){QUnit.assert.pushResult({result:!l,actual:o,expected:E,message:(i||"")+" failed because of "+n.message});}}T={awaitRendering:function(){if(sap.ui.getCore().getUIDirty()){return new Promise(function(i){function l(){if(sap.ui.getCore().getUIDirty()){setTimeout(l,1);}else{i();}}l();});}},checkError:function(i,E,C,l){i.strictEqual(E.constructor,C);i.strictEqual(E.message,l);i.strictEqual(E.name,C.name);},deepContains:function(o,E,i){p(o,E,i,true);},notDeepContains:function(o,E,i){p(o,E,i,false);},useFakeServer:function(o,B,F,i,l,n){var t,v;function w(X,Y){var Z=N(X,Y.requestBody),$=J(Y);h+=1;Y.respond(200,q.extend({},$,{"Content-Type":"multipart/mixed;boundary="+Z.boundary}),G(Z,$));}function x(X){var Y={buildResponse:X.buildResponse,code:X.code||200,headers:X.headers||{},ifMatch:X.ifMatch};if(X.source){Y.message=Q(B+X.source);Y.headers["Content-Type"]=Y.headers["Content-Type"]||z(X.source);}else if(typeof X.message==="object"){Y.headers["Content-Type"]=j;Y.message=JSON.stringify(X.message);}else{Y.message=X.message;}return Y;}function y(){var X,Y,Z={};for(Y in F){X=F[Y];if(!Y.includes(" ")){Y="GET "+Y;}if(Array.isArray(X)){Z[Y]=X.map(x);}else{Z[Y]=[x(X)];}}return Z;}function z(X){if(/\.xml$/.test(X)){return"application/xml";}if(/\.json$/.test(X)){return j;}return"application/x-octet-stream";}function C(X,Y,Z){L.error(Y.requestLine||Y.method+" "+Y.url,Z,"sap.ui.test.TestUtils");return{code:X,headers:{"Content-Type":"text/plain"},message:Z};}function E(X){return X.slice(0,X.indexOf("\r\n"));}function G(X,Y){var Z=[""];X.parts.every(function($){Z.push($.boundary?"\r\nContent-Type: multipart/mixed;boundary="+$.boundary+"\r\n\r\n"+G($,Y):H($,Y));return!$.code||$.code<400||Y.DataServiceVersion==="2.0";});Z.push("--\r\n");return Z.join("--"+X.boundary);}function H(X,Y){var Z=q.extend({},Y,X.headers);return s+(X.contentId?"Content-ID: "+X.contentId+"\r\n":"")+"\r\nHTTP/1.1 "+X.code+" \r\n"+Object.keys(Z).map(function($){return $+": "+Z[$];}).join("\r\n")+"\r\n\r\n"+(X.message||"")+"\r\n";}function I(X,Y){var Z,$,_=X+" "+Y;if(v[_]){return{responses:v[_]};}if(!t){return undefined;}Z=[];$=t.filter(function(a1){var b1=_.match(a1.regExp);if(b1){Z.push(b1);}return b1;});if($.length>1){L.warning("Multiple matches found for "+_,undefined,"sap.ui.test.TestUtils");return undefined;}return $.length?{responses:$[0].response,match:Z[0]}:undefined;}function J(X){var Y,Z={};for(Y in X.requestHeaders){if(f.test(Y)){Z[Y]=X.requestHeaders[Y];}}return Z;}function K(X,Y){var Z,$=I(X.method,X.url),_,a1=$&&$.responses;a1=(a1||[]).filter(function(_){if(typeof _.ifMatch==="function"){return _.ifMatch(X);}return!_.ifMatch||_.ifMatch.test(X.requestBody);});if(a1.length){_=a1[0];if(typeof _.buildResponse==="function"){_=m({},_);_.buildResponse($.match,_);}if($.responses.length>1){Z=$.responses.indexOf(_);}}else if(!n){switch(X.method){case"HEAD":_={code:200};break;case"DELETE":case"MERGE":case"PATCH":_={code:204};break;case"POST":_={code:200,headers:{"Content-Type":j},message:X.requestBody};break;}}if(_){L.info(X.method+" "+X.url+(Z!==undefined?", alternative (ifMatch) #"+Z:""),'{"If-Match":'+JSON.stringify(X.requestHeaders["If-Match"])+'}',"sap.ui.test.TestUtils");}else{_=C(404,X,"No mock data found");}_.headers=q.extend({},J(X),_.headers);if(Y&&_.code<300){_.contentId=Y;}return _;}function N(X,Y){var Z;Y=Y.replace(/^\s+/,"");Z=E(Y);return{boundary:E(Y).slice(2),parts:Y.split(Z).slice(1,-1).map(function($){var _,a1,b1,c1,d1,e1;$=$.slice(2);a1=E($);if(c.test(a1)){c1=N(X,$.slice(a1.length+4));_=c1.parts.filter(function(f1){return f1.code>=300;});return _.length?_[0]:c1;}e1=$.indexOf("\r\n\r\n")+4;d1=O(X,$.slice(e1));b1=a.exec($.slice(0,e1));return K(d1,b1&&b1[1]);})};}function O(X,Y){var Z=Y.indexOf("\r\n\r\n"),$,_,a1={requestHeaders:{}};a1.requestBody=Y.slice(Z+4,Y.length-2);Y=Y.slice(0,Z);$=Y.split("\r\n");a1.requestLine=$.shift();_=e.exec(a1.requestLine);if(_){a1.method=_[1];a1.url=X+_[2];$.forEach(function(b1){var _=b.exec(b1);if(_){a1.requestHeaders[_[1]]=_[2];}});}return a1;}function P(X){var Y=X.url;if(r.test(Y)){w(Y.slice(0,Y.indexOf("/$batch")+1),X);}else{V(X);}}function Q(X){var Y=M[X];if(!Y){q.ajax({async:false,url:X,dataType:"text",success:function(Z){Y=Z;}});if(!Y){throw new Error(X+": resource not found");}M[X]=Y;}return Y;}function V(X){var Y=K(X);h+=1;X.respond(Y.code,Y.headers,Y.message);}function W(){var X,Y;v=y();if(i){t=i.map(function(Z){return{regExp:Z.regExp,response:Array.isArray(Z.response)?Z.response.map(x):[x(Z.response)]};});}Y=sinon.fakeServer.create();o.add(Y);Y.autoRespond=true;if(A){Y.autoRespondAfter=parseInt(A);}Y.respondWith("GET",/./,V);Y.respondWith("DELETE",/./,V);Y.respondWith("HEAD",/./,V);Y.respondWith("PATCH",/./,V);Y.respondWith("MERGE",/./,V);Y.respondWith("POST",/./,P);X=Y.restore;Y.restore=function(){sinon.FakeXMLHttpRequest.filters=[];X.apply(this,arguments);};sinon.xhr.supportsCORS=q.support.cors;sinon.FakeXMLHttpRequest.useFilters=true;sinon.FakeXMLHttpRequest.addFilter(function(Z,$){var _=I(Z,$)||(l?$.startsWith(l)||r.test($):Z==="DELETE"||Z==="HEAD"||Z==="MERGE"||Z==="PATCH"||Z==="POST");return!_;});return Y;}B=sap.ui.require.toUrl(B).replace(/(^|\/)resources\/(~[-a-zA-Z0-9_.]*~\/)?/,"$1test-resources/")+"/";return W();},withNormalizedMessages:function(C){var o=sinon.sandbox.create();try{var l=sap.ui.getCore(),G=l.getLibraryResourceBundle;o.stub(l,"getLibraryResourceBundle").returns({getText:function(K,n){var t=K,v=G.call(l).getText(K),i;for(i=0;i<10;i+=1){if(v.indexOf("{"+i+"}")>=0){t+=" "+(i>=n.length?"{"+i+"}":n[i]);}}return t;}});C.apply(this);}finally{o.verifyAndRestore();}},isRealOData:function(){if(R==="proxy"){throw new Error("realOData=proxy is no longer supported");}return g;},isSupportAssistant:function(){return S;},getRealOData:function(){return R?"&realOData="+R:"";},getRequestCount:function(){return h;},proxy:function(i){L.warning("#proxy is no longer supported",null,"sap.ui.test.TestUtils");return i;},resetRequestCount:function(){h=0;},retrieveData:function(K){var v=D[K];delete D[K];return v;},setData:function(K,v){D[K]=v;},setupODataV4Server:function(o,F,i,l,n){var t={};if(this.isRealOData()){return;}if(!l){l="/";}else if(l.slice(-1)!=="/"){l+="/";}Object.keys(F).forEach(function(v){var w=d.exec(v),x,y;if(w){x=w[1]||"GET";y=w[2];}else{x="GET";y=v;}if(!y.startsWith("/")){y=l+y;}t[x+" "+y]=F[v];});T.useFakeServer(o,i||"sap/ui/core/qunit/odata/v4/data",t,n,l!=="/"?l:undefined);}};return T;},true);
