sap.ui.define(["sap/ui/webc/common/thirdparty/base/delegate/ItemNavigation","sap/ui/webc/common/thirdparty/base/renderer/LitRenderer","sap/ui/webc/common/thirdparty/base/Keys","sap/ui/webc/common/thirdparty/base/types/Integer","sap/ui/webc/common/thirdparty/base/i18nBundle","sap/ui/webc/common/thirdparty/base/delegate/ResizeHandler","sap/ui/webc/common/thirdparty/base/types/NavigationMode","sap/ui/webc/common/thirdparty/base/UI5Element","./types/BreadcrumbsDesign","./types/BreadcrumbsSeparatorStyle","./BreadcrumbsItem","./generated/i18n/i18n-defaults","./Link","./Label","./ResponsivePopover","./List","./StandardListItem","./Icon","./generated/templates/BreadcrumbsTemplate.lit","./generated/templates/BreadcrumbsPopoverTemplate.lit","./generated/themes/Breadcrumbs.css","./generated/themes/BreadcrumbsPopover.css"],function(e,t,i,s,r,o,n,a,l,d,h,c,p,u,m,_,g,b,f,w,v,L){"use strict";function y(e){return e&&typeof e==="object"&&"default"in e?e["default"]:e}var S=y(e);var A=y(t);var I=y(s);var R=y(o);var k=y(n);var P=y(a);const W={tag:"ui5-breadcrumbs",managedSlots:true,languageAware:true,slots:{default:{propertyName:"items",type:HTMLElement,invalidateOnChildChange:true}},properties:{design:{type:l,defaultValue:l.Standard},separatorStyle:{type:d,defaultValue:d.Slash},_overflowSize:{type:I,noAttribute:true,defaultValue:0}},events:{"item-click":{detail:{item:{type:HTMLElement}}}}};class E extends P{static get metadata(){return W}static get render(){return A}static get template(){return f}static get staticAreaTemplate(){return w}static get styles(){return v}static get staticAreaStyles(){return L}constructor(){super();this._initItemNavigation();this._onResizeHandler=this._updateOverflow.bind(this);this._breadcrumbItemWidths=new WeakMap;this._dropdownArrowLinkWidth=0;this._labelFocusAdaptor={id:`${this._id}-labelWrapper`,getlabelWrapper:this.getCurrentLocationLabelWrapper.bind(this),set _tabIndex(e){const t=this.getlabelWrapper();t&&t.setAttribute("tabindex",e)},get _tabIndex(){const e=this.getlabelWrapper();return e?e.getAttribute("tabindex"):undefined}}}onInvalidation(e){if(e.reason==="childchange"){const t=this.getSlottedNodes("items").indexOf(e.child),i=t<this._overflowSize;if(i){this._overflowSize=t}}}onBeforeRendering(){this._preprocessItems()}onAfterRendering(){this._cacheWidths();this._updateOverflow()}onEnterDOM(){R.register(this,this._onResizeHandler)}onExitDOM(){R.deregister(this,this._onResizeHandler)}_initItemNavigation(){if(!this._itemNavigation){this._itemNavigation=new S(this,{navigationMode:k.Horizontal,getItemsCallback:()=>this._getFocusableItems()})}}_getFocusableItems(){const e=this._links;if(!this._isOverflowEmpty){e.unshift(this._dropdownArrowLink)}if(this._endsWithCurrentLocationLabel){e.push(this._labelFocusAdaptor)}return e}_onfocusin(e){const t=e.target,i=this.getCurrentLocationLabelWrapper(),s=t===i?this._labelFocusAdaptor:t;this._itemNavigation.setCurrentItem(s)}_onkeydown(e){const t=this._isDropdownArrowFocused;if(i.isShow(e)&&t&&!this._isOverflowEmpty){e.preventDefault();this._toggleRespPopover();return}if(i.isSpace(e)&&t&&!this._isOverflowEmpty&&!this._isPickerOpen){e.preventDefault();return}if((i.isEnter(e)||i.isSpace(e))&&this._isCurrentLocationLabelFocused){this._onLabelPress()}}_onkeyup(e){if(this._isDropdownArrowFocused&&i.isSpace(e)&&!this._isOverflowEmpty&&!this._isPickerOpen){this._openRespPopover()}}_cacheWidths(){const e=this._breadcrumbItemWidths,t=this.getSlottedNodes("items"),i=this._currentLocationLabel;for(let i=this._overflowSize;i<t.length;i++){const s=t[i],r=this.shadowRoot.querySelector(`.ui5-breadcrumbs-link-wrapper #${s._id}-link`);e.set(s,this._getElementWidth(r)||0)}if(this._endsWithCurrentLocationLabel&&i){const s=t[t.length-1];e.set(s,this._getElementWidth(i))}if(!this._isOverflowEmpty){this._dropdownArrowLinkWidth=this._getElementWidth(this._dropdownArrowLink)}}_updateOverflow(){const e=this.getSlottedNodes("items"),t=this.shadowRoot.querySelector(".ui5-breadcrumbs-root").offsetWidth;let i=this._getTotalContentWidth(),s=0;if(i>t){i+=this._dropdownArrowLinkWidth}while(i>t&&s<this._maxAllowedOverflowSize){const t=e[s];let r=0;if(this._isItemVisible(t)){r=this._breadcrumbItemWidths.get(t)||0}i-=r;s++}this._overflowSize=s;if(this._isOverflowEmpty&&this._isPickerOpen){this.responsivePopover.close()}const r=this._getFocusableItems();if(!r.some(e=>e._tabIndex==="0")){this._itemNavigation.setCurrentItem(r[0])}}_getElementWidth(e){if(e){return Math.ceil(e.getBoundingClientRect().width)}}_getTotalContentWidth(){const e=this.getSlottedNodes("items"),t=this._breadcrumbItemWidths,i=e.reduce((e,i)=>e+t.get(i),0);return i}_onLinkPress(e){const t=e.target,i=this.getSlottedNodes("items"),s=i.find(e=>`${e._id}-link`===t.id);this.fireEvent("item-click",{item:s})}_onLabelPress(){const e=this.getSlottedNodes("items"),t=e[e.length-1];this.fireEvent("item-click",{item:t})}_onOverflowListItemSelect(e){const t=e.detail.item,i=this.getSlottedNodes("items"),s=i.find(e=>`${e._id}-li`===t.id);window.open(s.href,s.target||"_self","noopener,noreferrer");this.responsivePopover.close();this.fireEvent("item-click",{item:s})}async _respPopover(){const e=await this.getStaticAreaItemDomRef();return e.querySelector("[ui5-responsive-popover]")}async _toggleRespPopover(){this.responsivePopover=await this._respPopover();if(this._isPickerOpen){this._closeRespPopover()}else{this._openRespPopover()}}async _closeRespPopover(){this.responsivePopover&&this.responsivePopover.close()}async _openRespPopover(){this.responsivePopover=await this._respPopover();this.responsivePopover.showAt(this._dropdownArrowLink)}_isItemVisible(e){return!e.hidden&&this._hasVisibleContent(e)}_hasVisibleContent(e){return e.innerText||Array.from(e.children).some(e=>!e.hidden)}_preprocessItems(){this.items.forEach(e=>{e._getRealDomRef=()=>this.getDomRef().querySelector(`[data-ui5-stable*=${e.stableDomRef}]`)})}getCurrentLocationLabelWrapper(){return this.shadowRoot.querySelector(".ui5-breadcrumbs-current-location > span")}get _endsWithCurrentLocationLabel(){return this.design===l.Standard}get _currentLocationText(){const e=this.getSlottedNodes("items");if(this._endsWithCurrentLocationLabel&&e.length>1){const t=e[e.length-1];if(this._isItemVisible(t)){return t.innerText}}return""}get _currentLocationLabel(){return this.shadowRoot.querySelector(".ui5-breadcrumbs-current-location ui5-label")}get _isDropdownArrowFocused(){return this._dropdownArrowLink._tabIndex==="0"}get _isCurrentLocationLabelFocused(){const e=this.getCurrentLocationLabelWrapper();return e&&e.tabIndex===0}get _maxAllowedOverflowSize(){const e=this.getSlottedNodes("items").filter(e=>this._isItemVisible(e));return e.length-1}get _dropdownArrowLink(){return this.shadowRoot.querySelector(".ui5-breadcrumbs-dropdown-arrow-link-wrapper ui5-link")}get _overflowItemsData(){return this.getSlottedNodes("items").slice(0,this._overflowSize).filter(e=>this._isItemVisible(e)).reverse()}get _linksData(){const e=this.getSlottedNodes("items").slice(this._overflowSize);if(this._endsWithCurrentLocationLabel){e.pop()}return e.filter(e=>this._isItemVisible(e))}get _links(){return Array.from(this.shadowRoot.querySelectorAll(".ui5-breadcrumbs-link-wrapper ui5-link"))}get _isOverflowEmpty(){return this._overflowItemsData.length===0}get _ariaHasPopup(){if(!this._isOverflowEmpty){return"listbox"}return undefined}get _isPickerOpen(){return!!this.responsivePopover&&this.responsivePopover.opened}get _accessibleNameText(){return E.i18nBundle.getText(c.BREADCRUMBS_ARIA_LABEL)}get _dropdownArrowAccessibleNameText(){return E.i18nBundle.getText(c.BREADCRUMBS_OVERFLOW_ARIA_LABEL)}get _cancelButtonText(){return E.i18nBundle.getText(c.BREADCRUMBS_CANCEL_BUTTON)}static get dependencies(){return[h,p,u,m,_,g,b]}static async onDefine(){E.i18nBundle=await r.getI18nBundle("@ui5/webcomponents")}}E.define();return E});