sap.ui.define(["sap/ui/webc/common/thirdparty/base/types/Float","sap/ui/webc/common/thirdparty/base/i18nBundle","sap/ui/webc/common/thirdparty/base/Keys","./SliderBase","./generated/templates/RangeSliderTemplate.lit","./generated/i18n/i18n-defaults"],function(t,e,s,i,a,n){"use strict";function l(t){return t&&typeof t==="object"&&"default"in t?t["default"]:t}var r=l(t);const u={tag:"ui5-range-slider",languageAware:true,managedSlots:true,properties:{startValue:{type:r,defaultValue:0},endValue:{type:r,defaultValue:100}}};class o extends i{static get metadata(){return u}static get template(){return a}static get VALUES(){return{start:"startValue",end:"endValue"}}constructor(){super();this._stateStorage.startValue=null;this._stateStorage.endValue=null}get tooltipStartValue(){const t=this.constructor._getDecimalPrecisionOfNumber(this._effectiveStep);return this.startValue.toFixed(t)}get tooltipEndValue(){const t=this.constructor._getDecimalPrecisionOfNumber(this._effectiveStep);return this.endValue.toFixed(t)}get _ariaDisabled(){return this.disabled||undefined}get _ariaLabelledByText(){return o.i18nBundle.getText(n.RANGE_SLIDER_ARIA_DESCRIPTION)}get _ariaHandlesText(){const t=this.effectiveDir==="rtl";const e=this._areValuesReversed();const s={};if(t&&!e||!t&&e){s.startHandleText=o.i18nBundle.getText(n.RANGE_SLIDER_END_HANDLE_DESCRIPTION);s.endHandleText=o.i18nBundle.getText(n.RANGE_SLIDER_START_HANDLE_DESCRIPTION)}else{s.startHandleText=o.i18nBundle.getText(n.RANGE_SLIDER_START_HANDLE_DESCRIPTION);s.endHandleText=o.i18nBundle.getText(n.RANGE_SLIDER_END_HANDLE_DESCRIPTION)}return s}onBeforeRendering(){if(!this.isCurrentStateOutdated()){return}this.notResized=true;this.syncUIAndState("startValue","endValue");this._updateHandlesAndRange(null)}_onfocusin(t){if(!this._getInitialValue("endValue")){this._setInitialValue("startValue",this.startValue);this._setInitialValue("endValue",this.endValue)}if(this.showTooltip){this._tooltipVisibility=i.TOOLTIP_VISIBILITY.VISIBLE}}_onfocusout(t){if(this._isFocusing()){this._preventFocusOut();return}this._setAffectedValue(null);this._setInitialValue("startValue",null);this._setInitialValue("endValue",null);if(this.showTooltip){this._tooltipVisibility=i.TOOLTIP_VISIBILITY.HIDDEN}}_onkeyup(t){super._onkeyup(t);this._swapValues();this._setAffectedValue(null)}_handleActionKeyPress(t){if(s.isEscape(t)){this.update(null,this._getInitialValue("startValue"),this._getInitialValue("endValue"));return}this._setAffectedValueByFocusedElement();const e=this._effectiveMin;const i=this._effectiveMax;const a=this._valueAffected;if((s.isEnd(t)||s.isHome(t))&&!a){this._homeEndForSelectedRange(t,s.isHome(t)?"startValue":"endValue",e,i);return}const n=this._handleActionKeyPressBase(t,a);if(!n){return}if(a&&!this._isPressInCurrentRange){const t=this.constructor.clipValue(n+this[a],e,i);this.update(a,t,null)}else if(n<0&&this.startValue>e||n>0&&this.endValue<i){const t=this.constructor.clipValue(n+this.startValue,e,i);const s=this.constructor.clipValue(n+this.endValue,e,i);this.update(a,t,s)}}_setAffectedValueByFocusedElement(){if(this.shadowRoot.activeElement===this._startHandle){this._setAffectedValue(o.VALUES.start)}if(this.shadowRoot.activeElement===this._endHandle){this._setAffectedValue(o.VALUES.end)}if(this.shadowRoot.activeElement===this._progressBar){this._setAffectedValue(null)}this._setIsPressInCurrentRange(!this._valueAffected)}_homeEndForSelectedRange(t,e,s,i){const a=this._handleActionKeyPressBase(t,e);const n=this.constructor.clipValue(a+this.startValue,s,i);const l=this.constructor.clipValue(a+this.endValue,s,i);this.update(null,n,l)}update(t,e,s){if(!t){this.updateValue("startValue",e);this.updateValue("endValue",s);this._updateHandlesAndRange(null)}else{const s=e;this._updateHandlesAndRange(s);this.updateValue(t,s)}}_onmousedown(t){if(this.disabled||this._effectiveStep===0){return}const e=this.handleDownBase(t);this._saveInteractionStartData(t,e);if(this._isPressInCurrentRange||this._handeIsPressed){this._handeIsPressed=false;return}this.update(this._valueAffected,e,null)}_saveInteractionStartData(t,e){const s=this.shadowRoot.querySelector(".ui5-slider-progress").getBoundingClientRect();this._startValueAtBeginningOfAction=this.startValue;this._endValueAtBeginningOfAction=this.endValue;this._initialPageXPosition=this.constructor.getPageXValueFromEvent(t);this._pressTargetAndAffectedValue(this._initialPageXPosition,e);this._initialStartHandlePageX=this.directionStart==="left"?s.left:s.right}_handleMove(t){t.preventDefault();if(this.disabled||this._effectiveStep===0){return}if(!this._isPressInCurrentRange){this._updateValueOnHandleDrag(t);return}this._updateValueOnRangeDrag(t)}_updateValueOnHandleDrag(t){const e=this.constructor.getValueFromInteraction(t,this._effectiveStep,this._effectiveMin,this._effectiveMax,this.getBoundingClientRect(),this.directionStart);this.update(this._valueAffected,e,null)}_updateValueOnRangeDrag(t){const e=this.constructor.getPageXValueFromEvent(t);const s=this._calculateRangeOffset(e,this._initialStartHandlePageX);this._setAffectedValue(null);this.update(null,s[0],s[1])}_handleUp(){if(this.startValue!==this._startValueAtBeginningOfAction||this.endValue!==this._endValueAtBeginningOfAction){this.fireEvent("change")}this._swapValues();this._setAffectedValueByFocusedElement();this._setAffectedValue(null);this._startValueAtBeginningOfAction=null;this._endValueAtBeginningOfAction=null;this._setIsPressInCurrentRange(false);this.handleUpBase()}_pressTargetAndAffectedValue(t,e){const s=this.shadowRoot.querySelector(".ui5-slider-handle--start");const i=this.shadowRoot.querySelector(".ui5-slider-handle--end");const a=s.getBoundingClientRect();const n=i.getBoundingClientRect();const l=t>=a.left&&t<=a.right;const r=t>=n.left&&t<=n.right;if(r||l){this._handeIsPressed=true}if(r||e>this.endValue){this._setAffectedValue(o.VALUES.end)}if(l||e<this.startValue){this._setAffectedValue(o.VALUES.start)}const u=e>=this._startValueAtBeginningOfAction&&e<=this._endValueAtBeginningOfAction;this._setIsPressInCurrentRange(!(this._valueAffected||this._handeIsPressed)?u:false)}_setAffectedValue(t){this._valueAffected=t;if(this._areValuesReversed()){this._setValuesAreReversed()}}_setIsPressInCurrentRange(t){this._isPressInCurrentRange=t}focusInnerElement(){const t=this._areValuesReversed();const e=this._valueAffected;if(this._isPressInCurrentRange||!e){this._progressBar.focus()}if(e===o.VALUES.start&&!t||e===o.VALUES.end&&t){this._startHandle.focus()}if(e===o.VALUES.end&&!t||e===o.VALUES.start&&t){this._endHandle.focus()}}_calculateRangeOffset(t,e){if(this._initialPageXPosition===t){return[this.startValue,this.endValue]}const s=this._effectiveMin;const i=this._effectiveMax;const a=this.endValue-this.startValue;let n=this._calculateStartValueByOffset(t,e);n=this.constructor.clipValue(n,s,i-a);return[n,n+a]}_calculateStartValueByOffset(t,e){const s=this._effectiveMin;const i=this._effectiveMax;const a=this._effectiveStep;const n=this.getBoundingClientRect();let l;let r;let u;if(t>this._initialPageXPosition){u=t-this._initialPageXPosition;r=e+u;l=this.constructor.computedValueFromPageX(r,s,i,n,this.directionStart);l=this.constructor.getSteppedValue(l,a,s)}else{u=this._initialPageXPosition-t;r=e-u;l=this.constructor.computedValueFromPageX(r,s,i,n,this.directionStart);l=this.constructor.getSteppedValue(l,a,s)}return l}_updateHandlesAndRange(t){const e=this._effectiveMax;const s=this._effectiveMin;const i=this.getStoredPropertyState("startValue");const a=this.getStoredPropertyState("endValue");const n=this._valueAffected;if(n===o.VALUES.start){this._selectedRange=(a-t)/(e-s);this._firstHandlePositionFromStart=(t-s)/(e-s)*100}else if(n===o.VALUES.end){this._selectedRange=(t-i)/(e-s);this._secondHandlePositionFromStart=(t-s)/(e-s)*100}else{this._selectedRange=(this.endValue-this.startValue)/(e-s);this._firstHandlePositionFromStart=(this.startValue-s)/(e-s)*100;this._secondHandlePositionFromStart=(this.endValue-s)/(e-s)*100}}_swapValues(){const t=this._valueAffected;if(t===o.VALUES.start&&this.startValue>this.endValue){const t=this.endValue;this.endValue=this.startValue;this.startValue=t;this._setValuesAreReversed();this.focusInnerElement()}if(t===o.VALUES.end&&this.endValue<this.startValue){const t=this.startValue;this.startValue=this.endValue;this.endValue=t;this._setValuesAreReversed();this.focusInnerElement()}}_setValuesAreReversed(){this._reversedValues=!this._reversedValues}_areValuesReversed(){return this._reversedValues}get _startHandle(){return this.shadowRoot.querySelector(".ui5-slider-handle--start")}get _endHandle(){return this.shadowRoot.querySelector(".ui5-slider-handle--end")}get _progressBar(){return this.shadowRoot.querySelector(".ui5-slider-progress")}get styles(){return{progress:{width:`${this._selectedRange*100}%`,"transform-origin":`${this.directionStart} top`,[this.directionStart]:`${this._firstHandlePositionFromStart}%`},startHandle:{[this.directionStart]:`${this._firstHandlePositionFromStart}%`},endHandle:{[this.directionStart]:`${this._secondHandlePositionFromStart}%`},tickmarks:{background:`${this._tickmarks}`},label:{width:`${this._labelWidth}%`},labelContainer:{width:`100%`,[this.directionStart]:`-${this._labelWidth/2}%`},tooltip:{visibility:`${this._tooltipVisibility}`}}}static async onDefine(){o.i18nBundle=await e.getI18nBundle("@ui5/webcomponents")}}o.define();return o});